<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ArturMarcos
 * Date: 11/05/17
 * Time: 17:34
 * To change this template use File | Settings | File Templates.
 */

namespace HCM\FPA\Calculos\Apolo;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\FPA\Calculos\Geral\Inicializa;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;

class PreparaFilaApolo extends \Zeedhi\Queue\Producer{

    private $hcmParameters;
    private $_nrOrgPadrao;
    private $_nrOrgTrabalho;
    private $_nrEstruturaTrab;
    private $_nrTipoModalidadeCalculo;
    private $_nrOcorrenciaCalculo;
    private $_mesCompetencia;
    private $_nrTipoCalculo;
    private $_simulacao;
    private $_retrocesso;
    private $_parcial;
    private $_dtPagamento;
    private $_dt_inicio;
    private $_dt_fim;
    private $_dsInicio;
    private $_dsFim;
    private $_id_fazDifComp;
    private $_dsOrdem;
    private $_calculo_folha;
    private $_tp_calc_mov;
    private $_vinculom;
    private $_tpVinculoProcesso;
    private $_tpRescisaoDireito;
    private $_dependencia;
    private $_formulario;
    private $_tp_processamento;
    private $_cdOperador;
    private $_nrFormulario;
    private $return;
    private $horaDisparo;

    protected static $queueName = "/queue/";

// apollo port browser = 61680
    const LIMIT_LOTE_FOUR = 8;
    const LIMIT_LOTE_ONE = 1;

    public function __construct($entityManager, $hcmParameters, $dataSet){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        
        $paramsApolo = FPA::getParamsApolo();
        
        $url = $paramsApolo['URL'];
        $port = $paramsApolo['PORT'];
        $user = $paramsApolo['USER'];
        $password = $paramsApolo['PASSWORD'];
        $broke = $paramsApolo['BROKE'];
        
        $queueConnection = new \Zeedhi\Queue\Connection($url, $port, $user, $password, $broke);
        
        parent::__construct($queueConnection);
        $this->dataSet = $dataSet;
        $this->_nrTipoCalculo = $dataSet['TP_CALCULO'];
        $this->_nrOrgTrabalho = $this->hcmParameters->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrOrgPadrao();
        $this->_nrEstruturaTrab = FPA::getEstruturaTrabalho();
        $this->_mesCompetencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
        $this->_mesCompetencia = DateUtil::truncateData($this->_mesCompetencia);
        $this->_nrTipoModalidadeCalculo = $this->hcmParameters->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalculo = $this->hcmParameters->getNrOcorrenciaCalculo();
        $this->_cdOperador = $this->hcmParameters->getCdoperador();
        $this->_retrocesso = false;
        $this->_parcial = false;
        $this->_nrFormulario = $dataSet['NRFORMCALCULO'];
        /* Tipo processamento */
        $tp_processamento = strtoupper($dataSet['TP_PROCESSAMENTO']);
        $this->_tp_processamento = $tp_processamento;
        $this->_buscaDadosFormulario($dataSet);
        $this->return = array();
        Inicializa::Container($entityManager, $hcmParameters, $this->_dtPagamento);

        $this->_vinculom = TkDI::getContainer()->vinculom;
    }

    public function preparaFilaApolo(){
        
        //Retorna Vinculos
        $vinculos = $this->_vinculom->retornaVinculosPorTipoCalculo($this->_nrTipoCalculo,$this->_nrOrgTrabalho, $this->_mesCompetencia, $this->_dsInicio, $this->_dsFim,
            $this->_dt_inicio, $this->_dt_fim, $this->_dsOrdem, $this->_nrEstruturaTrab, null, false, "N", $this->_tp_processamento);
        
        if($this->dataSet['TP_PROCESSAMENTO'] == 'CALCULO_APOLO_GRAVAR_NP'){
            $this->dataSet['NP'] = true;
            $this->dataSet['TP_PROCESSAMENTO'] = 'CALCULO_APOLO_GRAVAR';
            $this->_tp_processamento = 'CALCULO_APOLO_GRAVAR';
        }
        
        $nrvinculos = array();
        if(count($vinculos) < 1){
            $this->return['MSG'] = 'Nenhum vinculo encontrado';
            return $this->return;
        }
        
        $countA = 0;
        $countB = 0;
        
        //Contabilizacao separar por gerencial e garantir que todos os vinculos das gerenciais estejam dentro do mesmo escopo.
        if($this->_nrTipoCalculo == FpatipocalculoEntity::CALC_CONTABILIZACAO){
            
            foreach ($vinculos as $key => $vinculo) {
                $nrvinculosGerencial[$vinculo->historico->getNrestrutgeren()][$vinculo->getNrvinculom()] = $vinculo->getNmvinculom();
            }
            
            foreach ($nrvinculosGerencial as $key => $geren) {
                if($countB > 300){
                   $countA++;
                   $countB = 0; 
                }
                if($nrvinculos[$countA] == null){
                    $nrvinculos[$countA] = [];
                }
                $nrvinculos[$countA] +=  $geren;
                $countB += count($geren);
            }
        }else{
            foreach ($vinculos as $key => $vinculo) {
                if($countB > 300){
                   $countA++;
                   $countB = 0; 
                }
                $nrvinculos[$countA][$vinculo->getNrvinculom()] = $vinculo->getNmvinculom();
                $countB++;
            }
        }
        
        $nrcalculoconsumer = $this->entityManager->getRepository(Repositories::FPA_CALCULOCONSUMER)->insereCalculoConsumer($this->_nrOrgTrabalho, count($vinculos), $this->hcmParameters);
        
        foreach ($nrvinculos as $key => $vinculosD) {
            
            $nrcalculoFolha =  $this->hcmParameters->determinaNrCalculoFolha($this->_nrTipoCalculo);
        
            // cria registro no calculoconsumer
            $operador = $this->entityManager->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $this->_cdOperador));
            $paramsHcmParametros = $this->setParametrosHcm();
            
            $calculoParams = array(
                "NRCALCULOCONSUMER"  => $nrcalculoconsumer,
                "CDOPERADOR"         => $this->_cdOperador,
                "DSEMAILOPER"        => $operador->getDsemailoper(),
                "DTMESCOMPETENCIA"   => $this->_mesCompetencia->format('d/m/Y'),
                "NRORG"              => $this->_nrOrgTrabalho,
                "DATASET"            => $this->dataSet,
                "VINCULOS"           => $vinculosD,
                "PARAMSHCM"          => $paramsHcmParametros  
            );
            
            $this->sendCalculo($calculoParams, $key);
            
            if($key < 4){
                sleep(50);
            }
        }
        $this->return['MSG'] = 'Atenção! Através desta opção, o processo de gravação será realizado em segundo plano. Em breve, a notificação de finalização do processo chegará em seu e-mail.';
        return $this->return;
    }
    
    public function setParametrosHcm(){
        return array(
            "cdoperador"        => $this->hcmParameters->getCdoperador(),
            "nmoperador"        => $this->hcmParameters->getNmoperador(),
            "nrestruttrab"      => $this->hcmParameters->getEstruturaTrabalho(),
            "nrorgpadrao"       => strval($this->hcmParameters->getNrorgpadrao()),
            "nrorg"             => strval($this->hcmParameters->getNrorg()),
            "nrorgtrab"         => strval($this->hcmParameters->getNrorgTrabalho()),
            "dtmescompetenc"    => $this->hcmParameters->getDtCompetencia(),
            "dtmescompetencdiacorrente" => $this->hcmParameters->getPrimeiroDiaDoMes(),
            "nrtipoestrutlegal" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
            "nrtipoestrutgeren" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "idambientesal"     => $this->hcmParameters->getIdambientesal(),
            "nrocorrecal"       => $this->hcmParameters->getOcorrenciaCalculo(),
            "nrtpmodalidcal"    => $this->hcmParameters->getNrModalidadeCalculo(),
            "nrtpmodalidsal"    => $this->hcmParameters->getNrModalidadeSalario(),
            "dataatual"         => DateUtil::getDataAtual(),
            "dtultimodiames"    => $this->hcmParameters->getUltimoDiaMes(),
            "dtultimodiacompetencia" => $this->hcmParameters->getDtmescomptencDiaCorrente(),
        );
    }
    
    private function _buscaDadosFormulario($dataSet){

        switch ($this->_nrTipoCalculo) {
            case FpatipocalculoEntity::CALC_FERIAS :
                $this->_buscaDadosFormularioFerias($dataSet);
                break;

            case FpatipocalculoEntity::CALC_RESCISAO :
                $this->_buscaDadosFormularioRescisao($dataSet);
                break;

            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR :
                $this->_buscaDadosFormularioRescocomplementar($dataSet);
                break;

            case FpatipocalculoEntity::CALC_CONTABILIZACAO :
                $this->_buscaDadosFormularioContabilizacao($dataSet);
                break;
            default:
                $this->_buscaDadosFormularioCalculo($dataSet);
                break;
        }
    }

    private function _buscaDadosFormularioContabilizacao($dataSet){
        $this->_formulario = $dataSet;
        $this->_dsOrdem = $dataSet['DSORDEM'];
        $this->_dsInicio = $dataSet['DSINICIO'];
        $this->_dsFim = $dataSet['DSFIM'];
        $this->_nr_tipo_hierarquia = $dataSet['NRHIERARQORG'];
        $this->_tipo_movimento = $dataSet['NRTIPOMOVIMENT'];
        $this->_nrOcorrenciaCalc = $dataSet['NROCORRECAL'];
        $this->_idFormaContab = $dataSet['IDFORMACONTAB'];
    }

    private function _buscaDadosFormularioCalculo($dataSet){
        $this->_dsOrdem = trim($dataSet['DSORDEM']);
        $this->_dsInicio = is_string($dataSet['DSINICIO']) ? trim($dataSet['DSINICIO']) : $dataSet['DSINICIO'];
        $this->_dsFim = $dataSet['DSFIM'];
        $this->_dtPagamento = $dataSet['DTPAGAMENTO'];
    }

    private function _buscaDadosFormularioFerias($dataSet){
        $this->_dsOrdem = trim($dataSet['DSORDEM']);
        $this->_dsInicio = is_string($dataSet['DSINICIO']) ? trim($dataSet['DSINICIO']) : $dataSet['DSINICIO'];
        $this->_dsFim = $dataSet['DSFIM'];
        $this->_dtPagamento = $dataSet['DTPAGAMENTO'];
        $this->_dt_inicio = DateUtil::getDataDeString(substr($dataSet['DTINIGOZOINI'],0, 10));
        $this->_dt_fim = DateUtil::getDataDeString(substr($dataSet['DTINIGOZOFIM'], 0, 10));
        $this->_dias_abono = DateUtil::getDataDeString($dataSet['QTDIASABONOFERI']);
        $this->nrFerias = $dataSet['NRFERIAS'];
    }

    private function _buscaDadosFormularioRescisao($dataSet){
        $this->_dsOrdem = trim($dataSet['DSORDEM']);
        $this->_dsInicio = is_string($dataSet['DSINICIO']) ? trim($dataSet['DSINICIO']) : $dataSet['DSINICIO'];
        $this->_dsFim = $dataSet['DSFIM'];
        $this->_dtPagamento = $dataSet['DTPAGAMENTO'];
        $this->_dt_inicio = DateUtil::getDataDeString(substr($dataSet['DTRESCISAOINI'],0, 10));
        $this->_dt_fim = DateUtil::getDataDeString(substr($dataSet['DTRESCISAOFIM'], 0, 10));
    }

    private function _buscaDadosFormularioRescocomplementar($dataSet){
        $this->_dsOrdem = trim($dataSet['DSORDEM']);
        $this->_dsInicio = is_string($dataSet['DSINICIO']) ? trim($dataSet['DSINICIO']) : $dataSet['DSINICIO'];
        $this->_dsFim = $dataSet['DSFIM'];
        $this->_dtPagamento = $dataSet['DTPAGAMENTO'];
        $this->_dt_inicio = DateUtil::getDataDeString(substr($dataSet['DTRESCISAOINI'],0, 10));
        $this->_dt_fim = DateUtil::getDataDeString(substr($dataSet['DTRESCISAOFIM'], 0, 10));
        $this->_id_fazDifComp = $dataSet['IDFAZDIFCOMP'];
    }

    public function sendCalculo($calculoParams, $key)
    {
        $dtatual = DateUtil::getDataAtual();
        $horaDisparo = $dtatual->format('H:i:s');
        $this->horaDisparo = str_replace(':','',$horaDisparo).$key;
        self::$queueName = "/queue/".'hcm_calculo_'.$this->_nrOrgTrabalho.$this->horaDisparo;
        
        $count    = 0;
        $vinculos = array();
        $params   = $calculoParams;

        $qtVinculos = count($calculoParams["VINCULOS"]);
        
        /*if($this->_nrTipoCalculo === FpatipocalculoEntity::CALC_CONTABILIZACAO || $this->_nrTipoCalculo === FpatipocalculoEntity::CALC_FECHAMENTO || $qtVinculos < 50){
            $limiteLote = $qtVinculos / self::LIMIT_LOTE_ONE;
        }else{
            $limiteLote = $qtVinculos / self::LIMIT_LOTE_FOUR;
        }*/
        
        $limiteLote = $qtVinculos / self::LIMIT_LOTE_ONE;
        //Inicializa Consumidores e aguarda 20 segundos para os mesmos estarem em execução.
        $this->inicializaConsumidorJenkins($calculoParams, $qtVinculos);
        sleep(10);
        
        if ($qtVinculos > $limiteLote) {
            foreach ($calculoParams["VINCULOS"] as $key => $vinculo) {
                if ($count < $limiteLote) {
                    $vinculos[$key] = $vinculo;
                    $count++;
                } else {
                    $params["VINCULOS"] = $vinculos;
                    $message = json_encode(array(
                            'CALCULO_PARAMS' => array(
                                $params
                            )
                        )
                    );

                    $this->send($message);
                    $vinculos = array();
                    $vinculos[$key] = $vinculo; // o vinculo que faz entrar no 'else' não é contemplado no array, então zeramos adicionando ele para o próximo
                    $count = 1; // como adicionamos o vínculo acima, o contador deve iniciar com zero.
                }
            }
        } else {
            $vinculos = $calculoParams["VINCULOS"];
        }

        if (count($vinculos) > 0) {
            $params["VINCULOS"] = $vinculos;
            $message = json_encode(array(
                    'CALCULO_PARAMS' => array(
                        $params
                    )
                )
            );
            $this->send($message);
        }
    }

    private function inicializaConsumidorJenkins($calculoParams, $qtVinculos) {
        /*if($this->_nrTipoCalculo === FpatipocalculoEntity::CALC_CONTABILIZACAO || $qtVinculos < 16 || (!empty($this->dataSet['NP']) && $qtVinculos < 200)){
            $url = $this->hcmParameters->getUrlJenkinsMobileOneConsumer($this->horaDisparo);
        }else{
            $url = $this->hcmParameters->getUrlJenkinsMobileCalculoConsumer($this->horaDisparo);
        }*/
        
        $url = $this->hcmParameters->getUrlJenkinsMobileOneConsumer($this->horaDisparo);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_exec($ch);
        $requestInfo = curl_getinfo($ch);
        if ($requestInfo['http_code'] !== 201) {
            throw new \Exception('Não foi possível inicializar o consumidor via Jenkis, favor verificar, código: '.$requestInfo['http_code']);
        }
    }
}