<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\Util\TkEntity;
use HCM\Util\DateUtil;

class FpaincideventoEntity extends TkEntity
{
    private $_incidencias = array();
    private $_incidenciasDissidio = array();
    
    public function __construct($entityManager, $hcmParameters) {
         
        $this->hcmParameters = $hcmParameters;
        $this->nrorg = $this->hcmParameters->getNrorgTrabalho();
        $this->nrorgPadrao = $this->hcmParameters->getNrorgPadrao();
        parent::__construct(null, $entityManager);
    }

    public function inicializaLista($data_competencia) {
        $incidencias = $this->entityManager->getRepository(Repositories::FPA_INCIDEVENTO)->retornaIncidencias($this->nrorg, $data_competencia, $this->nrorgPadrao);
        foreach ($incidencias as $incidencia) {
            $idIncidevento = $incidencia->getIdincidevento();
            $this->_incidencias[$incidencia->getNrtipoincide()][$incidencia->getNreventom()][$incidencia->getNrorg()] = $idIncidevento;
        }
    }
    
    public function inicializaListaDissidio($data_competencia) {
        $incidencias = $this->entityManager->getRepository(Repositories::FPA_INCIDEVENTO)->retornaListaDissidio($this->nrorg, $data_competencia, $this->nrorgPadrao);
        foreach ($incidencias as $incidencia) {
            $idIncidevento = $incidencia->getIdincidevento();
            $this->_incidenciasDissidio[$incidencia->getNrtipoincide()][$incidencia->getNreventom()][$incidencia->getNrorg()] = $idIncidevento;
        }
    }
    
    public function incide($tipo_incidencia, $nr_evento, $data_competencia){

        if (empty($this->_incidencias) === true) {
            self::inicializaLista($data_competencia);
        }

        if (array_key_exists($tipo_incidencia, $this->_incidencias) === true) {
            if (array_key_exists($nr_evento, $this->_incidencias[$tipo_incidencia]) === true) {
                return $this->_incidencias[$tipo_incidencia][$nr_evento];
            } else {
                return false;
            }
        } else {
            return false;
        }

    }

    public function getEventos($mesCompentencia, $tipoIncidencia){
        $nrEventos = array();

        if (empty($this->_incidencias) === true) {
            self::inicializaLista($mesCompentencia);
        }

        if (array_key_exists($tipoIncidencia, $this->_incidencias) === true) {
            foreach($this->_incidencias[$tipoIncidencia] as $nrEvento =>$incideEvento){
                $nrEventos[] = $nrEvento;
            }
        }
        
        return $nrEventos;
    }

    public function getEventosIncDissidio($mesCompentencia, $tipoIncidencia){
        $nrEventos = array();
        $dataMesCompetencia = DateUtil::getDataDeString($mesCompentencia, DateUtil::FORMATO_DATA, true);
        self::inicializaListaDissidio($mesCompentencia);
       
        if (array_key_exists($tipoIncidencia, $this->_incidenciasDissidio) === true) {
            foreach($this->_incidenciasDissidio[$tipoIncidencia] as $nrEvento =>$incideEvento){
                $nrEventos[] = $nrEvento;
            }
        }
        return $nrEventos;
    }

}

