<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomFeriasRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function getRelatCustomFerias($parameters, $filters, $ocorCalc, $nrTpModalidCalc, $ignoraocorrecal, $idferiascalc, $orderByArray = []) {
        Util::getValueInFilterDataSourceByName($filters, array('NRVINCULOM'), true);
        $conditions = Util::createQueryFiltered($filters);
        $orderByClause = Util::buildOrderByClauseByOrderByCondition($orderByArray);
        
        $joinHierarquia = $selectHierarquia1 = $selectHierarquia2 = null;
      if(array_key_exists('NRTIPOHIERARQORG', $parameters) && isset($parameters['NRTIPOHIERARQORG']) && !empty($parameters['NRTIPOHIERARQORG']) ) {
          $tipohierarquia = $parameters['NRTIPOHIERARQORG'];
          
          $joinHierarquia = " LEFT JOIN HIERARQUIAORG
                                 ON HIERARQUIAORG.NRESTRUTURAMREL = VINCULOH.NRESTRUTGEREN
                                 AND HIERARQUIAORG.NRORG          = GPE_VINCULOM.NRORG 
                                 AND HIERARQUIAORG.NRTIPOHIERARQORG = $tipohierarquia 
                               
                               LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
                                      ON VINCULOH.NRORG                 = ESTRUTSUPERIORM.NRORG
                                     AND HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM
                               
                               LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
                                      ON ESTRUTSUPERIORM.NRORG           = ESTRUTSUPERIORH.NRORG
                                     AND ESTRUTSUPERIORM.NRESTRUTURAM   = ESTRUTSUPERIORH.NRESTRUTURAM
                                     AND ESTRUTSUPERIORH.DTMESCOMPETENC = (SELECT MAX(ESTRUTURAH4.DTMESCOMPETENC)
                                                                             FROM ESTRUTURAH ESTRUTURAH4
                                                                            WHERE ESTRUTURAH4.NRORG         = ESTRUTSUPERIORH.NRORG
                                                                              AND ESTRUTURAH4.NRESTRUTURAM    = ESTRUTSUPERIORH.NRESTRUTURAM
                                                                              AND ESTRUTURAH4.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
                                ";
           
          $selectHierarquia = "HIERARQUIAORG.NRTIPOHIERARQORG AS TIPOHIERARQORG,
                               ESTRUTSUPERIORM.NRESTRUTURAM   AS NRESTRUTSUPERIOR,
                               ESTRUTSUPERIORH.NMESTRUTURAH   AS NMESTRUTSUPERIOR, ";  
                               
      }else{
          $joinHierarquia =  " ";

          $selectHierarquia = "NULL AS TIPOHIERARQORG,
                               NULL AS NRESTRUTSUPERIOR,
                               NULL AS NMESTRUTSUPERIOR, ";     
      }
    
      if(array_key_exists('NRTPMODALIDCAL', $parameters)){
          $tipomodalidade = $parameters['NRTPMODALIDCAL'];
          $tipomodalidade = "AND CF.NRTPMODALIDCAL = '$tipomodalidade' ";
      }else {
          $tipomodalidade = "";
      }
      if(array_key_exists('NROCORRECAL', $parameters)){
          $nrocorrecalc = $parameters['NROCORRECAL'];
          $nrocorrecalc = "AND CF.NROCORRECAL = $nrocorrecalc";
      }else {
          $nrocorrecalc = "";
      }

      if(array_key_exists('NRESTRUTLEGAL', $parameters)) {
          /*$listEstrutLegal = array_map(function($estrutlegal) {
              return $estrutlegal;
          },
          $parameters['NRESTRUTLEGAL']);*/
          $condEstrutLegal = "AND VINCULOH.NRESTRUTLEGAL IN (" . implode(",",$parameters['NRESTRUTLEGAL']) . ")";
      } else {
        $condEstrutLegal = "";
      }
      
      if(array_key_exists('NRVINCULOM', $parameters)) {
          /*$listVinculo = array_map(function($vinculo) {
              return $vinculo;
          },
          $parameters['NRVINCULOM']);*/
          $condVinculo = " AND GPE_VINCULOM.NRVINCULOM IN (" . str_replace("%", "",$parameters['NRVINCULOM']) . ") ";
      } else {
        $condVinculo = "";
      }

      if(array_key_exists('NRESTRUTGEREN', $parameters)) {
          /*$listEstrutGeren = array_map(function($estrutgeren) {
              return $estrutgeren;
          },
          $parameters['NRESTRUTGEREN']);*/
          $condEstrutGeren = "AND VINCULOH.NRESTRUTGEREN IN (" . implode(",",$parameters['NRESTRUTGEREN']) . ")";
      } else {
        $condEstrutGeren = "";
      }

      /*
      if(array_key_exists('DTADMISSAOVINC', $parameters)) {
          $condDtAdmissao = " AND DTADMISSAOVINC BETWEEN TO_DATE('". $parameters["DTADMISSAOVINC"][0] . "', 'dd/mm/YYYY') 
          AND TO_DATE('". $parameters["DTADMISSAOVINC"][1] . "', 'dd/mm/YYYY') " ;
      } else {
          $condDtAdmissao = "";
      }

      if(array_key_exists('DTINIGOZOFERIAS', $parameters)) {
          $condDtIniGozoFerias = " AND DTINIGOZOFERIAS BETWEEN TO_DATE('". $parameters["DTINIGOZOFERIAS"][0] . "', 'dd/mm/YYYY') 
          AND TO_DATE('". $parameters["DTINIGOZOFERIAS"][1] . "', 'dd/mm/YYYY') ";
      } else {
          $condDtIniGozoFerias = "";
      }

      if(array_key_exists('DATALIMFERIAS', $parameters)) {
          $condDatalimferias = " AND DATALIMFERIAS BETWEEN TO_DATE('". $parameters["DATALIMFERIAS"][0] . "', 'dd/mm/YYYY') 
          AND TO_DATE('". $parameters["DATALIMFERIAS"][1] . "', 'dd/mm/YYYY') ";
      } else {
          $condDatalimferias = "";
      }
      */
      
      if($idferiascalc == 'S'){
         $joinidferiascalc = " INNER JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = GPE_VINCULOM.NRORG
                             AND CF.NRTIPOMOVIMENT = 2
							 AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                             AND CF.NROCORRECAL IN (1,2,3)                            
                             --AND CF.DTOCORRENCIA   = TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY')
                             AND CF.DTOCORRENCIA BETWEEN ADD_MONTHS(TRUNC(FPA_GOZOFERIAS.DTINIGOZOFERIAS, 'MM'), -1) AND FPA_GOZOFERIAS.DTINIGOZOFERIAS 
                             
                             INNER JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG           = CF.NRORG
                              AND ICF.NRVINCULOM      = GPE_VINCULOM.NRVINCULOM
                              AND ICF.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
                              AND (FPA_GOZOFERIAS.NRGOZOFERIAS = ICF.NRGOZOFERIAS OR ICF.NRGOZOFERIAS IS NULL)
                              --AND ICF.NREVENTOM IN ( 3030, 3040, 210, 212, 220, 222, 230, 232, 240, 242, 1140, 1145, 1340 ) /* LÃ­quido | FÃ©rias | 1/3FÃ©rias | INSS | IRRF */
                              
                              ";
          
      }else{
         $joinidferiascalc = " LEFT JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = GPE_VINCULOM.NRORG
                             AND CF.NRTIPOMOVIMENT = 2
							 AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                             AND (CF.NROCORRECAL = :P_NROCORRECAL OR :P_IGNORA_OCOR_CALC = 'S')                            
                             --AND CF.DTOCORRENCIA   = TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY')
                             AND CF.DTOCORRENCIA BETWEEN ADD_MONTHS(TRUNC(FPA_GOZOFERIAS.DTINIGOZOFERIAS, 'MM'), -1) AND FPA_GOZOFERIAS.DTINIGOZOFERIAS 
                             
                             LEFT JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG           = CF.NRORG
                              AND ICF.NRVINCULOM      = GPE_VINCULOM.NRVINCULOM
                              AND ICF.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
                              AND (FPA_GOZOFERIAS.NRGOZOFERIAS = ICF.NRGOZOFERIAS OR ICF.NRGOZOFERIAS IS NULL)
                              --AND ICF.NREVENTOM IN ( 3030, 3040, 210, 212, 220, 222, 230, 232, 240, 242, 1140, 1145, 1340 ) /* LÃ­quido | FÃ©rias | 1/3FÃ©rias | INSS | IRRF */
                             ";
      }
      
      if(array_key_exists('QTDEDIASRESTANTE', $parameters)) {
          $condDtreflimite = "TO_DATE('".$parameters['QTDEDIASRESTANTE']."', 'DD/MM/YYYY')";
      } else {
          $condDtreflimite = "LAST_DAY(TO_DATE('".$parameters['P_DTMESCOMPETENC']."', 'DD/MM/YYYY'))";
      }
      
      $sql = "
SELECT
  CDMATRICULA,
  CDMATRICULAESOCIAL,
  NRESTRUTLEGAL,
  NMESTRUTLEGAL,
  NRESTRUTGEREN,
  NMESTRUTGEREN,
  NRESTRUTSIND,
  DTBASEFERIAS,
  NROCUPACAOM,
  NMOCUPACAOH,
  NRESCALATRABM,
  NMESCALATRABH,
  QTHRESCALATRABH,
  QTHRSEMESCTRABH,
  NMESTRUTSIND,
  TIPOHIERARQORG,
  NRESTRUTSUPERIOR,
  NMESTRUTSUPERIOR,
  NRVINCULOM,
  NMVINCULOM,
  NRTIPOVINCULOM,
  NMTIPOVINCULOH,
  DTADMISSAOVINC,
  NRCPFPESSOA,
  DTNASCPESSOA,
  IDADE,
  CDINTESTRUTEXP,
  CDBANCO,
  NMBANCO,
  CDAGENCIA,
  CDCONTCORR,
  NRFERIAS,
  NRTIPOFERIAS,
  NMTIPOFERIASH,
  DTINIAQUISICAO,
  DTFIMAQUISICAO,
  QTMESAFASTAMENT,
  QTFALTASPERIODO,
  QTDIASMAXFE,
  QTDIASMAXABON,
  IDCONTROLFERIAS,
  QTDIAAFASTAMENT,
  NRGOZOFERIAS,
  DTINIGOZOFERIAS,
  DTFIMGOZOFERIAS,
  QTDIAGOZOFERIAS,
  QTDEDIASRESTANTE,
  QTDIASABONOFERI,
  DTRETORNOFERIAS,
  IDADIANT13SALAR,
  DATALIMFERIAS,
  SUM(CASE WHEN NREVENTOM IN ( 3030, 3040 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS VRLIQUIDO,
  SUM(CASE WHEN NREVENTOM IN ( 210, 212, 220, 222 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS VRFERIAS,
  SUM(CASE WHEN NREVENTOM IN ( 230, 232, 240, 242 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS VRTERCOFERIAS,
  SUM(CASE WHEN NREVENTOM IN ( 1140, 1145 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS VRINSS,
  SUM(CASE WHEN NREVENTOM IN ( 1340 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS VRIRRF,
  SUM(CASE WHEN NREVENTOM IN ( 1510 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS SUBTOTAL,
  SUM(CASE WHEN NREVENTOM IN ( 1520 ) THEN NVL(VREVENTOFOLHA, 0) ELSE 0 END) AS SUBTOTAL2A,
  MIN(DTPAGAMENTO) AS DTPAGAMENTO,
  DSGOZOFERIAS,
  NROCORRECAL,
  NRTPMODALIDCAL
FROM (
SELECT
  REPLACE( TRANSLATE (GPE_VINCULOM.CDMATRICULA, '~!@#$%^&*_-+=|\(){}[]:;<>,.?/' , ' ' ), ' ', '' ) CDMATRICULA,
  VINCULOH.CDMATRICULAESOCIAL,
  VINCULOH.NRESTRUTLEGAL,
  ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,
  VINCULOH.NRESTRUTGEREN,
  ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,
  VINCULOH.NRESTRUTSIND,
  VINCULOH.DTBASEFERIAS,
  VINCULOH.NRCARGO AS NROCUPACAOM,
  GPE_OCUPACAOH.NMOCUPACAOH AS NMOCUPACAOH,
  VINCULOH.NRESCALATRABM,
  GPE_ESCALATRABH.NMESCALATRABH AS NMESCALATRABH,
  GPE_ESCALATRABH.QTHRESCALATRABH,
  GPE_ESCALATRABH.QTHRSEMESCTRABH,
  ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,
$selectHierarquia
  GPE_VINCULOM.NRVINCULOM,
  GPE_VINCULOM.NMVINCULOM AS NMVINCULOM,
  GPE_VINCULOM.NRTIPOVINCULOM,
  GPE_TIPOVINCULOH.NMTIPOVINCULOH,
  GPE_VINCULOM.DTADMISSAOVINC,
  GPE_PESSOAH.NRCPFPESSOA,
  GPE_PESSOAH.DTNASCPESSOA,
  TRUNC(( LAST_DAY(TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY')) - GPE_PESSOAH.DTNASCPESSOA ) / 365.242199) IDADE,
  ESTRUTGERENCM.CDINTESTRUTEXP,
  BANCO.CDBANCO,
  BANCO.NMBANCO AS NMBANCO,
  CONTCORRPARC.CDAGENCIA,
  CONTCORRPARC.CDCONTCORR,
  FPA_FERIAS2.NRFERIAS,
  FPA_FERIAS2.NRTIPOFERIAS,
  FPA_TIPOFERIASH.NMTIPOFERIASH,
  FPA_FERIAS2.DTINIAQUISICAO,
  FPA_FERIAS2.DTFIMAQUISICAO,
  FPA_FERIAS2.QTMESAFASTAMENT,
  FPA_FERIAS2.QTFALTASPERIODO,
  FPA_FERIAS2.QTDIASMAXFE,
  FPA_FERIAS2.QTDIASMAXABON,
  FPA_FERIAS2.IDCONTROLFERIAS,
  FPA_FERIAS2.QTDIAAFASTAMENT,
  FPA_GOZOFERIAS.NRGOZOFERIAS,
  FPA_GOZOFERIAS.DTINIGOZOFERIAS,
  FPA_GOZOFERIAS.DTFIMGOZOFERIAS,
  NVL((FPA_GOZOFERIAS.DTFIMGOZOFERIAS - FPA_GOZOFERIAS.DTINIGOZOFERIAS) + 1, 0) QTDIAGOZOFERIAS,

  (SELECT
   (CASE
      WHEN (FPA_FERIAS2.DTFIMAQUISICAO > TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
		  THEN
			ROUND(FLOOR(MONTHS_BETWEEN($condDtreflimite, FPA_FERIAS2.DTINIAQUISICAO))*
			(CASE FPA_FERIAS2.NRTIPOFERIAS
				WHEN 1 THEN 2.5
				WHEN 2 THEN 2.5
				WHEN 3 THEN 1.5
				WHEN 4 THEN 1.3333333333333
				WHEN 5 THEN 1.1666666666667
				WHEN 6 THEN 1
				WHEN 7 THEN 0.8333333333333
				WHEN 8 THEN 0.6666666666666
				ELSE 2.5
			END))
		  ELSE NVL(FPA_FERIAS2.QTDIASMAXFE, T.QTDIASMAXFE)
   END
   - NVL(SUM((G.DTFIMGOZOFERIAS - G.DTINIGOZOFERIAS) + 1 + NVL(G.QTDIASABONOFERI, 0)),0))
     FROM FPA_TIPOFERIASH T
     LEFT JOIN FPA_GOZOFERIAS G  ON G.NRORG = GPE_VINCULOM.NRORG
								AND G.NRFERIAS = FPA_FERIAS2.NRFERIAS
    WHERE (T.NRORG = 0 OR T.NRORG = FPA_FERIAS2.NRORG)
	  AND T.NRTIPOFERIAS = FPA_FERIAS2.NRTIPOFERIAS
    GROUP BY T.QTDIASMAXFE) QTDEDIASRESTANTE,
  FPA_GOZOFERIAS.QTDIASABONOFERI,
  FPA_GOZOFERIAS.DTRETORNOFERIAS,
  FPA_GOZOFERIAS.IDADIANT13SALAR,
  TO_DATE(TO_CHAR(ADD_MONTHS(FPA_FERIAS2.DTINIAQUISICAO, 23), 'DD/MM/YYYY'), 'DD/MM/YYYY') AS DATALIMFERIAS,
  ICF.NREVENTOM,
  ICF.VREVENTOFOLHA,
  /*ICF.DTOCORRENCIA AS DTPAGAMENTO,*/
  CASE WHEN NREVENTOM IN ( 3030, 3040 ) THEN ICF.DTOCORRENCIA ELSE NULL END AS DTPAGAMENTO,
  FPA_GOZOFERIAS.DSGOZOFERIAS,
  CF.NROCORRECAL,
  CF.NRTPMODALIDCAL
FROM GPE_VINCULOM
JOIN GPE_VINCULOH VINCULOH ON GPE_VINCULOM.NRORG      = VINCULOH.NRORG
                          AND ( GPE_VINCULOM.DTRESCISAOVINC >= :P_COMPETENCIA/*:P_COMPETENCIA*/ OR GPE_VINCULOM.DTRESCISAOVINC IS NULL )
                          AND GPE_VINCULOM.NRVINCULOM = VINCULOH.NRVINCULOM
                          AND VINCULOH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                          WHERE NRORG = VINCULOH.NRORG
                                                            AND NRVINCULOM = VINCULOH.NRVINCULOM
                                                            AND DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY' ) )
LEFT JOIN FPA_FERIAS FPA_FERIAS2 ON GPE_VINCULOM.NRORG      = FPA_FERIAS2.NRORG
                                AND GPE_VINCULOM.NRVINCULOM = FPA_FERIAS2.NRVINCULOM
LEFT JOIN FPA_TIPOFERIASH ON FPA_TIPOFERIASH.NRTIPOFERIAS  = FPA_FERIAS2.NRTIPOFERIAS
                         AND FPA_TIPOFERIASH.DTMESCOMPETENC = (SELECT MAX(TFH.DTMESCOMPETENC)
                                                                 FROM FPA_TIPOFERIASH TFH
                                                                WHERE TFH.NRTIPOFERIAS = FPA_TIPOFERIASH.NRTIPOFERIAS
                                                                  AND TFH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY' ))
LEFT JOIN GPE_OCUPACAOH ON GPE_OCUPACAOH.NROCUPACAOM    = VINCULOH.NRCARGO
                       AND GPE_OCUPACAOH.NRORG          = VINCULOH.NRORG
                       AND GPE_OCUPACAOH.DTMESCOMPETENC = ( SELECT MAX(H.DTMESCOMPETENC) FROM GPE_OCUPACAOH H
                                                            WHERE H.NRORG = GPE_OCUPACAOH.NRORG
                                                              AND H.NROCUPACAOM = GPE_OCUPACAOH.NROCUPACAOM
                                                              AND H.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY') )
LEFT JOIN GPE_ESCALATRABH ON GPE_ESCALATRABH.NRESCALATRABM  = VINCULOH.NRESCALATRABM
                         AND GPE_ESCALATRABH.NRORG          = VINCULOH.NRORG
                         AND GPE_ESCALATRABH.DTMESCOMPETENC = ( SELECT MAX(H.DTMESCOMPETENC) FROM GPE_ESCALATRABH H
                                                                 WHERE H.NRORG = GPE_ESCALATRABH.NRORG
                                                                   AND H.NRESCALATRABM = GPE_ESCALATRABH.NRESCALATRABM
                                                                   AND H.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY') )
LEFT JOIN FPA_GOZOFERIAS ON FPA_GOZOFERIAS.NRORG    = FPA_FERIAS2.NRORG
                        AND FPA_GOZOFERIAS.NRFERIAS = FPA_FERIAS2.NRFERIAS
LEFT JOIN ESTRUTURAM ESTRUTLEGALM ON VINCULOH.NRORG         = ESTRUTLEGALM.NRORG
                                 AND VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM
LEFT JOIN ESTRUTURAH ESTRUTLEGALH ON ESTRUTLEGALM.NRORG          = ESTRUTLEGALH.NRORG
                                 AND ESTRUTLEGALM.NRESTRUTURAM   = ESTRUTLEGALH.NRESTRUTURAM
                                 AND ESTRUTLEGALH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH1
                                                                    WHERE ESTRUTURAH1.NRORG = ESTRUTLEGALH.NRORG
                                                                      AND ESTRUTURAH1.NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
                                                                      AND ESTRUTURAH1.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY') )
LEFT JOIN ESTRUTURAM ESTRUTGERENCM ON VINCULOH.NRORG         = ESTRUTGERENCM.NRORG
                                  AND VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM
LEFT JOIN ESTRUTURAH ESTRUTGERENCH ON ESTRUTGERENCM.NRORG          = ESTRUTGERENCH.NRORG
                                  AND ESTRUTGERENCM.NRESTRUTURAM   = ESTRUTGERENCH.NRESTRUTURAM
                                  AND ESTRUTGERENCH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH2
                                                                       WHERE ESTRUTURAH2.NRORG           = ESTRUTGERENCH.NRORG
                                                                         AND ESTRUTURAH2.NRESTRUTURAM    = ESTRUTGERENCH.NRESTRUTURAM
                                                                         AND ESTRUTURAH2.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY') )
LEFT JOIN ESTRUTURAM ESTRUTSINDM ON VINCULOH.NRORG        = ESTRUTSINDM.NRORG
                                AND VINCULOH.NRESTRUTSIND = ESTRUTSINDM.NRESTRUTURAM
LEFT JOIN ESTRUTURAH ESTRUTSINDH ON ESTRUTSINDM.NRORG          = ESTRUTSINDH.NRORG
                                AND ESTRUTSINDM.NRESTRUTURAM   = ESTRUTSINDH.NRESTRUTURAM
                                AND ESTRUTSINDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH3
                                                                   WHERE ESTRUTURAH3.NRORG           = ESTRUTSINDH.NRORG
                                                                     AND ESTRUTURAH3.NRESTRUTURAM    = ESTRUTSINDH.NRESTRUTURAM
                                                                     AND ESTRUTURAH3.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY') )
JOIN GPE_PESSOA ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
               AND GPE_VINCULOM.NRORG    = GPE_PESSOA.NRORG
JOIN GPE_PESSOAH ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
                AND GPE_PESSOAH.NRORG          = GPE_PESSOA.NRORG
                AND GPE_PESSOAH.DTMESCOMPETENC = ( SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC) FROM GPE_PESSOAH MAX_PESSOAH
                                                   WHERE MAX_PESSOAH.NRPESSOA        = GPE_PESSOAH.NRPESSOA
                                                     AND MAX_PESSOAH.NRORG           = GPE_PESSOAH.NRORG
                                                     AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY') )
LEFT JOIN GPE_TIPOVINCULOH ON GPE_TIPOVINCULOH.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
                          AND GPE_TIPOVINCULOH.DTMESCOMPETENC = (SELECT MAX(TVH.DTMESCOMPETENC)
                                                                   FROM GPE_TIPOVINCULOH TVH
                                                                  WHERE TVH.NRTIPOVINCULOM = GPE_TIPOVINCULOH.NRTIPOVINCULOM
                                                                    AND TVH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA/*:P_COMPETENCIA*/, 'DD/MM/YYYY'))
LEFT JOIN CONTCORRPARC ON CONTCORRPARC.NRORG         = GPE_VINCULOM.NRORG
                      AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
LEFT JOIN BANCO ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
               AND ( BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = :P_NRORG_PADRAO )
LEFT JOIN AGENCIA ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
                 AND AGENCIA.CDBANCO   = CONTCORRPARC.CDBANCO
                 AND ( AGENCIA.NRORG   = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = :P_NRORG_PADRAO )

 $joinHierarquia
 
 $joinidferiascalc
                             
WHERE GPE_VINCULOM.NRORG = :P_NRORG

  AND ( GPE_VINCULOM.DTADMISSAOVINC <> GPE_VINCULOM.DTRESCISAOVINC OR GPE_VINCULOM.DTRESCISAOVINC IS NULL )
  AND ( CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC FROM CONTCORRPARC C
                                        WHERE NRORG         = GPE_PESSOA.NRORG
                                          AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO )
         OR CONTCORRPARC.NRCONTCORRPARC IS NULL )
         
            $condEstrutLegal 
            $condEstrutGeren
            $condVinculo         
  
    )
    WHERE 1=1
    $conditions
    
GROUP BY
  CDMATRICULA,
  CDMATRICULAESOCIAL,
  NRESTRUTLEGAL,
  NMESTRUTLEGAL,
  NRESTRUTGEREN,
  NMESTRUTGEREN,
  NRESTRUTSIND,
  DTBASEFERIAS,
  NROCUPACAOM,
  NMOCUPACAOH,
  NRESCALATRABM,
  NMESCALATRABH,
  QTHRESCALATRABH,
  QTHRSEMESCTRABH,
  NMESTRUTSIND,
  TIPOHIERARQORG,
  NRESTRUTSUPERIOR,
  NMESTRUTSUPERIOR,
  NRVINCULOM,
  NMVINCULOM,
  NRTIPOVINCULOM,
  NMTIPOVINCULOH,
  DTADMISSAOVINC,
  NRCPFPESSOA,
  DTNASCPESSOA,
  IDADE,
  CDINTESTRUTEXP,
  CDBANCO,
  NMBANCO,
  CDAGENCIA,
  CDCONTCORR,
  NRFERIAS,
  NRTIPOFERIAS,
  NMTIPOFERIASH,
  DTINIAQUISICAO,
  DTFIMAQUISICAO,
  QTMESAFASTAMENT,
  QTFALTASPERIODO,
  QTDIASMAXFE,
  QTDIASMAXABON,
  IDCONTROLFERIAS,
  QTDIAAFASTAMENT,
  NRGOZOFERIAS,
  DTINIGOZOFERIAS,
  DTFIMGOZOFERIAS,
  QTDIAGOZOFERIAS,
  QTDEDIASRESTANTE,
  QTDIASABONOFERI,
  DTRETORNOFERIAS,
  IDADIANT13SALAR,
  DATALIMFERIAS,
  DSGOZOFERIAS,
  NROCORRECAL,
  NRTPMODALIDCAL
  
  $orderByClause

        ";
        
        $params = array(
          "P_COMPETENCIA"  => $parameters['P_DTMESCOMPETENC'],
          "P_NRORG"        => $parameters['P_NRORG'],
          "P_NRORG_PADRAO" => $parameters['P_NRORG_PADRAO'],
          "P_NRTPMODALIDCAL" => $nrTpModalidCalc,
          "P_NROCORRECAL" => $ocorCalc,
          "P_IGNORA_OCOR_CALC" => $ignoraocorrecal
        );
        
        if($idferiascalc == 'S'){
            unset($params['P_NROCORRECAL']);
            unset($params['P_IGNORA_OCOR_CALC']);
        }
        
        
      $query = $this->entityManager->getConnection()->prepare($sql);
      $query->execute(
        $params
      );
      return $query->fetchAll();
    }
}