<?php
namespace Indeterminado\Repositories;

class Relacproditgen extends \Doctrine\ORM\EntityRepository
{
	public function deleteByCdlivromagAndNrorg($cdlivromag, $nrorg)
	{
		/*A função apaga os registros da tabela RELACPRODITGEN com o where verificando o CDLIVROMAG e o NRORG.*/

		try {
			$sql = "DELETE FROM RELACPRODITGEN WHERE CDLIVROMAG = '$cdlivromag' AND NRORG = '$nrorg'";

			\Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);	
		} catch (Exception $e) {
			throw $e;
		}
	}

	public function replicaItensPorLivro($cdlivroorig, $cdlivrodest, $nrorg)
	{
		/*A função copia todos os registros da tabela RELACPRODITGEN do livro de origem para o livro de destino.
		  OBSERVAÇÃO: Lembrando que para que a cópia seja realizada o livro de origem deve possuir os cadastros de Tipo de Item e Gênero
		  que o livro de destino possui.*/

		try {
			$dataAtual = \Geral\Util\DateUtil::getDataAtual();
	        $cdoperador = \Geral\Util\Ambiente::getCdOperador();

			$sql = "INSERT INTO RELACPRODITGEN
						(CDLIVROMAG, CDPRODUTO, CDTPITEMPROD, CDGENPROD, CDNATUREC, NRORG, DTINCLUSAO, 
						 DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
					(SELECT
						'$cdlivrodest', CDPRODUTO, CDTPITEMPROD, CDGENPROD, CDNATUREC, '$nrorg', '$dataAtual',
						'$dataAtual', '$nrorg', '$cdoperador', '$nrorg', '$cdoperador', 'S'
					FROM RELACPRODITGEN
					WHERE CDLIVROMAG = '$cdlivroorig'
					AND NRORG = '$nrorg')";

			\Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);	
		} catch (\Exception $e) {
			throw $e;
			
		}
	}

	public function atualizaIntervaloByNrorgCdlivromag($nrorg, $cdlivromag, $cdarvprodini, $cdarvprodfin, $cdtpitemprod, $cdgenprod, $cdnaturec)
	{
		/*A função updata os registros da tabela RELACPRODITGEN para o intervalo de produtos informado verificando o CDLIVROMAG e o NRORG.*/
		
		try {
			$sql = "UPDATE RELACPRODITGEN
					SET CDTPITEMPROD = NVL('$cdtpitemprod',CDTPITEMPROD),
						CDGENPROD = NVL('$cdgenprod',CDGENPROD),
						CDNATUREC = NVL('$cdnaturec',CDNATUREC)
					WHERE CDLIVROMAG = '$cdlivromag'
					AND NRORG = '$nrorg'
					AND CDPRODUTO IN (SELECT CDPRODUTO
										FROM PRODUTO
										WHERE CDARVPROD BETWEEN '$cdarvprodini' AND '$cdarvprodfin'
										AND NRORG = '$nrorg')";

			\Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);	
		} catch (Exception $e) {
			throw $e;
		}
	}

	public function insereIntervaloByNrorgCdlivromag($nrorg, $cdlivromag, $cdarvprodini, $cdarvprodfin, $cdtpitemprod, $cdgenprod, $cdnaturec)
	{
		try {
			$dataAtual = \Geral\Util\DateUtil::getDataAtual();
	        $cdoperador = \Geral\Util\Ambiente::getCdOperador();

			$sql = "INSERT INTO RELACPRODITGEN
						(CDLIVROMAG, CDPRODUTO, CDTPITEMPROD, CDGENPROD, CDNATUREC, NRORG, DTINCLUSAO, 
						 DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
					(SELECT
						'$cdlivromag', CDPRODUTO, '$cdtpitemprod', '$cdgenprod', '$cdnaturec', '$nrorg', '$dataAtual',
						'$dataAtual', '$nrorg', '$cdoperador', '$nrorg', '$cdoperador', 'S'
					FROM PRODUTO
					WHERE CDARVPROD BETWEEN '$cdarvprodini' AND '$cdarvprodfin'
					AND NRORG = '$nrorg'
					AND CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
					AND CDPRODUTO NOT IN (SELECT CDPRODUTO FROM RELACPRODITGEN WHERE CDLIVROMAG = '$cdlivromag' AND NRORG = '$nrorg'))";

			\Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);	
		} catch (\Exception $e) {
			throw $e;
			
		}
	}

}