<?php

require_once 'base/GepItemtrabalhoativEntityBase.php';

/**
 * GepItemtrabalhoativEntity.
 *
 * @package Entity
 * @author  robertomartins
 */
class GepItemtrabalhoativEntity extends GepItemtrabalhoativEntityBase
{

    private $_caminhoCompleto = null;


    /**
     * Exclui Item trabalho atividade por atividade.
     *
     * @param integer $nrorg       N?mero da Organiza??o.
     * @param integer $nratividade N?mero da Atividade.
     *
     * @return Ambigous <number, number>
     */
    public static function excluiItemTrabalhoAtivByAtividade($nrorg, $nratividade){
        $dado = GepItemtrabalhoativ::excluiItemTrabalhoAtivByAtividade($nrorg, $nratividade);
        return $dado;
    }


    static public function retornaItemdetrabalhoativ($nratividade){
        return GepItemtrabalhoativ::retornaItemdetrabalhoativ($nratividade);
    }


    public static function ajaxExport($nratividade) {

        $metadata_export = array();
        $file_export = array();

        if ($nratividade !== false) {
            $nrorg = Ambiente::getNrorg();
            $itens = GepItemtrabalhoativ::getObjectsByWhere("NRORG = ? AND NRATIVIDADE = ?", array($nrorg, $nratividade));

            foreach ($itens as $item) {
                $dsitemtrabalho = $item->get('DSITEMTRABALHO');

                if (empty($dsitemtrabalho) !== true) {
                    $metadata_export[] = $dsitemtrabalho;
                } else {
                    // fetch files to export
                    $nritemtrabalho = $item->get('NRITEMTRABALHO');

                    if (empty($nritemtrabalho) !== true) {

                        $itemtrabalho = GepItemtrabalho::getObjectByWhere("NRORG = ? AND NRITEMTRABALHO = ?", array($nrorg, $nritemtrabalho));

                        if (($itemtrabalho instanceof GepItemtrabalhoEntity) === true) {
                            $nmitemtrabalho = $itemtrabalho->get('NMITEMTRABALHO');
                            $file_export[] = array($nmitemtrabalho,$nratividade);
                        }
                    }
                }
            }

            if (count($metadata_export) > 0) {
                echo json_encode($metadata_export);
            } else if (count($file_export) > 0) {
                echo json_encode($file_export);
            }

            return;
        }
    }

    public static function criaUrlItemTrabalhoRemoto($path) {

    }

    public function exporta($destino) {

           if (is_dir($destino) !== true) {
               TkFile::mkdir($destino, 0777);
           }

           $dsitemtrabalho = $this->get('DSITEMTRABALHO');
           $nrorg          = Ambiente::getNrorg();
           $nritemtrabalho = $this->get('NRITEMTRABALHO');
           $nratividade    = $this->get('NRATIVIDADE');
           $nmitemtrabalho = $this->get('NMITEMTRABALHO');
           $dsitemtrabalho = null;
           $nmitemtrabalho = 'p4a_header';


           if (empty($dsitemtrabalho) === false) {
               $destino = $destino.$dsitemtrabalho.'.zip';
               ManipulacaoArquivoLogic::executametadiffExport($dsitemtrabalho,$destino);
           } else {

                   // $itemtrabalho = GepItemtrabalho::consultaItemTrabalho($nrorg, $nritemtrabalho);
                   // $nrarvorepai = $itemtrabalho->getNrarvorepai();

                    $recu = ApropriacaoAtividadelogic::retornaArvoreRecursivamente(886);
                    $path = '';
                    foreach ($recu as $k => $v) {
                        $path = DIRECTORY_SEPARATOR .$v.$path;
                    }
                    $path = substr($path, 1);
                    ManipulacaoArquivoLogic::exportaArquivoSvn($path, $nmitemtrabalho, $nratividade );

           }
    }


    /**
     * Retorna Caminho Completo.
     *
     * @return string
     */
    public function retornaCaminhoCompleto() {
        if ($this->_caminhoCompleto === null) {
            $this->_caminhoCompleto = $this->getGepItemtrabalho()->retornaCaminhoCompleto();
        }

        return $this->_caminhoCompleto;
    }
    
    
  	/**
     * Retorna o sql da consulta dos itens de trabalho de uma atividade.
     * 
     * @param int $nratividade Cod. da Atividade.
     * 
     * @return string
     */
    public static function retornaConsultaItensTrabalhoAtiv($nratividade) {
    	$sql = GepItemtrabalhoativ::retornaConsultaItensTrabalhoAtiv($nratividade);
    	return $sql;
    }  


    public static function retornaNovoCodigo($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_ITEMTRABALHOATIV',10);
        return $codigo;
    }


    /**
     * Enter description here ...
     *
     * @param integer $nratividade       Numero da atividade.
     * @param integer $idativo           Ativo.
     * @param integer $nritemtrabalho    Numero do item.
     * @param string  $dsitemtrabalho    Descricaoo do item.
     * @param string  $nrreleaseatual    Release atual.
     * @param string  $nrreleaseanterior Release anterior.
     * @param integer $nrorg             Numero da organizacao.
     * @param integer $dtinclusao        Data da inclusao.
     * @param integer $cdoperinclusao    Numero do operador que incluiu.
     * @param integer $nrorginclusao     Organizacao na inclusao.
     * @param integer $dtultatu          Data da ultima atualizacao.
     * @param integer $cdoperultatu      Codigo operador ultima atualizacao.
     * @param integer $nrorgultatu       Organizacao na ultima atualizacao.
     *
     * @return boolean
     */
public function insereNovoItem(
                               $nrorg,
                               $nratividade,
                               $idativo,
                               $nritemtrabalho,
                               $dsitemtrabalho,
                               $nrreleaseanterior,
                               $nrreleaseatual,
                               $data,
                               $operador) {
        try {
            $cod = GepItemtrabalhoativEntity::retornaNovoCodigo($nrorg);

            $obj = new self;
            $obj->setNratividade($nratividade);
            $obj->setNritemtrabalhoativ($cod);
            $obj->setIdativo($idativo);
            $obj->setNritemtrabalho($nritemtrabalho);
            $obj->setDsitemtrabalho($dsitemtrabalho);
            $obj->setNrreleaseanterior($nrreleaseanterior);
            $obj->setNrreleaseatual($nrreleaseatual);
            $obj->setNrorg($nrorg);
            $obj->setDtinclusao($data);
            $obj->setCdoperinclusao($operador);
            $obj->setNrorginclusao($nrorg);
            $obj->setDtultatu($data);
            $obj->setCdoperultatu($operador);
            $obj->setNrorgultatu($nrorg);
            $obj->persist();
            return true;
        } catch (Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }


}