<?php
require_once 'CalculoAbstract.php';
/**
 * Enter description here ...
 *
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class Calculo extends CalculoAbstract{
    /**
     * Metodo principal.
     *
     * @param GpevinculomEntity  $vinculo       Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tp_calc_mov   Instancia de FpatpcalcmovEntity.
     * @param Demonstrativo      $demonstrativo Instancia de Demonstrativo.
     * @param integer            $contador      Contador.
     *
     * @return void
     */
    public function calcular(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov, Demonstrativo $demonstrativo, $contador){

        // @todo mudar o parametro $vinculo para o atributo $this->_vinculo.
        /* $this->_vinculo = $vinculo; */
        $this->_inicializaVariaveis($vinculo, $tp_calc_mov);
        /* Inicializa...*/

        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            return;
        }

        try {
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
            // Carrega os itens de calculo.
            $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();

        } catch(Exception $e) {
            $message = $e->getMessage();
            $message .= ' - CALCULO.PHP';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem($e->getMessage());
            ///throw new Exception($message);
        }

        //Informa qual o número do calculo, vínculo e organização estão em processamento
        MsgCalculo::getInstance()->setDados($this->_itens_calculo_principal->getNrcalculofolha(), $vinculo->getNrvinculom(), $this->_nrorg);

        // Criado metodo controleLiquido para diminuir a complexidade.
        if ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FECHAMENTO &&
            $this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){//BORBA 22/08/2014 ANTES TESTAVA SOMENTE FECHAMENTO
            $liquido = $this->_controleLiquido();
            if ($liquido === true) {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Vinculo possui liquido.',MsgCalculo::ALERTA);
                //tk_warning('Vinculo '.$vinculo->getNrvinculom().' possui liquido');
                return;
            }
        }

        // Verifica existencia de liquido parcial e retrocede.
        $this->_controleLiquidoParcial();
        $this->_inicializaVariaveisRegra();
        $this->_calculo_regra->geraVariaveis();
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_INICIO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
		
            $this->_verificaTrabalhoEfetivo($vinculo);

            $this->_geraReferenciaSitFunc();

            /*BORBA 29/04/2015 */
            $this->_calculaDsrSuplementar($this->_itens_calculo_principal,$vinculo);

            $this->_calculaRemuneracaoBase($vinculo, $this->_itens_calculo_principal, $this->_nr_tipo_calculo);

            $this->_demonstraAdiantamento($tp_calc_mov);

            if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
                || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            ) {
                //@todo - Implementar Demonstra 13 Salario
                $this->_demonstra13Salario($tp_calc_mov);
            }
            $this->_demonstraFerias($tp_calc_mov);

            $this->_calculaValeTransporte();

            /* @todo refinar tratamento de outras contribuicoes sindicais. */
            $this->_calculaContribuicaoSindical($vinculo);

            /*BORBA 27/11/2014 Para atender a solicitação 153873 */
            $this->_analisaSalMaternidade($vinculo, $tp_calc_mov);

            $this->_executaCalculoEspecifico($vinculo, $tp_calc_mov);

            /*BORBA 27/10/2014 Estava posicionado antes do calculo de contribuicao sindical e foi colocado apos o calculo especifico pois o 13º incide para o salario família*/
            $this->_calculaSalarioFamilia($vinculo);

            // Grupo de Incidencias
            $this->_calculaGrupoIncidencias();

            $this->_calculaTotais();
			
        } elseif ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            // Provisao Contabil nao calcula totais.
            $this->_verificaTrabalhoEfetivo($vinculo);
            $this->_executaCalculoEspecifico($vinculo, $tp_calc_mov);
        } elseif ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FECHAMENTO) {
            $this->_fechamento->fechar($vinculo, $this->_itens_calculo_principal, $this->_tpCalcMov);

            /*$this->_fechamento->projetaPeriodoSeguinte($this->_itens_calculo_principal);
             $num_mes = $this->_mes_competencia->getMonth()->toValue(TkDateTime::MONTH);
             if ($num_mes === 12) {
             $this->_fechamento->projetaVinculoFimAno($vinculo->historico);
             }*/

            /*
             * O fechamento retorna o item calculo projeta os itens e persist o itens_periodo_seguinte
             * $items = $this->_itens_calculo_principal->getItems();
             * @todo Rever o persist
             * if (count($items) > 0) {
             *  $this->itens_periodo_seguinte->persist();
             * }
             */
        } else {
            // Adiantamento, Ferias, 13 Salario e PLR.
            $this->_verificaTrabalhoEfetivo($vinculo);
            $this->_calculaRemuneracaoBase($vinculo, $this->_itens_calculo_principal, $this->_nr_tipo_calculo);
            $this->_executaCalculoEspecifico($vinculo, $tp_calc_mov);
            //BORBA 20/08/2013
            //$this->_calculaGrupoIncidencias(); Inserido dia 20/08 porém comentado no dia 25/09 para verificar real necessidade.
            $this->_calculaTotais();
        }

//        if ($this->_recalculo === true) {
        if (($this->_recalculo === true) || ($this->_ocorrencia > 1)) {

            /* Calculo da diferenca do recalculo
             * $this->_itens_calculo_principal->listaItemCalculo("ANTES", $this->_eventom); */

            if($this->_nr_tipo_calculo===FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR){

                //Até aqui a ocorrencia pode ter sido maior que 1 ou não e obrigatoriamente o recalculo foi true

                //BORBA 27/03/20014 - No Futuro, esta verificação deve ocorrer também ou senão unicamente no inicio , para que
                //o movimento de origem seja carregado nos itens de calculo principal e em seguida retrocedido, assim,
                //o operador nao terá o trabalho de relançar itens de calculo eventuais.
                $comp_ocorr_resc = new \TkDateTime($vinculo->getDtrescisaovinc(), TkDateTime::FORMAT_DATE);
                $comp_ocorr_resc->setDay(1);
                
                //Marcelo 21-11-2014 Alteracao das mensagens de aviso de tk_warning para tk_abort porque nao estavam sendo exibidas
                if($this->_mes_competencia->equals($comp_ocorr_resc)){
                    if($this->_nrOcorrenciaCalculo==1){
                        //@todo MsgCalculo
                        MsgCalculo::getInstance()->adicionaMensagem('Para fazer Rescisao Complementar dentro do mês de competência da Rescisão o Nr de Ocorrencia deve ser maior que '.$this->_nrOcorrenciaCalculo);
                        //tk_abort('RECALCULO - Para fazer Rescisao Complementar dentro do mês de competência da Rescisão o Nr de Ocorrencia deve ser maior que '.$this->_nrOcorrenciaCalculo);
                    }else{
                        $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, $this->_nrTipoModalidadeCalculo,
                            $this->_nrOcorrenciaCalculo-1, $comp_ocorr_resc, $comp_ocorr_resc
                        );
                    }
                }elseif($this->_mes_competencia->isLater($comp_ocorr_resc)){
                    if($this->_nrOcorrenciaCalculo>1){
                        //@todo MsgCalculo
                        MsgCalculo::getInstance()->adicionaMensagem('Para fazer Rescisao Complementar após o mês de competência da Rescisão o Nr de Ocorrencia deve ser 1');
                        //tk_abort('RECALCULO - Para fazer Rescisao Complementar após o mês de competência da Rescisão o Nr de Ocorrencia deve ser 1');
                    }else{
                        $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, $this->_nrTipoModalidadeCalculo,
                            $this->_nrOcorrenciaCalculo, $comp_ocorr_resc, $comp_ocorr_resc
                        );
                    }

                }

            }elseif($this->_nr_tipo_calculo===FpatipocalculoEntity::CALC_FOLHA){
                //Até aqui a ocorrencia tem que obrigatoriamente ter sido >1
                $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, $this->_nrTipoModalidadeCalculo,
                    $this->_nrOcorrenciaCalculo-1, $this->_mes_competencia,$this->_mes_competencia
                );

            }

            $listaNrCalculo = array();
            foreach ($calculo_folha as $calculo){
                $listaNrCalculo[] = $calculo->getNrcalculofolha();
            }

            $this->_itens_origem->retornaItensPorVinculo($vinculo->getNrorg(), $vinculo->getNrvinculom(), $listaNrCalculo[0]);
            $this->_itens_calculo_principal->calculaDiferencaRecalculo($this->_itens_origem, $this->_eventom);
            /* Recalcula total de proventos, descontos e liquido ap?s o calculo de diferenca. */
            $this->_calculaTotais();
        }

        /* $this->_itens_calculo_principal->listaItemCalculo("CALCULO FINAL", $this->_eventom);*/


        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_FINAL, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );
        // Persiste ou Simula.
        $msgcalculo = MsgCalculo::getInstance()->getDados();
        // felipesantos 24/04/2015
        if ($msgcalculo['IDSTATUS'] === MsgCalculo::ID_COM_ERRO) {
            return;
        }
        elseif ($this->_simulacao === false) {
            $tp_calc_mov->persisteItensCalculo();
            return;
        } else {
            // alessandrobartels - 27/12/2011 - Criado metodo para montar cabecalho a ser impresso em tela.
            $elementoDemonstrativo = $this->_preparaCabecalho($vinculo, $demonstrativo, $contador);

            // Retorna a lista de itens de calculo para manipulacao no Facade.
            $lista = $tp_calc_mov->retornaListaItensCalculo(
                $this->_mes_competencia, $this->_eventom, $elementoDemonstrativo, $vinculo->getNrvinculom()
            );

            return $lista;
        }
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity  $vinculo   Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tpCalcMov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels - 16/08/2011 - Inicializados os atributos Vinculo e TpCalcMov.
     */
    private function _inicializaVariaveis(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tpCalcMov){

        /* @todo mudar o parametro $vinculo para o atributo $this->_vinculo nas demais fases do calculo. */

        $this->_vinculo = $vinculo;
        // @todo mudar o parametro $tpCalcMov para o atributo $this->_tpCalcMov nas demais fases do calculo.
        $this->_tpCalcMov = $tpCalcMov;

        $this->_movimentoPrincipal = array(
            FpatipocalculoEntity::CALC_FOLHA, FpatipocalculoEntity::CALC_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR
        );

        $this->_movimentoAuxiliar = array(
            FpatipocalculoEntity::CALC_13SAL, FpatipocalculoEntity::CALC_ADIANT_13SAL, FpatipocalculoEntity::CALC_ADIANTAMENTO,
            FpatipocalculoEntity::CALC_FERIAS, FpatipocalculoEntity::CALC_PROVISAO_CONTABIL
        );
        $this->_dias_remuneracao = 0; /* 30 para ferias, adiantamento e 13 - 30 ou menos para Folha, Rescisão e Res. complementar BORBA 12/04/2013 */
        $this->_dias_normais = 0; /* vai ser igual a dias uteis + dias rsr */
        $this->_dias_uteis = 0;
        $this->_dias_rsr = 0;
        $this->_dias_afastados = 0;
        $this->_dias_ferias = 0;
        $this->_sit_func_resumo = array();

        $this->_salario = 0;
        /* $this->_sit_func_resumo = $this->_situacao_funcional->getSituacaoFuncionalResumo(); */
        /*BORBA 23/03/2015 Atendendo à solicitação de implementação de cálculo de PLR */
        if(($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_PLR || $this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_ADIANT_PLR)&&
            in_array(FpaProcessoEntity::PLR, $this->_listaProcessos) == true){
            $nrEstruturaSindcal=$vinculo->historico->getNrestrutsind();
            if(is_null($nrEstruturaSindcal)) {
                tk_warning('Não existe estrutura sindical no histórico do Vínculo: '.$vinculo->getNrvinculom());
                return;
            }
            $fpaparamsindicato = \Folha\Entities\FpaParamsindicato::findOneByNrestruturamAndNrorg($nrEstruturaSindcal,$vinculo->getNrorg());
            if(!is_object($fpaparamsindicato)) {
                tk_warning('Não existe parametro de Sindicato para o sindicato: '.$nrEstruturaSindcal);
                return;
            }
            $dataBase = $fpaparamsindicato->getDtbasesindical();
            if(is_null($dataBase)) {
                tk_warning('DataBase não parametrizada para o sindicato: '.$nrEstruturaSindcal);
                return;
            }

            $this->_setaValorTipoSalario($dataBase);
        }else{
            // 26/12/2011 Salario - Passado para o percorre calculo para impressao do salario no cabecalho do demonstrativo.
            /*BORBA 23/03/2015 antes estava assim e sem sentido $this->_setaValorTipoSalario($vinculo);*/
            $this->_setaValorTipoSalario($this->_mes_competencia);
        }

        $nrEscala = $vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.');
            //tk_warning('Vinculo '.$vinculo->getNrvinculom().' sem escala de trabalho.');
            return;
        }

        $escala = $this->_escalam->retornaEscala($nrEscala, $this->_nrorg);
        $this->_jornada_diaria = $escala->historico->getQthrescalatrabh();

        $nrEstrutura = $vinculo->historico->getNrestrutlegal();
        if ($nrEstrutura === null) {
            $this->_nrCalendario = null;
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem parametrização de Estrutura Legal.');
            //tk_warning('Vinculo '.$vinculo->getNrvinculom().' sem parametrizacao de Estrutura Legal.');
            return;
        }

        // Carrega Estrutura.
        $this->_estrutura->carregaEstrutura($nrEstrutura);
        $estrutura = $this->_estrutura->getEstrutura();

        // Carrega Calendario.
        $this->_nrCalendario = $estrutura->historico->getNrcalendario();

        // Carrega Parametro de Estrutura.
        $this->_paramCalculo->carregaParametroEstrutura($nrEstrutura);

        // Carrega Parametro da Folha.
        $this->_carregaParametroFolha();

        // Carrega Parametro de Ferias.
        $this->_carregaParametroFerias();

        // Carrega Grupo de Incidencias
        $this->_carregaItensGrupo();
		
        /*BORBA 09/01/2015 Para atender a solicitação 155798 */
        $this->_dia_fecha_apuracao=$escala->historico->getNrdiafinapur();
		if (!is_null($this->_dia_fecha_apuracao)){
			$this->_ini_periodo_apura = clone $this->_mes_competencia;
			$this->_ini_periodo_apura->setDay($this->_dia_fecha_apuracao+1)->addMonth(-1);
			$this->_fim_periodo_apura =  clone $this->_mes_competencia ;
			$this->_fim_periodo_apura->setDay($this->_dia_fecha_apuracao);
            $vinculo->ajustaIntervaloAdmResc($this->_ini_periodo_apura, $this->_fim_periodo_apura, $this->_nrControleAfastamento);
        }

    }


    /**
     * Determina as atributos de regra.
     *
     * @return void
     *
     * @author alessandrobartels / brunofeliciano - 18/08/2011
     */
    private function _inicializaVariaveisRegra(){
        /* Inicializacao das regras devem ser feitas por ultimo, apos todas as instancias serem carregadas */
        $this->_regram = new FpaRegramEntity(null, $this->_nrorg, $this->_nrOrgPadrao);
        $this->_calculo_regra = new CalculoRegra($this);
        $this->_tpCalcRegra = new FpaTpcalcregraEntity(null, $this->_nrorg, $this->_nrOrgPadrao);
    }


    /**
     * Carrega o parametro de folha.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return void
     *
     * @author alessandrobartels - 18/11/11
     * 		   thalesvalias      - 21/11/11 - Implementacao dos parametros de folha.
     */
    private function _carregaParametroFolha() {

        try{
            $this->_paramCalculo->carregaParametroFolha();

            $paramFolha = $this->_paramCalculo->getParamFolha();
            if (is_object($paramFolha) === true) {
                $this->_idTipoArredonda   = $paramFolha->getTipoArredondamento();
                $this->_nrDigitoArredonda = $paramFolha->getDigitoArredondamento();
                $this->_nrLimiteArredonda = $paramFolha->getLimiteArredondamento();
                $this->_nrGrupoIncidencia = $paramFolha->getGrupoIncidencia();
                $this->_nrControleAdmissao = $paramFolha->getControleAdmissao();
                $this->_idIRAcumulaRecMinimo = $paramFolha->getAcumulaIRRecolhimentoMinimo();
                $this->_percentualAdiantamento = $paramFolha->getPercentualAdiantamento();
                $this->_nrDiasMinAdiantamento = $paramFolha->getNumeroMinimoAdiantamento();
                $this->_idRecAdianPriMes = $paramFolha->getIdRecebeAdiantPriMes();  //BORBA 30/07/2013
                $this->_nrControleFerias = $paramFolha->getControleFerias(); //BORBA 04/08/2014
                $this->_nrControleAfastamento = $paramFolha->getControleAfastamento(); //BORBA 04/08/2014
            } else {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Não encontrado Parametro de Folha definido no Parâmetro da Estrutura.',MsgCalculo::ERRO,true);
                //tk_warning('Nao encontrado Parametro de Folha definido no Parametro da Estrutura.');
            }
        } catch (Exception $e){
            throw $e;

        }
    }


    /**
     * Carrega o parametro de ferias.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return void
     *
     * @author thalesvalias - 01/12/11 - Implementacao dos parametros de ferias.
     */
    private function _carregaParametroFerias() {

        try{
            $this->_paramCalculo->carregaParametroFerias();

            $paramFerias = $this->_paramCalculo->getParamFerias();

            if (is_object($paramFerias) === true) {
                $this->_vrPercentualProvisao = $paramFerias->getPercentualProvisao();
                $this->_nrDiasFeriaProv = $paramFerias->getNrDiasFeriasProvisao();
            } else {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Não encontrado Parâmetro de Férias definido no Parâmetro da Estrutura.',MsgCalculo::ERRO,true);
                //tk_warning('Nao encontrado Parametro de Ferias definido no Parametro da Estrutura.');
            }
        } catch (Exception $e){
            throw $e;
        }
    }


    /**
     * Carrega os itens de grupo de incidencia
     *
     * @return void
     *
     * @author alessandrobartels- 26/06/2012
     */
    private function _carregaItensGrupo(){
        $this->_itemGrupo->carregaItensGrupoPorGrupoIncidencia($this->_nrorg, $this->_nrOrgPadrao, $this->_nrGrupoIncidencia);
    }


    /**
     * Faz o controle de liquido de acordo com o tipo de calculo.
     *
     * @return boolean
     *
     * @author alessandrobartels - 14/07/2011 - Criado novo metodo para diminuir a complexidade no metodo calcular().
     */
    private function _controleLiquido(){
        if ($this->_obj_tipo_calculo->getIdctrlliquido() === FpatipocalculoEntity::IDCTRLLIQUIDO_EXIGE_LIQUIDO) {
            $liquido = $this->_itens_calculo_principal->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );

            if ($liquido === false) {
                // O fechamento so ocorre para quem tem liquido.
                return false;
            }
        } elseif ($this->_obj_tipo_calculo->getIdctrlliquido() === FpatipocalculoEntity::IDCTRLLIQUIDO_PROIBE_LIQUIDO) {
            $liquido = $this->_itens_calculo_principal->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );

            if ($liquido === true) {
                if ($this->_id_retrocesso === true) {
                    $this->_retrocesso($this->_itens_calculo_principal);
                } else {
                    false;
                    // Vinculo nao tem liquido e nao retrocede.
                }
            } else {
                return false;
            }
        }

        return true;
    }


    /**
     * Verifica a existencia de liquido parcial. Retrocede se existir.
     *
     * @return void
     *
     * @author alessandrobartels - 22/12/2011
     */
    private function _controleLiquidoParcial(){
        $liquidoParcial = $this->_itens_calculo_principal->verificaLiquidoParcial(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );

        if ($liquidoParcial === true) {
            $this->_retrocesso($this->_itens_calculo_principal);
        }
    }


    /**
     * Retrocesso do Calculo.
     *
     * @param GpevinculomEntity  $vinculo     Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     */
    public function retroceder(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov){

        /* Verificar as mensagens e retorná-las para o FACADE */
        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Não foram encontrados itens de calculo.');
            //throw new Exception($vinculo->getNrvinculom().' Não encontrou itens de calculo - CALCULO');
            /* return null; */
        }

        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
        $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();

        //Informa qual o número do calculo, vínculo e organização estão em processamento
        //@todo MsgCalculo
        MsgCalculo::getInstance()->setDados($this->_itens_calculo_principal->getNrcalculofolha(), $vinculo->getNrvinculom(), $this->_nrorg);

        $liquido = $this->_itens_calculo_principal->verificaLiquido(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );
        if ($liquido === true) {
            $this->_retrocesso($this->_itens_calculo_principal);
            $this->_itens_calculo_principal->persist();
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo retrocedeu.',MsgCalculo::ALERTA);
            //tk_warning('Vinculo: '.$vinculo->getNrvinculom().' Retrocedeu - CALCULO');
        } else {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo não tem líquido',MsgCalculo::ALERTA);
            //tk_warning('Vinculo: '.$vinculo->getNrvinculom().' Nao tem liquido - CALCULO');

        }
    }


    /**
     * Chamada dos calculos especificos.
     *
     * @param GpevinculomEntity $vinculo     Vinculo.
     * @param integer           $tp_calc_mov Tipo de Calculo Movimento.
     *
     * @return void
     */
    private function _executaCalculoEspecifico(GpevinculomEntity $vinculo, $tp_calc_mov){

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_ANTES_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        switch($this->_nr_tipo_calculo){
            case FpatipocalculoEntity::CALC_FERIAS: $this->_executaFerias($vinculo); break;
            case FpatipocalculoEntity::CALC_FOLHA: $this->_executaFolha($vinculo); break;
            case FpatipocalculoEntity::CALC_13SAL: $this->_executa13Sal($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_ADIANT_13SAL: $this->_executa13Sal($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_ADIANTAMENTO: $this->_executaAdiantamento($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_RESCISAO: $this->_executaRescisao($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR: $this->_executaRescisaocomplementar($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL: $this->_executaProvisaoContabil($vinculo, $tp_calc_mov);break;
            case FpatipocalculoEntity::CALC_ADIANT_PLR: $this->_executaPLR($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_PLR: $this->_executaPLR($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
        }

    }


    /**
     * Calculo da remuneracao base.
     *
     * @param GpevinculomEntity     $vinculo         Vinculo.
     * @param FpaitecalcfolhaEntity $itens_calculo   Itens Calculo.
     * @param string                $nr_tipo_calculo Numero do Tipo de Calculo - Apesar de ser uma atributo da classe,.
     *                                               eh parametrizado pois na rescisao exige varias tipos de calculo.
     * @param string                $incidencia      Incidencia.
     *
     * @return string
     */
    private function _calculaRemuneracaoBase(
        GpevinculomEntity $vinculo, FpaitecalcfolhaEntity $itens_calculo, $nr_tipo_calculo, $incidencia = null
    ){
        $this->_geraReferenciaSalario(
            $itens_calculo, $nr_tipo_calculo, $vinculo->historico->getIdremuneracao(), $vinculo->getNrvinculom()
        );
        $this->_calculaSalario($itens_calculo);

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_REMUNERACAO, $nr_tipo_calculo,$itens_calculo
        );

        // Chamada do metodo que calcula os eventos associados ao
        $this->_geraEventoRelacionado();

        /* @todo tratar comissao*/

        /*BORBA 23/07/2014 Trazido pra antes dos reflexos para reduzir dias uteis e dsr em caso de falta - antes ficava após o ponto de regra apos horas extras CONFORME ATIVIDADE: PA-GRUPO-TEK - Falta descontar DSR para Cálculo do Reflexo*/
        $this->_calculaFaltas($itens_calculo);

        $this->_calculaAdicionais($itens_calculo);

        // Calculo do reflexo de adicional noturno
        $this->_calculaReflexo($itens_calculo, FpatipoincideEntity::INC_REFLEXO_ADIC_NOTURNO, FpatipoassoceveEntity::ASSOC_REFLEXO_ADIC_NOTURNO);

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_ADICIONAIS, $nr_tipo_calculo,$itens_calculo
        );


        $this->_calculaExtra($itens_calculo);

        // Calculo do reflexo de hora extra
        $this->_calculaReflexo($itens_calculo, FpatipoincideEntity::INC_REFLEXO_HORA_EXTRA, FpatipoassoceveEntity::ASSOC_REFLEXO_REP_REMUNERADO);

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_HORAS_EXTRAS, $nr_tipo_calculo,$itens_calculo
        );


        /* @todo tratar falta comissao*/

        if ($incidencia !== null) {
            $aux = $itens_calculo->calculaIncidencias($incidencia, $this->_mes_competencia, $this->_eventom);
            //tk_warning($aux.' '.$incidencia);
            $evento_base_rem = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_BASE_REMUNERACAO);
            $itens_calculo->geraEvento($evento_base_rem, null, $aux, 0, 1);
            return $aux;
        }

    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Vinculo.
     *
     * @return void
     */
    private function _executaFolha(GpevinculomEntity $vinculo){

        //BORBA 02/07/2013 Gera evento assoc base remun e projeta pro mes seguinte (ASSOC_BASE_REMUN_MES_ANTERIOR)
        //INC_REMUN_MES utiliza as incidencias INSS_SAL + INSS_13SAL

		//Marcelo 12/11/2014 Função para cálculo da remuneração foi colocada antes do cálculo de FGTS, INSS e IRRF para permitir utilizar
		//esta base em regras destes cálculos

        $evento_base_rem = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_BASE_REMUN);
        $base_resc= $this->_calculaBase($this->_itens_calculo_principal, FpatipoincideEntity::INC_REMUN_MES, $this->_mes_competencia);
        $this->_itens_calculo_principal->geraEvento($evento_base_rem, null, $base_resc, 0, 2);

        /*
         * Antes do calculo especifico e apos o calculo especifico de folha existem 2 chamadas de regras.
         * Foi deixado dessa forma para manter a coerencia.
         */
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );
        // Calculado para tipo de vinculo CLT
        if (in_array(FpaProcessoEntity::FGTS, $this->_listaProcessos) === true) {

			if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
               $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
           } else{
               $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
           }

//            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_CALC, FpatipoassoceveEntity::ASSOC_FGTS,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );


        // @todo - Teste FoodSercive para acerto folha 06/12
//        if ((int)$this->_vinculo->getNrtipovinculom() !== 3){
        // Calculado para tipo de vinculo CLT
        if (in_array(FpaProcessoEntity::INSS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_CALC, FpatipoassoceveEntity::ASSOC_INSS_CALC,
                FpatipoassoceveEntity::ASSOC_INCID_INSS, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia, null, null, 0, false
            );
        }

        // Calculado para tipo de vinculo SOCIOS
        if (in_array(FpaProcessoEntity::INSS_SOCIOS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_CALC_PRO_LABORE, FpatipoassoceveEntity::ASSOC_INSS_SOCIOS,
                FpatipoassoceveEntity::ASSOC_INCID_INSS_PRO_LABORE, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia, null, null, 0, true
            );
        }
		
        //Marcelo 30-01-2015 Cálculo de folha para o tipo de vínculo autonomo. Solicitação 0000154678
        // Calculado para tipo de vinculo AUTONOMOS
        if (in_array(FpaProcessoEntity::INSS_AUTONOMO, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_CALC_AUTONOMO, FpatipoassoceveEntity::ASSOC_INSS_AUTONOMO,
                FpatipoassoceveEntity::ASSOC_INCID_INSS_AUTONOMO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia, null, null, 0, true
            );
        }		

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        if (in_array(FpaProcessoEntity::IRRF, $this->_listaProcessos) === true){
            IRRF::calcula(
                FpatipoincideEntity::INC_IRRF_CALC, FpatipoassoceveEntity::ASSOC_IRRF_CALC,
                FpatipoassoceveEntity::ASSOC_INCID_IRRF, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Vinculo.
     *
     * @return void
     *
     * @author - alessandrobartels
     *           thalesvalias - 01/12/11 -
     */
    private function _executaFerias(GpevinculomEntity $vinculo){

        if (in_array(FpaProcessoEntity::FERIAS, $this->_listaProcessos) === false){
            return;
        }

        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_FERIAS, $this->_mes_competencia, $this->_eventom
        );

        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_FERIAS, 100,
            $this->_mes_competencia, $base
        );

        /* @todo parametrizar adicional de ferias (1/3)
         * Criar 1 evento de TOTAL, criar o parametro do percentual no TipoFeriasH.
         * A preparacao ira gerar o evento com o percentual na referencia (cadastrar o evento com gerar valor 0 = S)
         * Buscar o evento e usa-lo nos adicionais.
         *
         *
         * @todo Verificar / Gerar base de ferias.
         * */
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_FERIAS, (100/3),
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, 100,
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE, (100/3),
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, 100,
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_ABONO, (100/3),
            $this->_mes_competencia, $base
        );

        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, (100/2),
            $this->_mes_competencia, $base
        );

        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, (100/2),
            $this->_mes_competencia, $base
        );

        /* @todo Parametrizar o percentual de provisao (OK) e a quantidade de dias no tipo de ferias ou
         * em outro lugar que possa variar por organizacao
         */

        // thalesvalias - 01/12/11 - Percentual de Provisao parametrizado em FPAPARAMFERIASH.
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_PROVIS_FERIAS_DB,
            $this->_vrPercentualProvisao, $this->_mes_competencia, $base
        );

        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_PROVIS_2_PARTE_DB,
            $this->_vrPercentualProvisao, $this->_mes_competencia, $base
        );
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        // Encargos sobre ferias.
		if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }

//        $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_FERIAS, FpatipoassoceveEntity::ASSOC_FGTS_FERIAS,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_FERIAS, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );

        // Encargos sobre 13 salario adiantado em ferias.
        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_13SAL, FpatipoassoceveEntity::ASSOC_FGTS_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        $qtdMaxFerias = $this->_gozo_ferias->getDias1aParte() + $this->_gozo_ferias->getDias2aParte();
        $proporcao = $this->_gozo_ferias->getDias2aParte() / $qtdMaxFerias;

        INSS::calcula(
            FpatipoincideEntity::INC_INSS_FERIAS, FpatipoassoceveEntity::ASSOC_INSS_FERIAS,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_FERIAS, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia,
            FpatipoassoceveEntity::ASSOC_INSS_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $proporcao,
            false
        );
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_13SAL, FpatipoassoceveEntity::ASSOC_INSS_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia,null,null,0,false
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_FERIAS, FpatipoassoceveEntity::ASSOC_IRRF_FERIAS,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_FERIAS, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );
        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_13SAL, FpatipoassoceveEntity::ASSOC_IRRF_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

    }

    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo         Vinculo.
     * @param integer           $nr_tipo_calculo Numero do Tipo Calculo.
     *
     * @return void
     */
    private function _executaPLR(GpevinculomEntity $vinculo, $nr_tipo_calculo, $tp_calc_mov){

        if (in_array(FpaProcessoEntity::PLR, $this->_listaProcessos) === false) {
            return;
        }

        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_PLR, $this->_mes_competencia, $this->_eventom
        );

            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_PLR, 0,
                $this->_mes_competencia, $base
            );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );
        if ($nr_tipo_calculo === FpatipocalculoEntity::CALC_PLR) {
            IRRF::calcula(
                FpatipoincideEntity::INC_IRRF_PLR, FpatipoassoceveEntity::ASSOC_IRRF_PLR,
                FpatipoassoceveEntity::ASSOC_INCID_IRRF_PLR, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo,
                true
            );
        }
            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
            );

        }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo         Vinculo.
     * @param integer           $nr_tipo_calculo Numero do Tipo Calculo.
     *
     * @return void
     */
    private function _executa13Sal(GpevinculomEntity $vinculo, $nr_tipo_calculo, $tp_calc_mov){


        if (in_array(FpaProcessoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaProcessos) === false) {
            return;
        }

        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_13SAL, $this->_mes_competencia, $this->_eventom
        );

        if ($nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL) {

            // Evento de adiantamento de 13 ja pago
            $evento = $this->_assoc_eventos->retornaEventoAssociado(FpaTipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg);
            $nrEventoOrigem = $evento->getNreventom();
            // Evento de 13 adiantado para debito
            $evento = $this->_assoc_eventos->retornaEventoAssociado(FpaTipoassoceveEntity::ASSOC_ADIANT_13SAL_DB, $this->_eventom, $this->_nrorg);
            $nrEventoDestino = $evento->getNreventom();

            //@todo - Criar parametro para executar a media somemte no complement ou no adiantamento tambem (pendencia - 472).
            // Totaliza as partes de 13 salario já adiantado (pode ser adiantamento em ferias ou adiantamento normal).
            // Os 2 tipos de adiantamento foram demonstrados no movimento mensal.

			//Marcelo 16-12-2014 - Como o adiantamento de 13º salario nao esta sendo demonstrado na folha mensal, foi alterado
			//para que seja buscado no próprio movimento de adiantamento do 13º

            $listaEventosTotalizados = $this->_media->calcula(
                $vinculo, FpatipocalculoEntity::CALC_ADIANT_13SAL, $nrEventoOrigem, $this->_primeiroDiaAno,
                $this->_mes_competencia, $this->_nrTipoModalidadeCalculo, $this->_nrOcorrenciaCalculo
            );

            // Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino
            $listaEventosOrigemDestino = array_combine(split(',', $nrEventoOrigem), split(',', $nrEventoDestino));

            $this->_media->geraEventoMedia(
                $this->_itens_calculo_principal, $listaEventosTotalizados, $listaEventosOrigemDestino,
                FpatipomovimentEntity::TP_MOV_MENSAL, false, 1
            );

            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_13SAL, 100,
                $this->_mes_competencia, $base
            );

        } else {

            // Adiantamento de 13 salario.
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, 100,
                $this->_mes_competencia, $base
            );
            $evento_base = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_13SAL_12AVOS);
            /* $indice = $this->_itens_calculo_principal->procuraEvento($evento_base, $this->_mes_competencia); */
            $indice = $this->_itens_calculo_principal->procuraEvento($evento_base, null);
            /*Busca base novamente para aproveitar todo o tratamento generico do evento (
             centavos, valor negativo, etc.)*/
            if ($indice !== -1) {
                $base = $this->_itens_calculo_principal->retornaValor($indice);
            } else {
                $base = 0.0;
            }

            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, 100,
                $this->_mes_competencia, $base
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

		if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }

//        $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_13SAL, FpatipoassoceveEntity::ASSOC_FGTS_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );


        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );


        // INSS e IRRF sao gerados no 13 complementar.
        if ($nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_13SAL, FpatipoassoceveEntity::ASSOC_INSS_13SAL,
                FpatipoassoceveEntity::ASSOC_INCID_INSS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia,null,null,0,false
            );

            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
            );

            IRRF::calcula(
                FpatipoincideEntity::INC_IRRF_13SAL, FpatipoassoceveEntity::ASSOC_IRRF_13SAL,
                FpatipoassoceveEntity::ASSOC_INCID_IRRF_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
            );

            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
            );

        }
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity  $vinculo     Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tp_calc_mov Instancoa de FpatpcalcmovEntity.
     *
     * @return void
     */
    private function _executaAdiantamento(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov){

        if (in_array(FpaProcessoEntity::ADIANTAMENTO_SALARIO, $this->_listaProcessos) === false){
            return;
        }

        /* Demonstrar a base de IR mes anterior */
        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_MENSAL, -1));
        $this->_itens_adiantamento_ma =  $obj_tp_calc_mov->getInstancia();

        $this->_demonstra(
            $this->_itens_adiantamento_ma, FpatipoassoceveEntity::ASSOC_INCID_IRRF,
            FpatipoassoceveEntity::ASSOC_BASE_IRRF_CR
        );

        /* Demonstra o IR do mes anterior */
        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_MENSAL, -1));
        $this->_itens_adiantamento_ma =  $obj_tp_calc_mov->getInstancia();

        $this->_demonstra(
            $this->_itens_adiantamento_ma, FpatipoassoceveEntity::ASSOC_IRRF_CALC,
            FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_CALC
        );

        //BORBA - 22/07/2013 - É Necessário que evento ASSOC_IRRF_JA_DESC_CALC seja demonstrativo
        $evento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_CALC, $this->_eventom, $this->_nrorg
        );
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento, null);
        if ($posicao !== -1) {
            $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM
            );
        }
        //BORBA 30/07/2013 Se o parametro de folha permite recebimento no primeiro mes chama o metodo _geraReferenciaAdiantamento()
        //senão verifica se o vinculo foi admitido antes da competencia antes de chamar _geraReferenciaAdiantamento()
        $dt_adm=new TkDateTime($this->_vinculo->getDtadmissaovinc());
        $dt_comp=new TkDateTime($this->_mes_competencia);
        if ($this->_idRecAdianPriMes == FpaParamfolhahEntityBase::IDRECADIANPRIMES_SIM) {
            $this->_geraReferenciaAdiantamento();
        } elseif ($dt_adm->isEarlier($dt_comp)) {
            $this->_geraReferenciaAdiantamento();
        }

        //BORBA 24/07/2013  Chamada do metodo que calcula os eventos associados diretamente ao vinculo
        $this->_geraEventoRelacionado();

        // If criado para diferenciar adiantamento com IRRF do adiantamento sem IRRF BORBA 19/03/2013
        if($this->_ultPagamento === FpaFormcalculoEntityBase::IDULTPGTOMES_S){
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_ULT_PAG_CR, 100,
                $this->_mes_competencia, 0.0
            );
        }else{
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_CR, 100,
                $this->_mes_competencia, 0.0
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

		if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }

//        $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_ADIANT, FpatipoassoceveEntity::ASSOC_FGTS_ADIANTAMENTO,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_ADIANT, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_ADIANT, FpatipoassoceveEntity::ASSOC_INSS_ADIANTAMENTO,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_ADIANT, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia,null,null,0,false
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_ADIANT, FpatipoassoceveEntity::ASSOC_IRRF_ADIANTAMENTO,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_ADIANT, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

    }
    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo     Vinculo.
     * @param integer           $tp_calc_mov Tipo de Calculo Movimento.
     *
     * @return void
     */
    private function _executaRescisaocomplementar(GpevinculomEntity $vinculo, $tp_calc_mov){

    $this->_recalculo=true;
    $this->_executaRescisao($vinculo, $tp_calc_mov);

    }

    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo     Vinculo.
     * @param integer           $tp_calc_mov Tipo de Calculo Movimento.
     *
     * @return void
     */
    private function _executaRescisao(GpevinculomEntity $vinculo, $tp_calc_mov){

        if (in_array(FpaProcessoEntity::RESCISAO, $this->_listaProcessos) === false) {
            return;
        }

        // BORBA 13/08/2013 bloco temporário até que se resolva a questão do tipo de direito de aviso... ou não
        $diasExp1 = $vinculo->getNrdiascontratoexp() ? $vinculo->getNrdiascontratoexp()-1 : 0;
        $diasExp2 = $vinculo->getNrdiascontratoexppro() ? $vinculo->getNrdiascontratoexppro() : 0;

        $this->_dt_fim_exp1 = new TkDateTime($vinculo->getDtadmissaovinc());
        $this->_dt_fim_exp1->addDay($diasExp1);

        $this->_dt_fim_exp2 = new TkDateTime($vinculo->getDtadmissaovinc());
        $this->_dt_fim_exp2->addDay($diasExp1+$diasExp2);

        $dtRescisao = new TkDateTime($vinculo->getDtrescisaovinc());

        /* Os eventos so serao lancados em caso de rescisao.
        * O aviso trabalhado eh calculado com base no salario ja o que for indenizado uso uma incidencia diferente.
        */

        //BORBA 13/08/2013 Adicionada a condição data de fim do contrato de exp < que data de rescisão para realizar o calculo
        if (in_array(FpaTipodireitoEntity::AVISO_PREVIO, $this->_listaDireitos) === true &&($this->_dt_fim_exp1->isEarlier($dtRescisao) &&
                $this->_dt_fim_exp2->isEarlier($dtRescisao))){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_AVISO_PREVIO_RESC));
            $this->_itens_aviso_previo = $obj_tp_calc_mov->getInstancia();

            if (count($this->_itens_aviso_previo->getItems()) > 0){

                // Marcelo 29-01-2015 Adicionado um novo ponto de regra para viabilizar manipulação dos itens de cálculos auxiliares
	   	    	// pela regra antes da utilização destes itens pelo cálculo principal da rescisao
                $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_AVISO_PREVIO_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_aviso_previo
                );

                // Não existe tipo de cálculo AVISO_PREVIO, o tipo CALC_13SAL é usado para o _calculaRemuneracaoBase gerar a base cheia.
                $base = $this->_calculaRemuneracaoBase(
                    $vinculo, $this->_itens_aviso_previo, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_AVISO_PREVIO
                );
                // Quando a data de Aviso é igual à data de rescisão no vínculo o sistema entende que o aviso não foi cumprido e deve ser indenizado
                if($vinculo->getDtrescisaovinc()===$vinculo->getDtavisoprevio()){
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN,
                        FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN, $base, 100
                    );
                    /*Geração do evendo de Complemento de aviso previo indenizado  Borba 23/02/2013*/
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ,
                        FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ, $base, 100
                    );

                }
            }
            /*$this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_TRAB, 100,
                $this->_mes_competencia, 0.0
            );
            $qtd_dias_indenizados = $this->_calculaDiversos(
                $this->_itens_calculo_principal, FpatipoincideEntity::INC_AVISO_PREVIO,
                FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN, 100, $this->_mes_competencia, 0.0
            );
            $qtd_dias_indenizados += $this->_calculaDiversos(
                $this->_itens_calculo_principal, FpatipoincideEntity::INC_AVISO_PREVIO,
                FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ, 100, $this->_mes_competencia, 0.0
            );*/
        }else{ //BORBA 13/08/2013 Mesmo tendo direito ao av. prev. se estiver dentro do contrato de exp, calcula ART_479 ou ART_480
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_INDENIZ_ART_480, 100,
                $this->_mes_competencia, 0.0
            );
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_INDENIZ_ART_479, 100,
                $this->_mes_competencia, 0.0
            );
        }
        //BORBA 25/09/2013
        /*Aviso Previo Descontado do Funcionário*/
        if (in_array(FpaTipodireitoEntity::AVISO_PREVIO_DESC, $this->_listaDireitos)=== true){
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_DESC, 100,
                $this->_mes_competencia, 0.0
            );
        }

        /*Ferias vencidas*/
        if (in_array(FpaTipodireitoEntity::FERIAS_VENCIDAS, $this->_listaDireitos) === true){
            $obj_tp_calc_mov = $tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS_VENC_RESC);
            foreach ($obj_tp_calc_mov as $obj) {
                $this->_itens_ferias_vencidas_rescisao =  $obj->getInstancia();

                if (count($this->_itens_ferias_vencidas_rescisao->getItems()) > 0){
                    // Marcelo 29-01-2015 Adicionado um novo ponto de regra para viabilizar manipulação dos itens de cálculos auxiliares
         			// pela regra antes da utilização destes itens pelo cálculo principal da rescisao
                    $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_FERIAS_VENCIDAS_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_ferias_vencidas_rescisao
                    );

                    $base = $this->_calculaRemuneracaoBase(
                        $vinculo, $this->_itens_ferias_vencidas_rescisao, FpatipocalculoEntity::CALC_FERIAS,
                        FpatipoincideEntity::INC_FERIAS
                    );

                    // Ferias
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC,
                        FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC, $base, 100
                    );

                    // Adicional
                    if (in_array(FpaTipodireitoEntity::FERIAS_VENCIDAS_ADICIONAL, $this->_listaDireitos) === true){
                        $this->_geraEventoProvisaoRescisao(
                            $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES,
                            FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES, $base, 33.333
                        );
                    }
                }
            }
        }

        /* Ferias proporcionais*/
        if (in_array(FpaTipodireitoEntity::FERIAS_PROPORCIONAIS, $this->_listaDireitos) === true){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS_PROP_RESC));
            $this->_itens_ferias_proporcionais_rescisao = $obj_tp_calc_mov->getInstancia();

            if (count($this->_itens_ferias_proporcionais_rescisao->getItems()) > 0){
                // Marcelo 29-01-2015 Adicionado um novo ponto de regra para viabilizar manipulação dos itens de cálculos auxiliares
  	    		// pela regra antes da utilização destes itens pelo cálculo principal da rescisao
                $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_FERIAS_PROPORCIONAIS_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_ferias_proporcionais_rescisao
                );

                $base = $this->_calculaRemuneracaoBase(
                    $vinculo, $this->_itens_ferias_proporcionais_rescisao, FpatipocalculoEntity::CALC_FERIAS,
                    FpatipoincideEntity::INC_FERIAS
                );

                // Ferias
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
                    FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $base, 100
                );
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL,
                    FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $base, 100
                );

                /*BORBA 12/12/2014 Criado para transportar o avo integral para o cálculo Atendendo à solicitação 153857*/
                /*Retorna objeto do evento associado do avo integral e em seguida retorna a referência do mesmo nos itens de férias proporcionais*/
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
                );
                $refeventoAux=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($eventoAux);
                /*Retorna objeto do evento associado do avo integral complementar e em seguida retorna a referência do mesmo nos itens de férias proporcionais*/
                $eventoAuxCompl = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL, $this->_eventom, $this->_nrorg
                );
                $refeventoAuxCompl=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($eventoAuxCompl);
                /*Itens são retirados pois não tem mais utilidade*/
                $this->_itens_ferias_proporcionais_rescisao->retiraitem($eventoAux);
                $this->_itens_ferias_proporcionais_rescisao->retiraitem($eventoAuxCompl);

                /*Retorna objeto do evento associado onde os avos estão proporcionalizados e em seguida altera a referência do mesmo nos itens do calculo principal e ferias proporcionais*/
                $evento = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg);
                $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha',$refeventoAux);
                $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha',$refeventoAux);

                /*Retorna objeto do evento associado onde os avos estão proporcionalizados e em seguida altera a referência do mesmo nos itens do calculo principal e ferias proporcionais*/
                $evento=$this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $this->_eventom, $this->_nrorg);
                $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha',$refeventoAuxCompl);
                $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha',$refeventoAuxCompl);

                // Adicional
                if (in_array(FpaTipodireitoEntity::FERIAS_PROPORCIONAIS_ADICIONAL, $this->_listaDireitos) === true){
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $base, 33.333
                    );
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL,
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $base, 33.333
                    );
                    /*BORBA 12/12/2014 Criado para transportar o avo integral para o cálculo Atendendo à solicitação 153857*/
                    /*Retorna objeto do evento associado onde os avos estão proporcionalizados e em seguida altera a referência do mesmo nos itens do calculo principal e ferias proporcionais*/
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg);
                    $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha',$refeventoAux);
                    $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha',$refeventoAux);

                    /*Retorna objeto do evento associado onde os avos estão proporcionalizados e em seguida altera a referência do mesmo nos itens do calculo principal e ferias proporcionais*/
                    $evento=$this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $this->_eventom, $this->_nrorg);
                    $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha',$refeventoAuxCompl);
                    $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha',$refeventoAuxCompl);

                }
            }
        }

        /* Decimo Terceiro */
        if (in_array(FpaTipodireitoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaDireitos) === true){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_13SAL_RESC));
            $this->_itens_13sal_resc = $obj_tp_calc_mov->getInstancia();

            if (count($this->_itens_13sal_resc->getItems()) > 0){
                // Marcelo 29-01-2015 Adicionado um novo ponto de regra para viabilizar manipulação dos itens de cálculos auxiliares
  	    		// pela regra antes da utilização destes itens pelo cálculo principal da rescisao
                $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_13_SALARIO_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_13sal_resc
                );

                $base = $this->_calculaRemuneracaoBase(
                    $vinculo, $this->_itens_13sal_resc, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_13SAL
                );
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_RESC,
                    FpatipoassoceveEntity::ASSOC_13SAL_RESC, $base, 100
                );
                /*Geração do evento de Complemento de aviso previo indenizado  Borba 23/02/2013*/
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC,
                    FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC, $base, 100
                );
            }
        }


        /* Rescisao de contrato com prazo determinado*/
        // BORBA 25/09/2013 Comentado pois já é calculado o art 479 utilizando metade dos dias restantes.
//        if (in_array(FpaTipodireitoEntity::INDENIZACAO_PRAZO_DETERMINADO, $this->_listaDireitos) === true){
//            if(!isset($qtd_dias_indenizados)){//se a variável nao tiver sido definida precisa definir antes de usar realizando atribuição
//                $qtd_dias_indenizados=0;      // leandroafonso 01/08/2013
//            }
//            $qtd_dias_indenizados += $this->_calculaDiversos(
//                $this->_itens_calculo_principal, FpatipoincideEntity::INC_AVISO_PREVIO,
//                FpatipoassoceveEntity::ASSOC_INDENIZACAO, 100, $this->_mes_competencia, 0.0
//            );
//        }

        /* @todo qtd_dias_indenizado e o calendario sao usados para projetar a data de rescisao (implementar)
         * @todo A associacao do FGTS (depositado ou pago) vai depender do tipo de rescisao. (implementar)
         */
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );


		if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }

//        $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);

        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_RESC, FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );


        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_FERESC, FpatipoassoceveEntity::ASSOC_FGTS_FERIAS_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_FERIAS_RESC, $this->_mes_competencia,
            $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $percentual,
            $this->_nrorg
        );


        /* Evento de PROVENTO - FGTS Pago no ato da rescisao - Depende da causa da rescisao */
        if (in_array(FpaTipodireitoEntity::FGTS_PAGO, $this->_listaDireitos) === true){
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_13SAL_RESC,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia,
                $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $percentual,
                $this->_nrorg
            );
        }

        /* Evento de ENCARGO - FGTS Depositado - Depende da causa da rescisao */
        if (in_array(FpaTipodireitoEntity::FGTS_DEPOSITADO, $this->_listaDireitos) === true){
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_13_RESCISAO,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }


        // @todo - Parametrizar na causa de rescisao para gerar as indenizacoes e contribuicao social como PROVENTO ou ENCARGO
        /* Evento de PROVENTO - Indenizacoes */
        if (in_array(FpaTipodireitoEntity::MULTA_FGTS_PAGO, $this->_listaDireitos) === true){
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESC_MULTA);
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_RESCISAO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_RESCISAO,
                FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_BANCO,
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }

        /*        $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::CONTRIB_SOC_RESC);
                FGTS::calcula(
                    FpatipoincideEntity::INC_FGTS_CONTR_SOC_RESC_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_RESC,
                    FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                );

                FGTS::calcula(
                    FpatipoincideEntity::INC_FGTS_CONTR_SOC_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_BANCO,
                    FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                );
        */


        /* Evento de ENCARGO - Indenizacoes */
        if (in_array(FpaTipodireitoEntity::MULTA_FGTS_DEPOSITADO, $this->_listaDireitos) === true){
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESC_MULTA);
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_RESCISAO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_RESCISAO_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );


            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_BANCO_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }


        /* Evento de ENCARGO - Contribuicao Social */
        if (in_array(FpaTipodireitoEntity::MULTA_CONTRIBUICAO_SOCIAL, $this->_listaDireitos) === true){
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::CONTRIB_SOC_RESC);
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_CONTR_SOC_RESC_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_RESC_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_CONTR_SOC_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_BANCO_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }


        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        INSS::calcula(
            FpatipoincideEntity::INC_INSS_RESC, FpatipoassoceveEntity::ASSOC_INSS_RESCISAO,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia,null,null,0,false
        );
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_FERESC, FpatipoassoceveEntity::ASSOC_INSS_FERIAS_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_FERIAS_RESC, $this->_mes_competencia,
            $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia
        );
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_13RESC, FpatipoassoceveEntity::ASSOC_INSS_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_valores_referencia,null,null,0,false
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_RESC, FpatipoassoceveEntity::ASSOC_IRRF_RESCISAO,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_FERESC, FpatipoassoceveEntity::ASSOC_IRRF_FERIAS_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_FERIAS_RESC, $this->_mes_competencia,
            $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia,
            $vinculo, $this->_idIRAcumulaRecMinimo
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_13RESC, FpatipoassoceveEntity::ASSOC_IRRF_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity  $vinculo     Vinculo.
     * @param FpatpcalcmovEntity $tp_calc_mov Tipo Calculo Movimento.
     *
     * @return void
     *
     * @author alessandrobartels
     */
    private function _executaProvisaoContabil(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov){
        if (in_array(FpaProcessoEntity::PROVISAO, $this->_listaProcessos) === false){
            return;
        }

        /*Aviso Prévio*/
        $obj_tp_calc_mov = $tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_AVISO_PREVIO);
        foreach ($obj_tp_calc_mov as $obj) {
            $this->_itens_aviso_previo =  $obj->getInstancia();

                // Não existe tipo de cálculo AVISO_PREVIO, o tipo CALC_13SAL é usado para o _calculaRemuneracaoBase gerar a base cheia.,
                $base = $this->_calculaRemuneracaoBase(
                $vinculo, $this->_itens_aviso_previo, FpatipocalculoEntity::CALC_13SAL,
                FpatipoincideEntity::INC_AVISO_PREVIO
            );
            $this->_geraEventoProvisaoRescisao(
                $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN,
                FpatipoassoceveEntity::ASSOC_PROV_AVISO_PREVIO, $base, 100
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN,
                FpatipoassoceveEntity::ASSOC_ENC1_AVISO_PREVIO, $base, 25
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN,
                FpatipoassoceveEntity::ASSOC_ENC2_AVISO_PREVIO, $base, 8
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ,
                FpatipoassoceveEntity::ASSOC_PROV_AVISO_PREV_COMP, $base, 100
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ,
                FpatipoassoceveEntity::ASSOC_ENC1_AVISO_PREV_COMP, $base, 25
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ,
                FpatipoassoceveEntity::ASSOC_ENC2_AVISO_PREV_COMP, $base, 8
            );

        }

        /*Ferias vencidas*/
        $obj_tp_calc_mov = $tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_FERIAS_VENC);
        foreach ($obj_tp_calc_mov as $obj) {
            $this->_itens_ferias_vencidas_rescisao =  $obj->getInstancia();
            $base = $this->_calculaRemuneracaoBase(
                $vinculo, $this->_itens_ferias_vencidas_rescisao, FpatipocalculoEntity::CALC_FERIAS,
                FpatipoincideEntity::INC_FERIAS
            );
            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC,
                FpatipoassoceveEntity::ASSOC_PROV_FERIAS_VENC, $base, 100
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC,
                FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_VENC, $base, 25
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC,
                FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_VENC, $base, 8
            );
            // 1/3 Férias Vencidas
            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES,
                FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_VENC, $base, 33.3333333333333
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES,
                FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_VENC, $base, 8.333333333333333
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES,
                FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_VENC, $base, 2.666666666666667
            );
        }

        /* Ferias proporcionais*/
        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_FERIAS_PROP));
        $this->_itens_ferias_proporcionais_rescisao = $obj_tp_calc_mov->getInstancia();
        $base = $this->_calculaRemuneracaoBase(
            $vinculo, $this->_itens_ferias_proporcionais_rescisao, FpatipocalculoEntity::CALC_FERIAS,
            FpatipoincideEntity::INC_FERIAS
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
            FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP, $base, 100
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
            FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PROP, $base, 25
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
            FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PROP, $base, 8
        );
        //avo complementar mais encargos
        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL,
            FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PRO_COMP, $base, 100
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL,
            FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PRO_COMP, $base, 25
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL,
            FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PRO_COMP, $base, 8
        );

        // 1/3 Férias Proporcionais

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
            FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PROP, $base, 33.3333333333333
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
            FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_PROP, $base, 8.333333333333333
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
            FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_PROP, $base, 2.666666666666667
        );
        // 1/3 sobre o avo complementar mais encargos
        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL,
            FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PRO_COMP, $base, 33.3333333333333
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL,
            FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_PRO_COMP, $base, 8.333333333333333
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL,
            FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_PRO_COMP, $base, 2.666666666666667
        );


        /*Decimo Terceiro*/
        $obj_tp_calc_mov = current(
            $tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_13SAL)
        );
        $this->_itens_13sal_resc = $obj_tp_calc_mov->getInstancia();
        $base = $this->_calculaRemuneracaoBase(
            $vinculo, $this->_itens_13sal_resc, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_13SAL
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT, $base, 100
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT, $base, 25
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT, $base, 8
        );
        //avo complementar mais encargos
        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC,
            FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT_COMP, $base, 100
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC,
            FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT_COMP, $base, 25
        );

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC,
            FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT_COMP, $base, 8
        );

        /*
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo
        );*/

        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_MENSAL, -1));
        $this->_itens_provisao_mes_anterior = $obj_tp_calc_mov->getInstancia();

        /*Provisao Ferias Vencidas e Encargos  */
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_FERIAS_VENC,
            FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_VENC, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_VENC,
            FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_VENC, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_VENC,
            FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_VENC, $this->_mes_competencia, false
        );
        // 1/3 sobre ferias venc e encargos
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_VENC,
            FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_VENC, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_VENC,
            FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_VENC, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_VENC,
            FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_VENC, $this->_mes_competencia, false
        );

        /*Provisao Ferias Proporcionais e Encargos */
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP,
            FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_PROP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PROP,
            FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_PROP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PROP,
            FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_PROP, null, false
        );
        //dif avos complementares mais encargos
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PRO_COMP,
            FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_PRO_COMP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PRO_COMP,
            FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_PRO_COMP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PRO_COMP,
            FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_PRO_COMP, null, false
        );

        // dif 1/3 sobre ferias proporcionais
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PROP,
            FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_PROP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_PROP,
            FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_PROP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_PROP,
            FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_PROP, null, false
        );
        //dif avos complementares mais encargos
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PRO_COMP,
            FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_PRO_COMP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_PRO_COMP,
            FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_PRO_COMP, null, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_PRO_COMP,
            FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_PRO_COMP, null, false
        );

        /*Provisao 13 Salario e Encargos */
        // No caso do 13 Salario o Demonstra ajusta a data de ocorrencia para o mes corrente.
        // Diferente das ferias onde a data de ocorrencia eh sempre a data de inicio do periodo aquisitivo.
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT,
            FpatipoassoceveEntity::ASSOC_DIFP_13SAL_CONT, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT,
            FpatipoassoceveEntity::ASSOC_DIF1_13SAL_CONT, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT,
            FpatipoassoceveEntity::ASSOC_DIF2_13SAL_CONT, $this->_mes_competencia, false
        );
        //avos complementares mais encargos
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT_COMP,
            FpatipoassoceveEntity::ASSOC_DIFP_13SAL_CONT_COMP, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT_COMP,
            FpatipoassoceveEntity::ASSOC_DIF1_13SAL_CONT_COMP, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT_COMP,
            FpatipoassoceveEntity::ASSOC_DIF2_13SAL_CONT_COMP, $this->_mes_competencia, false
        );

        /*Aviso Prévio e Encargos */
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_AVISO_PREVIO,
            FpatipoassoceveEntity::ASSOC_DIFP_AVISO_PREVIO, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_AVISO_PREVIO,
            FpatipoassoceveEntity::ASSOC_DIF1_AVISO_PREVIO, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_AVISO_PREVIO,
            FpatipoassoceveEntity::ASSOC_DIF2_AVISO_PREVIO, $this->_mes_competencia, false
        );
        //dias complementares mais encargos
        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_AVISO_PREV_COMP,
            FpatipoassoceveEntity::ASSOC_DIFP_AVISO_PREV_COMP, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_AVISO_PREV_COMP,
            FpatipoassoceveEntity::ASSOC_DIF1_AVISO_PREV_COMP, $this->_mes_competencia, false
        );

        $this->_geraDiferencaMesAnterior(
            $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_AVISO_PREV_COMP,
            FpatipoassoceveEntity::ASSOC_DIF2_AVISO_PREV_COMP, $this->_mes_competencia, false
        );

    }

    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity
     * @return void
     *
     * @author brunoborba 27/11/2014 Para atender a solicitação 153873
     */
    private function _analisaSalMaternidade(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov)
    {
        if (in_array(FpaProcessoEntity::SALARIO_MATERNIDADE, $this->_listaProcessos) === true){
            $afastamento = $this->_verificaAfastamentos(
                $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
            if(in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE,$afastamento)) {
                $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_SALARIO_MATERNIDADE));
                $this->_itens_salario_maternidade = $obj_tp_calc_mov->getInstancia();
                /*Busca afastamento de salário maternidade do vínculo para extrair a data inicio e a data fim*/
                $alte_situ_func = new GpealtesitufuncEntity();
                $obj_alte_situ_func = current($alte_situ_func->retornaAlteSitFuncporVinculoNrsituacao($this->_vinculo->getNrvinculom(),GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE,$this->_nrorg));
                $fimperiodo = new TkDateTime($obj_alte_situ_func->getDtinisitufunc());
                $inicioperiodo = new TkDateTime($obj_alte_situ_func->getDtinisitufunc());
                /*Define o $fimperiodo como o ultimo dia do mes de competencia*/
                $fimperiodo->addMonth(1)->setDay(1)->addDay(-1);
                /*Define o $inicioperiodo 6 meses antes da data de competencia*/
                $inicioperiodo->addMonth(-5)->setDay(1);
                /*Se o inicio periodo for anterior à data de admissão, esta é atribuida, em seguida é definido o primeiro dia do mes de admissao*/
                $aux_inicioperiodo = new TkDateTime($this->_vinculo->getDtadmissaovinc());
                if($inicioperiodo->isEarlier($aux_inicioperiodo)){
                    $inicioperiodo =$aux_inicioperiodo;
                    $inicioperiodo->setDay(1);
                }
                /*Retorna Eventos que estão parametrizados como média para calculos*/
                $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                /*Pela lista de eventos Busca itens no movimento mensal*/

                $listaEventosTotalizados = $this->_media->calcula(
                    $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicioperiodo,
                    $fimperiodo, $this->_nrTipoModalidadeCalculo, $this->_nrOcorrenciaCalculo
                );
                /*Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino*/
                $listaEventosOrigemDestino = array_combine(split(',', $listaNrEventos), split(',', $listaNrEventos));
                /*Gera os eventos totalizados referencia/valor no $this->_itens_salario_maternidade*/
                $this->_media->geraEventoMedia(
                    $this->_itens_salario_maternidade, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_SALARIO_MATERNIDADE,
                    true, 6
                );
                /*@todo -> Desta parte em diante seria mais coerente criar um método _executaSalMaternidade()
                /*Não existe tipo de cálculo SALARIO_FAMILIA, o tipo CALC_13SAL é usado pro _calculaRemuneracaoBase gerar a base cheia.*/
                $base = $this->_calculaRemuneracaoBase(
                    $vinculo, $this->_itens_salario_maternidade, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_SAL_MATERNI
                );
                $this->_calculaDiversos(
                    $this->_itens_calculo_principal, FpatipoincideEntity::INC_SAL_MATERNI, FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE,
                    100, $this->_mes_competencia, $base
                );
                /*Retorna objeto do evento associado do salario maternidade para regerar o evento utilizando a quantidade maxima de dias no mes civil sem alterar o valor*/
                /*Para atender a solicitação 154412*/
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE, $this->_eventom, $this->_nrorg
                );
                $recuperareferencia=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux,$this->_mes_competencia);
                if($this->_dias_normais==0&&$recuperareferencia>=30){
                    $recuperacontador=$this->_itens_calculo_principal->retornaContadorPorEvento($eventoAux,$this->_mes_competencia);
                    $recuperavalor=$this->_itens_calculo_principal->retornaValorPorEvento($eventoAux,$this->_mes_competencia);
                    $ultimoDia = $this->_ult_dia_mes->toValue(TkDateTime::DAY);
                    $this->_itens_calculo_principal->geraEvento($eventoAux,$this->_mes_competencia,$recuperavalor,$ultimoDia,$recuperacontador);
                }
            }
        }
    }
    /**
     * Enter description here ...
     *
     * @param FpaitecalcfolhaEntity $item_origem    Item de calculo.
     * @param integer               $evento_origem  Assoc. evento origem.
     * @param integer               $evento_destino Assoc. evento destino.
     * @param integer               $base           Base.
     * @param integer               $percentual     Percentual.
     *
     * @return void
     */
    private function _geraEventoProvisaoRescisao(
        FpaitecalcfolhaEntity $item_origem, $evento_origem, $evento_destino, $base, $percentual
    ){
        $this->_demonstra($item_origem, $evento_origem, $evento_destino);
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, $evento_destino, $percentual, $this->_mes_competencia, $base
        );
    }


    /**
     * Enter description here ...
     *
     * @param FpaitecalcfolhaEntity $item_origem       Instancia de FpaitecalcfolhaEntity.
     * @param integer               $nr_evento_origem  Numero do evento de origem.
     * @param integer               $nr_evento_destino Numero do evento de destino.
     * @param TkDateTime            $dt_ocorrencia     Mes de ocorrencia.
     * @param Boolean               $aceitanegativo Aceita valor negativo
     *
     * @return void
     *
     * @author alessandrobartels
     */
    private function _geraDiferencaMesAnterior(
        FpaitecalcfolhaEntity $item_origem, $nr_evento_origem, $nr_evento_destino, TkDateTime $dt_ocorrencia, $aceitanegativo=true
    ){
        $array_dtocorrencia = $this->_demonstra($item_origem, $nr_evento_origem, $nr_evento_destino, $dt_ocorrencia);
        for ($i=0; $i<count($array_dtocorrencia); $i++) {
            $evento_origem = $this->_assoc_eventos->retornaEventoAssociado(
                $nr_evento_origem, $this->_eventom, $this->_nrorg
            );
            $evento_destino = $this->_assoc_eventos->retornaEventoAssociado(
                $nr_evento_destino, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->subtraiValor($evento_origem, $evento_destino, $array_dtocorrencia[$i], $aceitanegativo);
        }
    }


    /**
     * Enter description here ...
     *
     * @param FpaitecalcfolhaEntity $item_calc_fonte       Item Calculo Fonte.
     * @param integer               $assoc_fonte           Associacao Fonte.
     * @param integer               $assoc_destino         Associacao Destino.
     * @param TkDateTime            $dt_ocorrencia_destino Mes de ocorrencia.
     *
     * @return array
     */
    private function _demonstra(
        FpaitecalcfolhaEntity $item_calc_fonte, $assoc_fonte, $assoc_destino, TkDateTime $dt_ocorrencia_destino = null
    ){
        $array_dtocorrencia = null;
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($assoc_fonte, $this->_eventom, $this->_nrorg);
        $posicoes = $item_calc_fonte->retornaItens($evento_aux);
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($assoc_destino, $this->_eventom, $this->_nrorg);
        foreach ($posicoes as $indice) {
            $referencia = $item_calc_fonte->retornaReferencia($indice);
            $valor_item = $item_calc_fonte->retornaValor($indice);
            if ($dt_ocorrencia_destino === null) {
                $dtocorrencia = $item_calc_fonte->retornaDtocorrencia($indice);
            } else {
                $dtocorrencia = $dt_ocorrencia_destino;
            }
            //BORBA 30/09/2013 - Valores e referencia zerados não devem ser demonstrados
            if( $referencia!=0 || $valor_item!=0){
                $this->_itens_calculo_principal->geraEvento($evento_aux, $dtocorrencia, $valor_item, $referencia, 1);
                $array_dtocorrencia[] = $dtocorrencia;
            }
        }

        if ($array_dtocorrencia !== null) {
            return $array_dtocorrencia;
        }
    }


    /**
     * Enter description here ...
     *
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels - 25/07/2011 - Mudanca da instanciacao dos itens de adiantamento.
     */
    private function _demonstraAdiantamento(FpatpcalcmovEntity $tp_calc_mov){
        if (in_array(FpaProcessoEntity::ADIANTAMENTO_SALARIO, $this->_listaProcessos) === true) {
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_ADIANTAMENTO));
            $this->_itens_adiantamento_demonstra =  $obj_tp_calc_mov->getInstancia();
            //BORBA 01/10/2013 Criado para diferenciar adiantamento com IRRF do adiantamento sem IRRF
            if($this->_ultPagamento === FpaFormcalculoEntityBase::IDULTPGTOMES_S){
                $this->_demonstra(
                    //BORBA 31/10/2013 - Busca valor do provento de adiantamento no movimento de adiantamento antes buscava o líquido
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_CR,
                    FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_DB
                );
            }else{
                $this->_demonstra(
                    //BORBA 31/10/2013 - Busca valor do provento de adiantamento no movimento de adiantamento antes buscava o líquido
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_ULT_PAG_CR,
                    FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_ULT_PAG_DB
                );
            }
        }
    }


    private function _demonstra13Salario(FpatpcalcmovEntity $tp_calc_mov){
        if (in_array(FpaProcessoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaProcessos) === true) {
            /*  $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_ADIANTAMENTO));
              $this->_itens_adiantamento_demonstra =  $obj_tp_calc_mov->getInstancia();

              $this->_demonstra(
                  $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_LIQUIDO,
                  FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_DB
              );
              */

            // Demonstra Adiantamento de 13 Salario
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_13SAL));
            $this->_itens_13sal_demonstra =  $obj_tp_calc_mov->getInstancia();

            /*$this->_demonstra(
                $this->_itens_13sal_demonstra, FpatipoassoceveEntity::ASSOC_LIQUIDO,
                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL
            );*/

            $this->_demonstra(
                $this->_itens_13sal_demonstra, FpatipoassoceveEntity::ASSOC_LIQUIDO,
                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL_DB
            );
        }
    }

    /**
     * Enter description here ...
     *
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     *
     * @author alessandrobartels - 22/07/2011 -
     */
    private function _demonstraFerias(FpatpcalcmovEntity $tp_calc_mov){
        if(in_array(FpaProcessoEntity::FERIAS, $this->_listaProcessos) === false){
            return;
        }
        if ($this->_dias_ferias > 0) {
            /* Carrega os itens calculos do mes corrente (mc), do mes anterior (ma) e do mes anterior ao anterior (maa).
             * Isso eh necessario pois pode ocorrer do funcionario sair de ferias 30 dias em 1� de fevereiro. Sendo
             * assim as ferias deverao ser pagas em janeiro (2 dias antes). O mes de fevereiro sera demonstrado a 1a
             * parte (mc e ma) e no mes de marco a segunda parte (ma e maa).
             */
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS));
            $this->_itens_ferias_mc =  $obj_tp_calc_mov->getInstancia();

            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS, -1));
            $this->_itens_ferias_ma =  $obj_tp_calc_mov->getInstancia();

            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS, -2));
            $this->_itens_ferias_maa =  $obj_tp_calc_mov->getInstancia();

            $mesOcorrencia = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);

            /* Pesquisa a existencia de ferias 1a parte no mes corrente, se nao encontra procura no mes anterior.
             * Achando em algum dos meses demonstra ferias primeira parte.
             */
            $gerou = $this->_verificaFeriasMesOcorrencia(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_mc, $mesOcorrencia
            );
            if ($gerou !== true) {
                $gerou = $this->_verificaFeriasMesOcorrencia(
                    FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_ma, $mesOcorrencia
                );
            }

            if ($gerou === true) {
                $this->_demonstraFeriasPrimeiraParte();
            }

            /* Pesquisa a existencia de ferias 2a parte no mes anterior, se nao encontra procura no mes anterior
             * ao anterior. Achando em algum do meses, demonstra ferias segunda parte.
             */
            $gerou = $this->_verificaFeriasMesOcorrencia(
                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_itens_ferias_ma, $mesOcorrencia
            );
            if ($gerou !== true) {
                $gerou = $this->_verificaFeriasMesOcorrencia(
                    FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_itens_ferias_maa, $mesOcorrencia
                );
            }

            if ($gerou === true) {
                $this->_demonstraFeriasSegundaParte();
            }
        }

    }


    /**
     * Verifica a existencia do evento de ferias no mes de ocorrencia.
     *
     * @param integer               $nrTipoAssocEvento Numero do Tipo de Associacao do evento.
     * @param FpaitecalcfolhaEntity $itensFerias       Instancia de FpaitecalcfolhaEntity.
     * @param TkDateTime            $mesOcorrencia     Mes de ocorrencia.
     *
     * @return boolean
     *
     * @author alessandrobartels 04/08/2011
     */
    private function _verificaFeriasMesOcorrencia(
        $nrTipoAssocEvento, FpaitecalcfolhaEntity $itensFerias, TkDateTime $mesOcorrencia
    ){
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nrTipoAssocEvento, $this->_eventom, $this->_nrorg);
        $nrEvento = $itensFerias->procuraEvento($evento_aux, $mesOcorrencia);
        if ($nrEvento !== -1 && $itensFerias->retornaValor($nrEvento) !== 0 ){//leandroafonso 18/11 se valor diferente de 0 entra e retorna true
            return true;
        }
        else{
            return false;
        }

    }


    /**
     * Demonstracao de 1a parte de Ferias.
     *
     * @return void
     *
     * @author alessandrobartels 26/07/2011
     */
    private function _demonstraFeriasPrimeiraParte(){

        /* 1a Parte Ferias - Demonstra Ferias no Mensal */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_FERIAS, FpatipoassoceveEntity::ASSOC_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        /* Adicional 1/3 de ferias */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_FERIAS, FpatipoassoceveEntity::ASSOC_ADIC_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        /* Abono Pecuniraio de ferias */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        /* Adicional de Abono de Pecuniario */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_ABONO, FpatipoassoceveEntity::ASSOC_ADIC_ABONO,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        /* SubTotal de ferias*/
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, $this->_eventom, $this->_nrorg
        );

        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
        $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
            $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
        );

        /* IR de Ferias */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_IRRF_FERIAS, FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_FERI,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc, true
        );
        /*PA-GRUPO-TEK - 0000150908 Erro IRRF Férias na Folha Mensal - AMA -  a pedidos da Alessandra
        BORBA 20/05/2015 - Busca a associação do evento e utiliza a posição para atribuir o demonstrativo = N caso o evento exista.*/
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_FERI, $this->_eventom, $this->_nrorg
        );
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
        if ($posicao !== -1) {
            $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
            );
        }
        /* INSS de Ferias */
        /*$this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_INSS_FERIAS, FpatipoassoceveEntity::ASSOC_INSS_JA_DESC_CALC,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc, true
        );*/

        /* Adiantamento de 13 Salario */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        /* Quantidade de 12 avos */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, FpatipoassoceveEntity::ASSOC_13SAL_12AVOS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        /* @todo demonstrar pensao sobre ferias */

    }


    /**
     * Demonstracao de 2a Parte de Ferias.
     *
     * @return void
     *
     * @author alessandrobartels 26/07/2011
     */
    private function _demonstraFeriasSegundaParte(){

        /* Ferias 2a Parte - Demonstra Ferias 2a parte no Mensal */
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );

        /* Adicional 1/3 de ferias 2a Parte*/
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE, FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );

        /* INSS de Ferias 2a Parte */
        /*$this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_INSS_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_INSS_JA_DESC_CALC,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma, true
        );*/


        /* Demonstra SubTotal de ferias*/
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, $this->_eventom, $this->_nrorg
        );
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
        $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
            $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
        );
    }


    /**
     * Gera o evento de demonstracao de ferias.
     *
     * @param integer               $nrTipoAssocEventoFonte   Numero do tipo de associacao do evento fonte.
     * @param integer               $nrTipoAssocEventoDestino Numero do tipo de associacao do evento destino.
     * @param FpaitecalcfolhaEntity $itemAnterior             Instancia de FpaitecalcfolhaEntity.
     * @param FpaitecalcfolhaEntity $itemCorrente             Instancia de FpaitecalcfolhaEntity.
     * @param boolean               $demonstraForaMes         Flag se demonstra evento com data fora do mes de
     *                                                        ocorrencia.
     *
     * @return void
     *
     * @author alessandrobartels - 01/08/2011
     */
    private function _geraEventoDemonstraFerias(
        $nrTipoAssocEventoFonte, $nrTipoAssocEventoDestino, FpaitecalcfolhaEntity $itemAnterior,
        FpaitecalcfolhaEntity $itemCorrente, $demonstraForaMes = false
    ){
        $this->_demonstraFeriasResumo = array();
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            $nrTipoAssocEventoFonte, $this->_eventom, $this->_nrorg
        );

        $demonstraMa = $this->_geraValorReferenciaFerias($evento_aux, $itemAnterior, $demonstraForaMes);
        $demonstraMc = $this->_geraValorReferenciaFerias($evento_aux, $itemCorrente, $demonstraForaMes);
        if ($nrTipoAssocEventoFonte !== $nrTipoAssocEventoDestino) {
            $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                $nrTipoAssocEventoDestino, $this->_eventom, $this->_nrorg
            );
        }

        if ($this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['VAL'] > 0) {
            $this->_itens_calculo_principal->geraEvento(
                $evento_aux,
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['DAT'],
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['VAL'],
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['REF'],
                1
            );
        }
    }


    /**
     * Gera os valores e referencias para a demonstracao de ferias.
     *
     * @param FpaeventomEntity      $evento_aux       Instancia de FpaeventomEntity.
     * @param FpaitecalcfolhaEntity $itensFerias      Instancia de FpaitecalcfolhaEntity.
     * @param boolean               $demonstraForaMes Flag se demonstra evento com data fora do mes de ocorrencia.
     *
     * @return boolean
     *
     * @author alessandrobartels - 26/07/2011
     */
    private function _geraValorReferenciaFerias(
        FpaeventomEntity $evento_aux, FpaitecalcfolhaEntity $itensFerias, $demonstraForaMes = false
    ){
        $itens = $itensFerias->retornaItens($evento_aux);
        if (count($itens) > 0) {
            $referencia = 0;
            $valor_item = 0.0;
            foreach ($itens as $indice) {
                $dtocorrencia = $itensFerias->retornaDtocorrencia($indice);
                if ($this->_mes_competencia->equals($dtocorrencia, TkDateTime::FORMAT_DATE) === true || $demonstraForaMes === true) {
                    $referencia += $itensFerias->retornaReferencia($indice);
                    $valor_item += $itensFerias->retornaValor($indice);
                }
            }
            if($this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['REF']>0 && $referencia>0){
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Foram encontrados mais de um lançamento de férias para o vínculo: '.$itensFerias->retornaNrvinculom($indice));
                //tk_warning('Foram encontrados mais de um lançamento de férias para o vínculo: '.$itensFerias->retornaNrvinculom($indice));
            }
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['REF'] += $referencia;
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['VAL'] += $valor_item;
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['DAT'] = $dtocorrencia;
            return true;
        }

        return false;
    }


    /**
     * Verifica admissao e rescisao, ferias e afastamentos no periodo e gera os dias trabalhados efetivamente.
     *
     * @param GpevinculomEntity $vinculo Vinculo.
     *
     * @return void
     */
    private function _verificaTrabalhoEfetivo(GpevinculomEntity $vinculo){

        // Calendario nao parametrizado na estrutura ou estrutura nao parametrizada no vinculo.
        if ($this->_nrCalendario === null) {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Calendário não parametrizado na estrutura do vínculo.');
            //tk_warning('Calendario nao parametrizado na estrutura do vinculo '.$vinculo->getNrvinculom());
            $this->_dias_trabalhados = 0;
            return;
        }

        // Acerta o intervalo para inicio e fim do mes
        $this->_inicio_periodo->set($this->_mes_competencia);
        //$ultimoDia = $this->_ult_dia_mes->toValue(TkDateTime::DAY);  Borba 27/02/2013 * NÃO ESTAVA SENDO USADO
        $this->_fim_periodo->set($this->_ult_dia_mes);
        /* Verifica se o vinculo foi admitido ou rescindido no periodo e reduz intervalo. No caso de admissao verifica
         * o controle de admissao
         */
        $vinculo->ajustaIntervaloAdmResc($this->_inicio_periodo, $this->_fim_periodo, $this->_nrControleAdmissao);
        /* Verifica intercessao do periodo aquisitivo com os periodos de afastamento, faltas e ferias*/
        $afastamento = $this->_verificaAfastamentos(
            $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
        );
        //tk_var_dump($afastamento);
        $gozo_ferias = $this->_verificaFerias($vinculo, $this->_inicio_periodo, $this->_fim_periodo);
        $vet_dias_uteis = array();

        // So carrega vetor de dias uteis caso o calendario seja diferente do vinculo anterior.
        if ($this->_nrCalendario !== $this->_nrCalendarioAnterior) {
            $this->_calendario->carregaDiasUteis($this->_nrCalendario, $this->_inicio_periodo, $this->_fim_periodo);
            $this->_nrCalendarioAnterior = $this->_nrCalendario;
        }
        $vet_dias_uteis = $this->_calendario->getVetDiasUteis();
        // Criado metodo para diminuir a complexidade ciclomatica.
        $this->_detalhaTrabalho(
            $afastamento, $gozo_ferias, $vet_dias_uteis, $this->_dias_uteis, $this->_dias_rsr, $this->_dias_normais,
            $this->_dias_afastados, $this->_dias_ferias
        );
        //tk_var_dump($this->_sit_func_resumo);
        $this->_dias_trabalhados = $this->_dias_uteis;

        /*BORBA 09/01/2015 Para atender a solicitação 155798 */
        /*12 se refere ao afastamento ATESTADO*/

        $nrEscala = $this->_vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.');
            //tk_warning('Vinculo '.$this->_vinculo->getNrvinculom().' sem escala de trabalho.');
            return;
        }
        $escala = $this->_escalam->retornaEscala($nrEscala, $this->_nrorg);
        $idutapuraAtest = $escala->historico->getIdutapuratest();
		
		if($idutapuraAtest==GpeescalatrabhEntity::IDUTAPURATEST_SIM){
			$afast = $this->_verificaAfastamentos(
				$vinculo, $this->_situacao_funcional, $this->_ini_periodo_apura, $this->_fim_periodo_apura
			);
		}else{
			$afast = $this->_verificaAfastamentos(
				$vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
			);
		}
		if(in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO, $afast) == true){
			$diasatestadoaux=0;
			for ($i=0; $i < count($afast); $i++) {
				if ($afast[$i] == GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO ) {
					$diasatestadoaux++;
				}
			}
			$diferenca=$this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO]-$diasatestadoaux;
			$this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO]=$diasatestadoaux;
			$this->_dias_afastados -=$diferenca;
			$this->_dias_normais +=$diferenca;
		}
        //tk_warning($diasatestadoaux.'  '.$this->_dias_normais.'  '.$diferenca.'  '.$this->_dias_afastados);
        //tk_var_dump($this->_sit_func_resumo);
        /* @todo - Verificar a quantidade de dias em meses com 31 dias */

        if ((($this->_tipoSalario ===  GpealtesalarioEntity::IDTPSALARIO_MENSAL)
            && ($vinculo->historico->getIdtppagamento() === GpevinculohEntity::IDTPPAGAMENTO_MENSAL)
            || ($this->_tipoSalario === GpealtesalarioEntity::IDTPSALARIO_HORA)
            && ($vinculo->historico->getIdtppagamento() === GpevinculohEntity::IDTPPAGAMENTO_MENSAL_SALARIO_HORA))
        ) {
            $dias_totais = $this->_dias_normais + $this->_dias_ferias + $this->_dias_afastados;
            if ($this->_dias_normais > 30) {
                // Sem DSR.
                $this->_dias_trabalhados -= ($dias_totais - 30);

                /* @todo implementar parametros de calculo de referencia de salario*/
                // Com DSR.
                $this->_dias_normais -= ($dias_totais - 30);
            } else {
                if ($this->_mes_competencia_int === 2) {
                    if (($this->_inicio_periodo->equals($this->_mes_competencia) === true)
                        &&($this->_fim_periodo->equals($this->_ult_dia_mes) === true)
                    ) {
                        $this->_dias_trabalhados += (30 - $dias_totais);
                        $this->_dias_normais += (30 - $dias_totais);
                    }
                    /*@todo utilizado para nutri, usar parametros para beneficiar funcionario*/   //BORBA 26/03/2013
                } else {
                    /*BORBA 29/01/2015 Atendendo à solicitação 155577 antes era $this->_dias_afastados mas atestado não é afastamento*/
                    /*Em tese somente utiliza-se o controleafastamento quando existir unicamente atestados e dias normais em todos os outros casos usa-se o mes do calendário civil*/
                    if ($diasatestadoaux>0 && $this->_dias_afastados==$diasatestadoaux){
                        //tk_warning($diasatestadoaux.'   '.$this->_dias_normais.'  '.$this->_dias_afastados);
                        if ($this->_dias_normais+$this->_dias_afastados > 30){
                            //BORBA 06/08/2014 TESTAR AFASTAMENTO EM MESES DE 31 DIAS $this->_dias_normais = (30 - $this->_dias_afastados);
                            $this->_dias_normais = ($this->_nrControleAfastamento - $this->_dias_afastados);
                            //BORBA 12/08/2013
                            /*@todo verificar a possibilidade de utilizar este recurso ao final do metodo para evitar repetições em cada bloco onde dias normais é setado*/
                            if($this->_dias_normais<0){
                                $this->_dias_normais=0;
                            }
                        }
                    }
                }
            }
            //BORBA 06/11/2013 Subtrai um dia dos dias normais para empresas que nao pagam 1 dia no mes de 31 qd o vinculo retorna de ferias.
            if(in_array(1, $gozo_ferias) == true && $this->_nrControleFerias==30 && count($afastamento)==31){
                                $this->_dias_normais-=1;
            }

        } else {
            if ($vinculo->historico->getIdtppagamento() === null) {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Tipo de Pagamento não parametrizado para o vínculo.');
                $msg = 'Nao parametrizado Tipo de Pagamento para o vinculo ';
                $msg .= $vinculo->getNrvinculom().'.';
                //tk_warning($msg);
            } else {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Tipo de Pagamento incompatível entre a Alteracao Salarial e o Vínculo ');
                $msg = 'Tipo de Pagamento incompativel entre a Alteracao Salarial e o Vinculo ';
                $msg .= $vinculo->getNrvinculom().'.';
                //tk_warning($msg);
            }
        }

        $this->_calculo_regra->executaPontoRegra(

            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_DIAS_TRAB, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );
    }


    /**
     * Especifica dias trabalhados, descanso remunerado, afastados, ferias, uteis.
     *
     * @param array $afastamento    Dias afastados.
     * @param array $gozo_ferias    Dias de gozo de ferias.
     * @param array $vet_dias_uteis Dias uteis.
     *
     * @return void
     * @author alessandrobartels - 26/01/2012
     */
    private function _detalhaTrabalho(array $afastamento, array $gozo_ferias, array $vet_dias_uteis, &$diasUteis,
                                      &$diasDsr, &$diasNormais, &$diasAfastados, &$diasFerias)
    {
        $this->_sit_func_resumo = $this->_situacao_funcional->getSituacaoFuncionalResumo();

        for ($i=0; $i < count($afastamento); $i++) {
            if ($afastamento[$i] !== -1) {
                $afast = $afastamento[$i];
                /*    if (array_key_exists($this->_sit_func_resumo,$afast) !== true) {
                        $this->_sit_func_resumo
                    }
                */
                $this->_sit_func_resumo[$afast]++;
                $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                    $this->_nrOrgPadrao, $this->_nrorg, $afastamento[$i]
                );

                if ($sit_func->historico->getIdsuspremunera() === GpesitufunchEntity::IDSUSPREMUNERA_SIM) {
                    // Borba 19/04/2013 - basicamente para atestado médico que reduz sal e gera em outro evento
                    if ($sit_func->historico->getIdafastsitufunc() === GpesitufunchEntity::IDAFASTSITUFUNC_NAO) {
                        if ($vet_dias_uteis[$i] === 'S') {
                            $diasUteis++;
                        } else {
                            $diasDsr++;
                        }
                    }
                    $diasAfastados++;
                } elseif ($gozo_ferias[$i] != -1) {
                    $diasFerias++;
                    if ($vet_dias_uteis[$i] === 'S') {
                        $diasUteis++;
                    } else {
                        $diasDsr++;
                    }
                } else {
                    $diasNormais++;
                    if ($vet_dias_uteis[$i] === 'S') {
                        $diasUteis++;
                    } else {
                        $diasDsr++;
                    }
                }
            } else {
                $diasNormais++;
                if ($vet_dias_uteis[$i] === 'S') {
                    $diasUteis++;
                } else {
                    $diasDsr++;
                }
            }
        }
    }


    /**
     * Enter description here ...
     *
     * @return void
     */
    private function _geraReferenciaSitFunc(){
        /* GpesiteventoEntity::retornaEvento();*/
        foreach ($this->_sit_func_resumo as $key=>$situacao) {
            //BORBA 08/08/2013 - Testa situação para não gerar evento com referencia 0 (zero)
            if ($key > 0 && $situacao > 0) {
                $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                    $this->_nrOrgPadrao, $this->_nrorg, $key
                );
                /* echo $key."  ".$situacao.'<br/>';*/
                $eventos = $this->_sit_evento->retornaEvento($key, $this->_mes_competencia);
                foreach ($eventos as $nr_evento) {
                    $evento = $this->_eventom->retornaEvento($nr_evento);
                    if ($evento->historico->getIdunidrefereven() !== FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
                        /* FpaeventomEntity::REF_DIA){*/
                        $referencia = FpaeventohEntity::compatibilizaReferenciaHoras(
                            $situacao, FpaeventohEntity::IDUNIDREFEREVEN_DIA, $this->_jornada_diaria
                        );
                        /*FpaeventomEntity::REF_DIA);*/
                    } else {
                        /* ja eh dia*/

                        if($situacao == $this->_ult_dia_mes->get('d')){
                            $referencia = 30;
                        } else {
                            $referencia = $situacao;
                        }
                    }
                    $this->_itens_calculo_principal->geraEvento($evento, null, 0, $referencia, 1);
                }
            }
        }
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Vinculo.
     *
     * @return array
     */
    private function _verificaFerias(GpevinculomEntity $vinculo, $inicioPeriodo, $fimPeriodo){

        /* Carrega todas as ferias de todos os tipos do vinculo*/
        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());

        if ($this->_simulacao === false) {
            // Pegar tipo vinculo do vinculo.
            $nrTpVinculo = $vinculo->getNrtipovinculom();
            if ($nrTpVinculo === null) {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Não parametrizado o tipo de vínculo.');
                //tk_warning('Nao parametrizado o tipo de vinculo.');
            }

            // Otimizacao para nao carregar relacionamento tipo vinculo x tipo de ferias toda vez.
            if ($this->_nrTpVinculoAnterior !== $nrTpVinculo) {
                // Verificar quais os tipos de ferias para o tipo de vinculo.
                $objTpFeriasVinc = $this->_tpFeriasVinc->retornaTpFeriasPorTpVinculo(
                    $this->_nrorg, $this->_nrOrgPadrao, $nrTpVinculo
                );
            }

            /* Testa se o periodo aquisitivo corrente ja existe e faz a insercao caso contrario
             * Se for gerar um novo periodo verifica faltas e afastamentos do periodo anterior
             */
            $this->_ferias->verificaPeriodoAquisitivo(
                $vinculo, $this->_eventom, $this->_alteracao_situacao_funcional,
                $this->_faltas_intervalo, $objTpFeriasVinc, $this->_mes_competencia, $this->_jornada_diaria,
                $this->_nrTipoModalidadeCalculo, $this->_nrOcorrenciaCalculo
            );
        }

        /* Carrega os periodos de gozo para todos os periodos aquisitivos*/
        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());

        /* Verifica a intersecao de gozo com o periodo de pagamento de folha*/
        try{
            $gozo_ferias = $this->_gozo_ferias->retornaDiasFerias($inicioPeriodo, $fimPeriodo);
        }
        catch(Exception $e){
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Erro ao buscar dias de férias do vínculo: Ao tentar buscar o erro foi: '.$e->getMessage());
            //tk_warning('Erro ao buscar dias de férias do vínculo: ' .$vinculo->getNmvinculom().' <br>Ao tentar buscar o erro foi: '.$e->getMessage());
        }

        /*Gozo de ferias eh um array com o periodo de pagamento de folha
         preenchidos com 1 nas posicoes correspondetes aos dias de gozo e preenchido com 0 nos demais*/
        //tk_warning($this->_inicio_periodo.' | '.$this->_fim_periodo);
        //tk_warning('<pre>'.print_r($gozo_ferias, true).'</pre>');
        return $gozo_ferias;
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity  $vinculo            Vinculo.
     * @param GpesitufuncmEntity $situacao_funcional Situacao Funcional.
     *
     * @return Ambiguous
     */
    private function _verificaAfastamentos(GpevinculomEntity $vinculo, GpesitufuncmEntity $situacao_funcional,
                                           $inicioPeriodo, $fimPeriodo)
    {
        /* Carrega todos os afastamentos do vinculo*/
        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
            $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );
        /* Verifica a intersecao dos dias de afastamento com o periodo de pagamento de folha*/

        //$this->_nrControleAdmissao

        $afastamento = $this->_alteracao_situacao_funcional->retornaDiasAfastamento(
            $situacao_funcional, $inicioPeriodo, $fimPeriodo, true
        );
        /* Afastamento eh um array com o periodo de pagamento de folha preenchidos
         com o numero da situacao funcional e com 1 nos demais*/
        //tk_warning('<pre>'.print_r($afastamento, true).'</pre>');
        //tk_warning($this->_inicio_periodo.' | '.$this->_fim_periodo);
        return $afastamento;

    }


    /**
     * Enter description here ...
     *
     * @param string $item_corrente Item Corrente.
     *
     * @return void
     */
    private function _retrocesso($item_corrente){
        $item_corrente->executaRetrocesso($this->_eventom);
    }

    /**
     * Atribui o valor do salario.
     *
     * @param TkDateTime            $dataLimite Data limite ou o próprio mes competencia.
     * @return void
     *
     *
     */
    private function _setaValorTipoSalario(TkDateTime $dataLimite){
        // Define o tipo de mobilidade salarial (vinculo ou operador).
        if ($this->_ambiente_salario_operador === GpeParamoperEntity::IDAMBIENTESAL_REAL) {
            $nrModalidade = $this->_vinculo->historico->getNrtpmodalidsal();
        } else {
            $nrModalidade = $this->_tp_modalidade_salario_operador;
        }
        // Carrega as alteracoes salariais.
        $carregou = $this->_alteracaoSalario->carregaAlteracaoSalario($dataLimite,  $this->_vinculo->getNrvinculom(), $nrModalidade);
        if ($carregou === true) {
            $this->_salario = $this->_alteracaoSalario->getSalario();
            $this->_tipoSalario = $this->_alteracaoSalario->getTipoSalario();
        } else {
            $msg = 'Não encontrado valor de salário para o vínculo '. $this->_vinculo->getNrvinculom().'.<br />';
            $msg .= 'Favor verificar Tipo de Modalidade Salarial ou a Competência';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem($msg);
            //tk_warning('Não encontrado valor de salário para o vínculo. Favor verificar Tipo de Modalidade Salarial ou a Competência.');
        }
    }


    /**
     * Gera evento de Salario ou Repouso Remunerado Semanal conforme tipo de calculo.
     *
     * @param FpaitecalcfolhaEntity $itens_calculo   Instancia de FpaitecalcfolhaEntity.
     * @param FpaeventomEntity      $evento_salario  Instancia de FpaeventomEntity.
     * @param FpaeventomEntity      $evento_rsr      Instancia de FpaeventomEntity.
     * @param integer               $nr_tipo_calculo Numero do tipo de calculo.
     *
     * @return void
     *
     * @author alessandrobartels 06/09/2011 - Criado para diminuir a complexidade ciclomatica do metodo
     *                                        _geraReferenciaSalario.
     */
    private function _geraEventoSalarioRepousoRemunerado(
        FpaitecalcfolhaEntity $itens_calculo, FpaeventomEntity $evento_salario, FpaeventomEntity $evento_rsr = null,
        $nr_tipo_calculo
    ){
        if (($nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
            $dias_trab_aux = $this->_dias_normais;

            if ($evento_rsr !== null) {
                $referencia = $evento_rsr->historico->compatibilizaReferenciaDiasParaN(
                    $this->_dias_rsr, $this->_jornada_diaria
                );
                $itens_calculo->geraEvento($evento_rsr, null, 0, $referencia, 1);
                $dias_trab_aux = $this->_dias_trabalhados;
            }

            if ($evento_salario !== null) {
                $referencia = $evento_salario->historico->compatibilizaReferenciaDiasParaN(
                    $dias_trab_aux, $this->_jornada_diaria
                );
                $itens_calculo->geraEvento($evento_salario, null, 0, $referencia, 1);
            }
            $this->_dias_remuneracao = $this->_dias_normais; //para ferias, adiantamento e 13 - 30 ou menos para Folha, Rescisão e Res. complementar BORBA 12/04/2013*/
        //tk_warning($this->_dias_remuneracao.'  '.$this->_dias_normais);
        } else {
            //Férias, adiantamento, 13º e PLR
            $this->_dias_remuneracao = 30; //para ferias, adiantamento e 13 - 30 ou menos para Folha, Rescisão e Res. complementar BORBA 12/04/2013*/
            $referencia = $evento_salario->historico->compatibilizaReferenciaDiasParaN(30, $this->_jornada_diaria);
            $itens_calculo->geraEvento($evento_salario, null, 0, $referencia, 1);
            $posicao = $itens_calculo->procuraEvento($evento_salario, null);

            if ($posicao !== -1) {
                $itens_calculo->atribuiCalculoDemonstrativo($posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM);
            }
        }
    }


    /**
     * Enter description here ...
     *
     * @param FpaitecalcfolhaEntity $itens_calculo   Itens Calculo.
     * @param integer               $nr_tipo_calculo Numero Tipo Calculo.
     * @param string                $tipoRemuneracao Definicao do tipo de remuneracao.
     * @param integer               $nrVinculom      Numero do Vinculo.
     *
     * @return void
     */
    private function _geraReferenciaSalario(
        FpaitecalcfolhaEntity $itens_calculo, $nr_tipo_calculo, $tipoRemuneracao, $nrVinculom
    ){

        /* @todo testar no vinculo tipos de evento de salario*/
        $evento_salario = null; /* Instancia de FpaeventomEntity. */
        $evento_rsr = null; /* Instancia de FpaeventomEntity. */

        switch ($tipoRemuneracao) {
            case GpevinculohEntity::IDREMUNERACAO_SAL1:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_1, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_SAL1_RSR:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_1, $this->_eventom, $this->_nrorg
                );
                $evento_rsr = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_REPOUSO_REMUNERADO, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_SAL2:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_2, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_SAL2_RSR:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_2, $this->_eventom, $this->_nrorg
                );
                $evento_rsr = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_REPOUSO_REMUNERADO, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_ESTAGIO:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_BOLSA_ESTAGIO, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_SOCIO:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SOCIO, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_AUTONOMO:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_AUTONOMO, $this->_eventom, $this->_nrorg
                );
                break;

            case GpevinculohEntity::IDREMUNERACAO_NENHUM:

                break;

            default:
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Tipo de Remuneração incompatível para o vínculo '.$nrVinculom.'.');
                //tk_warning('Tipo de Remuneração incompatível para o vínculo '.$nrVinculom.'.');
                break;
        }

        /* if ($evento_rsr !== null) { */
        $this->_geraEventoSalarioRepousoRemunerado(
            $itens_calculo, $evento_salario, $evento_rsr, $nr_tipo_calculo
        );
        /* } */

    }


    /**
     * Enter description here ...
     *
     * @return void
     */
    private function _geraReferenciaAdiantamento(){

        if ($this->_dias_normais >= $this->_nrDiasMinAdiantamento) {
            // If criado para diferenciar adiantamento com IRRF do adiantamento sem IRRF BORBA 19/03/2013
            if($this->_ultPagamento === FpaFormcalculoEntityBase::IDULTPGTOMES_S){
                $evento_adiantamento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_ULT_PAG_CR, $this->_eventom, $this->_nrorg
                );
            }else{
                $evento_adiantamento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_CR, $this->_eventom, $this->_nrorg
                );
            }
            $this->_itens_calculo_principal->geraEvento($evento_adiantamento, null, 0, $this->_percentualAdiantamento, 1);
        }
    }


    /**
     * Enter description here ...
     *
     * @param string $itens_calculo Itens Calculo.
     *
     * @return void
     */
    private function _calculaSalario($itens_calculo){
        /* O vinculo estava parametrizado e nao estava sendo usado*/
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SALARIO_1, 100, $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SALARIO_2, 100, $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_REPOUSO_REMUNERADO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_BOLSA_ESTAGIO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SOCIO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_AUTONOMO, 100, $this->_mes_competencia, 0.0
        );

        if (in_array(FpaProcessoEntity::SALARIO_MATERNIDADE, $this->_listaProcessos) === true){
            $this->_calculaDiversos(
                $itens_calculo, FpatipoincideEntity::INC_SAL_MATERNI, FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE,
                100, $this->_mes_competencia, 0.0
            );
        /*BORBA 20/05/2015 Mesmo não estando no processo para ser calculado o evento apresenta referenciaa referencia e
        fica visível para o operador, agora ele é retirado caso não exista o processo SALARIO_MATERNIDADE para o tipo de vínculo. */
        }else{
            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->retiraitem($eventoAux);
        }


        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_DIFERENCA_SALARIO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_FALTAS_ABONADAS, 100, $this->_mes_competencia, 0.0
        );
        //BORBA 23/02/2013
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_ATESTADO_MEDICO, 100, $this->_mes_competencia, 0.0
        );
    }


    /**
     * Enter description here ...
     *
     * @param string $vinculo Vinculo.
     *
     * @return void
     */
    private function _calculaSalarioFamilia($vinculo){
        if (in_array(FpaProcessoEntity::SALARIO_FAMILIA, $this->_listaProcessos) === true){
            //BORBA 05/11/2014 De acordo com a solicitação 153704 -
            $afastamento = $this->_verificaAfastamentos(
                $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
			
			//Marcelo 10/02/2015 Afastamento devido a lincença maternidade deve conceder direito ao salário familia			
            if(in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_NORMAL,$afastamento) or
               in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE,$afastamento)){				
                //tk_var_dump($afastamento);
                SalarioFamilia::calcula(
                    FpatipoincideEntity::INC_SAL_FAMILIA, FpatipoassoceveEntity::ASSOC_SALARIO_FAMILIA,
                    $this->_mes_competencia,$this->_itens_calculo_principal, $this->_assoc_eventos,$this->_eventom,
                    $vinculo,$this->_dias_normais, // BORBA 29/04/2013 SALARIO FAMILIA PROPORCIONALIZADO
                    $this->_salario //BORBA 29/10/2013 Salario base deve ser testado também
                );
            }
        }
    }


    /**
     * Enter description here ...
     *
     * @param string $vinculo Vinculo.
     *
     * @return void
     */
    private function _calculaContribuicaoSindical($vinculo){
        if (in_array(FpaProcessoEntity::CONTRIBUICAO_SINDICAL, $this->_listaProcessos) === true) {
            ContribuicaoSindical::calcula(
                FpatipoassoceveEntity::ASSOC_CONTRIB_SINDICAL, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $vinculo
            );
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, FpatipoincideEntity::INC_CONT_SINDICAL,
                FpatipoassoceveEntity::ASSOC_CONTRIB_SINDICAL, 100, $this->_mes_competencia, 0.0
            );
        }
    }


    /*
     * Usado para varios eventos que dependem de uma base ou do salario do vinculo.
     * Testa e compatibiliza o tipo de referencia de cada evento.
     * E usado para salario, adicionais, horas extras, faltas e etc.
     * No caso de aviso previo indenizado a quantidade de dias retornado vai ser usado pra prorrogar
     * a data de rescisao para o calculo de direitos (ferias, 13 e etc).
     */


    /**
     * Calcula Diversos - Usado para varios eventos que dependem de uma base ou do salario do vinculo.
     *
     * @param FpaitecalcfolhaEntity $itens_calculo   Itens Calculo.
     * @param integer               $incidencia      Incidencia.
     * @param integer               $nr_evento       Evento.
     * @param float                 $percentual      Percentual.
     * @param TkDateTime            $mes_competencia Mes Competencia.
     * @param float                 $base            Base.
     *
     * @return float
     */
    private function _calculaDiversos(
        FpaitecalcfolhaEntity $itens_calculo, $incidencia, $nr_evento, $percentual, TkDateTime $mes_competencia,
        $base = 0.0
    ) {
        //BORBA 27/06/2013
        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ){
            //BORBA 29/05/2013
            if ( $this->_itens_calculo_principal!==$itens_calculo ){
                // Normalmente quando rescisao chama ferias, 13sal, aviso previo o periodo é sempre integral
                $this->_baseCorrespPeriodoIntegral = true;
            } else {
                // No mensal e na rescisao propriamente pode ser proporcional a não ser que a incidencia retorne 0 (zero)
                // e que o metodo use o salário como base deixando a cargo do calcula base retornar true ou não.				

                //06-02-2015 Marcelo Horas Extras e faltas sempre devem ser calculadas a partir da base integral				
                if (($incidencia == FpatipoincideEntity::INC_FALTAS) or ($incidencia == FpatipoincideEntity::INC_HORA_EXTRA)) {
                    $this->_baseCorrespPeriodoIntegral = true;
                } else {
                    $this->_baseCorrespPeriodoIntegral = false;
                }
            }

        } else {
            $this->_baseCorrespPeriodoIntegral = true;
        }

        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nr_evento, $this->_eventom, $this->_nrorg);

        if ($evento_aux !== null) {
            // @todo Testar se o evento possui associacao. Imprimir menssagem de erro.
            $itens = $itens_calculo->retornaItens($evento_aux);

            if ($base === 0.0) {
                $base = $this->_calculaBase($itens_calculo, $incidencia, $mes_competencia);
            } else{
                $this->_baseCorrespPeriodoIntegral = true;
            }
//          if ($nr_evento == 60){
//              tk_warning('PERICULOSIDADE '.$base);
//          }
            $tipo_referencia = $evento_aux->historico->getIdunidrefereven();

            $qtd_dias = 0;
            foreach ($itens as $indice) {
                $referencia = $itens_calculo->retornaReferencia($indice);

                /* echo "<CALCULO>TpRef: $tipo_referencia  NrEve: ".$evento_aux->getNreventom()."<br/>";*/
                switch ($tipo_referencia) {
                    case FpaeventohEntity::IDUNIDREFEREVEN_PERCENTUAL:
                        //BORBA 12/11/2013 Para medias de valor em que a preparação zera a referencia.
                        if($referencia!=0){
                            $valor_item = ($base * $referencia)/100;

                        }else{
                            $valor_item=$itens_calculo->retornaValor($indice);
                        }


//                    if ($nr_evento == 60){
//                        tk_warning('PERICULOSIDADE V '.$valor_item.' '.$referencia);
//                    }

                        break;
                    case FpaeventohEntity::IDUNIDREFEREVEN_DIA :
                    case FpaeventohEntity::IDUNIDREFEREVEN_HORA :
                    case FpaEventohEntity::IDUNIDREFEREVEN_HORA_MINUTO:
                        //if ($this->_baseCorrespPeriodoIntegral === true) {

                        if ($this->_baseCorrespPeriodoIntegral === false) {
                            $valor_hora = $base / $this->_calculaHoraEfetivas();
                        } else {						
                            //06-02-2015 Marcelo Horas Extras e faltas sempre devem ser calculadas a partir da base integral										
                            if (($incidencia == FpatipoincideEntity::INC_FALTAS) or ($incidencia == FpatipoincideEntity::INC_HORA_EXTRA)) {
                                $valor_hora = $this->_salario / ($this->_jornada_diaria * 30);                                
                            } else {																	
								$valor_hora = $base / ($this->_jornada_diaria * 30);
							}	
                        }

                        /* aplica o percentual no valor hora*/
                        $valor_hora = ($valor_hora * $percentual)/100;
                        $ref_hora = FpaeventohEntity::compatibilizaReferenciaHoras(
                            $referencia, $tipo_referencia, $this->_jornada_diaria
                        );
                        $valor_item = $valor_hora * $ref_hora;

                        if ($referencia === $ref_hora) {
                            // Para tipo de referencia HORA e HORA_MINUTO com valor inteiro
                            $qtd_dias += ($referencia / $this->_jornada_diaria);
                        } else {

                            if ($tipo_referencia === FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
                                $qtd_dias += $referencia;
                            } else {
                                // Para tipo de referencia HORA_MINUTO com valor quebrado
                                $qtd_dias += ($ref_hora / $this->_jornada_diaria);
                            }

                        }

                        break;
                    case FpaeventohEntity::IDUNIDREFEREVEN_12_AVOS:
                        $valor_item = ($base * $referencia)/12;
                        $valor_item = ($valor_item * $percentual)/100;
                        break;
                    default:
                        /* @todo Converter para tk_show_message*/
                        $msg = 'Tipo de referência '.$tipo_referencia.' não tratada - CalculaDiversos - CALCULO.PHP';
                        $msg .= ' Evento: '.$evento_aux->historico->getNmeventoh();
                        $msg .= ' Ref: '.$referencia.' Valor: '.$valor_item;
                        $msg .= ' Vínculo: '.$this->_vinculo->getNrvinculom().' Valor: ';
                        //@todo MsgCalculo
                        MsgCalculo::getInstance()->adicionaMensagem('Tipo de referência '.$tipo_referencia.' não tratada. Evento: '.$evento_aux->historico->getNmeventoh().' Ref: '.$referencia.' Valor: '.$valor_item);
                        //tk_warning($msg);

                        break;
                }
//                if ($nr_evento == 60){
//                    tk_warning('PERICULOSIDADE V1 '.$valor_item.' '.$referencia);
//                }
                $dtocorrencia = new TkDateTime($itens_calculo->retornaDtocorrencia($indice));
                //tk_warning($evento_aux->getNreventom().'  '.$dtocorrencia.'  '.$valor_item.'  '.$referencia);
                $itens_calculo->geraEvento($evento_aux, $dtocorrencia, (float)$valor_item, $referencia, 1);
                unset($dtocorrencia);
            }

            /* Utilizado na rescisao para projetar a data em funcao de indenizacoes lancadas/geradas
             * pelo usuario no movimento
             */
            return $qtd_dias;
        } else {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Evento não associado ('.$nr_evento.').');
            //tk_warning('Evento não associado.');
        }
    }


    /**
     * Atribui valor a um item ja existente num determinado mes de ocorrencia.
     *
     * @param FpaitecalcfolhaEntity $itens_calculo Itens Calculo.
     * @param integer               $nr_evento     Evento.
     * @param float                 $valor         Valor.
     *
     * @return void
     */
    private function _atribuiValor(FpaitecalcfolhaEntity $itens_calculo, $nr_evento, $valor) {
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nr_evento, $this->_eventom, $this->_nrorg);
        $itens = $itens_calculo->retornaItens($evento_aux);

        foreach ($itens as $indice) {
            $referencia = $itens_calculo->retornaReferencia($indice);
            $dtocorrencia = $itens_calculo->retornaDtocorrencia($indice);
            $itens_calculo->geraEvento($evento_aux, $dtocorrencia, $valor, $referencia, 1);
        }
    }


    /**
     * Calcula a base de calculo.
     *
     * @param FpaitecalcfolhaEntity $itens_calculo   Instancia de FpaitecalcfolhaEntity.
     * @param integer               $incidencia      Numero do tipo de incidencia.
     * @param TkDateTime            $mes_competencia Mes de competencia.
     *
     * @return float
     *
     * @author alessandrobartels - 14/07/2011 - criado metodo para eliminar complexidade em _calculaDiversos().
     */
    private function _calculaBase(FpaitecalcfolhaEntity$itens_calculo, $incidencia, TkDateTime $mes_competencia){
        /* A incidencia pode vir nula no caso de CalculaSalario*/
        if ($incidencia !== null) {
            $base = $itens_calculo->calculaIncidencias($incidencia, $mes_competencia, $this->_eventom);
            if ($base === 0.0) {
                $this->_baseCorrespPeriodoIntegral = true;
                $base = $this->_salario;
            }
        } else {
            $this->_baseCorrespPeriodoIntegral = true;
            $base = $this->_salario;
        }

        return $base;
    }


    /**
     * Enter description here ...
     *
     * @return Ambiguous
     */
    private function _calculaHoraEfetivas(){
        return $this->_dias_normais * $this->_jornada_diaria;
    }

    /**
     * Enter description here ...
     *
     * @param FpaitecalcfolhaEntity $itens_calculo   Itens Calculo.
     * @param GpevinculomEntity     $vinculo         Vinculo.
     *
     * @return void
     *
     * @author brunoborba - 30/04/2015
     */
    private function _calculaDsrSuplementar( FpaitecalcfolhaEntity $itens_calculo, GpevinculomEntity $vinculo
    ){
        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
            /*(@todo até a geração do evento é mais condizente ser tratado na preparação*/
            $ultimoDia = new TkDateTime($vinculo->getDtrescisaovinc());
            if ($ultimoDia->toString(TkDateTime::WEEKDAY_DIGIT)==5){
                $evento_dsr = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DSR_SUPLEMENTAR, $this->_eventom, $this->_nrorg
                );

                $itens_calculo->geraEvento($evento_dsr, null, 0, 1, 1);

                $this->_calculaDiversos(
                    $itens_calculo, null, FpatipoassoceveEntity::ASSOC_DSR_SUPLEMENTAR, 100,
                    $this->_mes_competencia, 0.0
                );
            }
        }
    }
    /**
     * Enter description here ...
     *
     * @param string $itens_calculo Itens Calculo.
     *
     * @return void
     */
    private function _calculaFaltas($itens_calculo){
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_DIA, 100,
            $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_HORA, 100,
            $this->_mes_competencia, 0.0
        );
        /* @todo Desejável fazer calculadiversos para perda de dsr associado ao ASSOC_FALTAS_HORA_MINUTO*/
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_HORA_MINUTO, 100,
            $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_ATRASOS, 100,
            $this->_mes_competencia, 0.0
        );

        //BORBA 30/09/2013 - Gerar perda de DSR de pelo menos 1 dia de acordo com a jornada
        $this->_geraPerdaDsr($itens_calculo);

        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA, 100,
            $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_PERDA_RSR_HORA, 100,
            $this->_mes_competencia, 0.0
        );

    }

    /**
     * Enter description here ...
     *
     * @param FpaitecalcfolhaEntity $itens_calculo Itens Calculo.
     *
     * @return void
     *
     * @autor BORBA
     */
    private function _geraPerdaDsr(FpaitecalcfolhaEntity $itens_calculo){

        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
            //BORBA 20/11/2013 - Verifica se tem pelo menos 1 DSR para antes de gerar a Perda
            if ($this->_dias_rsr > 0){
                // Calcula perda de DSR em horas
                $evento_dsr = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PERDA_RSR_HORA,
                    $this->_eventom, $this->_nrorg
                );
                 
                if ($evento_dsr !== null) {
                    // @todo Testar se o evento possui associacao. Imprimir menssagem de erro.
                    $itens = $itens_calculo->retornaItens($evento_dsr);
                }
                if(!$itens){
                    $evento_faltas = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FALTAS_HORA,
                        $this->_eventom, $this->_nrorg
                    );
                    if ($evento_faltas !== null) {
                        // @todo Testar se o evento possui associacao. Imprimir menssagem de erro.
                        $itens = $itens_calculo->retornaItens($evento_faltas);
                    }
                    if($itens){
                        $referencia = $evento_dsr->historico->compatibilizaReferenciaDiasParaN(
                            1, $this->_jornada_diaria
                        );
                        //tk_warning (' U->'.$this->_dias_uteis.'  DSR->'.$this->_dias_rsr.' N->'.$this->_dias_normais);
                        $itens_calculo->geraEvento($evento_dsr, null, 0, $referencia, 1);
                    }

                }

                // Calcula perda de DSR em dias
                // Marcelo 22/05/2014 Rotina para calcular a perda de DSR em dia - variavel $evento_dsr_dia
                $evento_dsr_dia = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA,
                    $this->_eventom, $this->_nrorg
                );

                if ($evento_dsr_dia !== null) {
                    // @todo Testar se o evento possui associacao. Imprimir menssagem de erro.
                    $itens = $itens_calculo->retornaItens($evento_dsr_dia);
                }
                if(!$itens){
                    $evento_faltas = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FALTAS_DIA,
                        $this->_eventom, $this->_nrorg
                    );
                    if ($evento_faltas !== null) {
                        // @todo Testar se o evento possui associacao. Imprimir menssagem de erro.
                        $itens = $itens_calculo->retornaItens($evento_faltas);
                    }
                    if($itens){
                        $referencia = $evento_dsr_dia->historico->compatibilizaReferenciaDiasParaN(
                            1, $this->_jornada_diaria
                        );
                        //tk_warning (' U->'.$this->_dias_uteis.'  DSR->'.$this->_dias_rsr.' N->'.$this->_dias_normais);
                        $itens_calculo->geraEvento($evento_dsr_dia, null, 0, $referencia, 1);
                    }

                }

            }
        }
    }

    /**
     * Enter description here ...
     *
     * @param string $itens_calculo Itens Calculo.
     *
     * @return void
     */
    private function _calculaAdicionais($itens_calculo){
        $listaAdicionaisNoturnos = Inicializa::getListaEventoAdicionalNoturno();

        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_AD_INSALUBRE, FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE, 20,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_AD_PERICULO, FpatipoassoceveEntity::ASSOC_ADIC_PERICULO, 20,
            $this->_mes_competencia, 0.0
        );
        /*$this->_calculaDiversos(
           $itens_calculo, FpatipoincideEntity::INC_AD_NOTURNO, FpatipoassoceveEntity::ASSOC_ADIC_NOTURNO_2, 20,
            $this->_mes_competencia, 0.0
        );*/
        foreach($listaAdicionaisNoturnos as $nrAdicionalNoturno => $referencia){
            //tk_warning($this->_calculaDiversos(
            //    $itens_calculo, FpatipoincideEntity::INC_AD_NOTURNO, $nrAdicionalNoturno, $referencia , $this->_mes_competencia, 0.0
            // ));
            $this->_calculaDiversos(
                $itens_calculo, FpatipoincideEntity::INC_AD_NOTURNO, $nrAdicionalNoturno, $referencia , $this->_mes_competencia, 0.0
            );
        }

    }


    /**
     * Calculo de Hora Extra.
     *
     * @param FpaitecalcfolhaEntity $itens_calculo Itens Calculo.
     *
     * @return void
     */
    private function _calculaExtra(FpaitecalcfolhaEntity $itens_calculo){

        $listaHorasExtras = Inicializa::getListaEventoHoraExtra();

        foreach($listaHorasExtras as $nrHoraExtra => $referencia){

            $this->_calculaDiversos(
                $itens_calculo, FpatipoincideEntity::INC_HORA_EXTRA, $nrHoraExtra, $referencia + 100, $this->_mes_competencia, 0.0
            );
        }

    }


    /**
     * Calculo reflexo de hora extra em RSR.
     *
     * @param FpaitecalcfolhaEntity $itens_calculo Instancia de Itens de Calculo
     * @param integer               $nrIncidencia  Numero do tipo de incidencia
     * @param integer               $nrEvento      Numero do tipo de associacao de eventos
     * @return void
     *
     * @author alessandrobartels 15/01/2013
     */
    private function _calculaReflexo(FpaitecalcfolhaEntity $itens_calculo, $nrIncidencia, $nrEvento){
        /*@todo rever necessidade de utilizar parametro futuramente*/
        // Nas férias e no 13º o reflexo vem como média de valor BORBA 09/04/2013
        if (!(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR))
        ) {
            return;
        }
        /*BORBA 12/01/2015 Para atender a solicitação 155798 */
        $nrEscala = $this->_vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.');
            //tk_warning('Vinculo '.$this->_vinculo->getNrvinculom().' sem escala de trabalho.');
            return;
        }
        $escala = $this->_escalam->retornaEscala($nrEscala, $this->_nrorg);
        $idutapuraDsr = $escala->historico->getIdutapuradsr();

        if($idutapuraDsr==GpeescalatrabhEntity::IDUTAPURADSR_SIM){
            if ($this->_itens_calculo_principal->getNrcalculofolha() == $itens_calculo->getNrcalculofolha()) {
                $base = $itens_calculo->calculaIncidencias($nrIncidencia, $this->_mes_competencia, $this->_eventom, true);
                if (is_array($base)) {
                    $calendario = new CalendarioLogic($this->_nrorg, $this->_nrOrgPadrao);
                    foreach ($base as $dataTimestamp => $valorBase) {

                        $diasUteis = 0;
                        $diasDsr = 0;
                        $diasNormais = 0;
                        $diasAfastados = 0;
                        $diasFerias = 0;

                        $dtOcorrencia = new \TkDateTime();
                        $dtOcorrencia->setTimestamp($dataTimestamp);

                        $primeiroDiaOcorrencia = clone $dtOcorrencia;
                        $ultimoDiaOcorrencia = clone $dtOcorrencia;

                        $primeiroDiaOcorrencia->addMonth(-1)->setDay($this->_dia_fecha_apuracao+1);
                        $ultimoDiaOcorrencia->setDay($this->_dia_fecha_apuracao);
                        $this->_vinculo->ajustaIntervaloAdmResc($primeiroDiaOcorrencia, $ultimoDiaOcorrencia, $this->_nrControleAdmissao);
                        $calendario->carregaDiasUteis($this->_nrCalendario, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                        $afastamento = $this->_verificaAfastamentos(
                            $this->_vinculo, $this->_situacao_funcional, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia
                        );
                        $gozo_ferias = $this->_verificaFerias($this->_vinculo, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                        $this->_detalhaTrabalho(
                            $afastamento, $gozo_ferias, $calendario->getVetDiasUteis(), $diasUteis, $diasDsr, $diasNormais, $diasAfastados,
                            $diasFerias
                        );						
			
                        $this->_geraEventoCalculoReflexo(
                            $itens_calculo, $nrEvento, $dtOcorrencia, $valorBase, $diasDsr, $diasUteis
                        );

                    }
                } else {
                    $calendario = new CalendarioLogic($this->_nrorg, $this->_nrOrgPadrao);
                    $primeiroDiaOcorrencia = clone $this->_mes_competencia;
                    $ultimoDiaOcorrencia = clone $this->_mes_competencia;

                    $primeiroDiaOcorrencia->addMonth(-1)->setDay($this->_dia_fecha_apuracao+1);
                    $ultimoDiaOcorrencia->setDay($this->_dia_fecha_apuracao);

                    $calendario->carregaDiasUteis($this->_nrCalendario, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                    $afastamento = $this->_verificaAfastamentos(
                        $this->_vinculo, $this->_situacao_funcional, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia
                    );
                    $gozo_ferias = $this->_verificaFerias($this->_vinculo, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                    $this->_detalhaTrabalho(
                        $afastamento, $gozo_ferias, $calendario->getVetDiasUteis(), $diasUteis, $diasDsr, $diasNormais, $diasAfastados,
                        $diasFerias
                    );
                    $this->_dias_rsr=$diasDsr;
                    $this->_dias_uteis=$diasUteis;
                    $this->_geraEventoCalculoReflexo(
                        $itens_calculo, $nrEvento, $this->_mes_competencia, $base, $this->_dias_rsr, $this->_dias_uteis
                    );

                }

            }

        } else {
            //BORBA 29/05/2013 - só o if - Verificar se deve comparar o nritemcalcfolha ou nrcalculofolha
            if ($this->_itens_calculo_principal->getNrcalculofolha() == $itens_calculo->getNrcalculofolha()) {
                // jorgefonseca 13/11/2013 Modificado para gerar evento para varias bases se lancado com varias datas de ocorrencia
                $base = $itens_calculo->calculaIncidencias($nrIncidencia, $this->_mes_competencia, $this->_eventom, true);
                if (is_array($base)) {
                    $calendario = new CalendarioLogic($this->_nrorg, $this->_nrOrgPadrao);
                    foreach ($base as $dataTimestamp => $valorBase) {

                        $diasUteis = 0;
                        $diasDsr = 0;
                        $diasNormais = 0;
                        $diasAfastados = 0;
                        $diasFerias = 0;

                        $dtOcorrencia = new \TkDateTime();
                        $dtOcorrencia->setTimestamp($dataTimestamp);

                        $primeiroDiaOcorrencia = clone $dtOcorrencia;
                        $ultimoDiaOcorrencia = clone $dtOcorrencia;

                        $primeiroDiaOcorrencia->setDay(1);
                        $ultimoDiaOcorrencia->addMonth(1)->subDay(1);

                        $calendario->carregaDiasUteis($this->_nrCalendario, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                        $afastamento = $this->_verificaAfastamentos(
                            $this->_vinculo, $this->_situacao_funcional, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia
                        );
                        $gozo_ferias = $this->_verificaFerias($this->_vinculo, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                        $this->_detalhaTrabalho(
                            $afastamento, $gozo_ferias, $calendario->getVetDiasUteis(), $diasUteis, $diasDsr, $diasNormais, $diasAfastados,
                            $diasFerias
                        );
                        /*BORBA 21/11/2013 - Quando for mes de competencia utilizar $this->_dias_rsr e $this->_dias_uteis,
                        pois em caso de rescisao nem sempre se utiliza calendario cheio.*/

                        if ($dtOcorrencia == $this->_mes_competencia) {
                            $diasDsr = $this->_dias_rsr;
                            $diasUteis = $this->_dias_uteis;
                        }
                        /*BORBA 31/10/2014 aumenta em um DSR caso a pessoa seja demitida na sexta SOLICITAÇÃO 152544*/
                        //tk_warning($this->_vinculo->getDtrescisaovinc());

                        /*BORBA 24/07/2014 - Em caso de existir falta e perda de dsr para a competencia em questão,
                        retorna a referencia para deduzir dos dias uteis. Usado somente para faltas e perda dentro do mes corrente*/
                        /*CONFORME ATIVIDADE: PA-GRUPO-TEK - Falta descontar DSR para Cálculo do Reflexo*/
                        $idfaltasreflexo = $escala->historico->getIdfaltasreflexo();
                        if ($dtOcorrencia == $this->_mes_competencia && $idfaltasreflexo==GpeescalatrabhEntity::IDFALTASREFLEXO_SIM){

                            $evento_falta = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_FALTAS_DIA);
                            $ref_falta=$this->_itens_calculo_principal->retornaReferenciaPorEvento($evento_falta, $dtOcorrencia);

                            $evento_dsr = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA);
                            $ref_dsr=$this->_itens_calculo_principal->retornaReferenciaPorEvento($evento_dsr, $dtOcorrencia);

                            //Impede que $diasUteis fique negativo
                            if($ref_falta>$diasUteis){
                                $diasUteis=0;
                            }else{
                                $diasUteis=$diasUteis-$ref_falta;
                            }
                            //Impede que $diasDsr fique negativo
                            if($ref_dsr>$diasDsr){
                                $diasDsr=0;
                            }else{
                                $diasDsr=$diasDsr-$ref_dsr;
                            }
                            //tk_warning('  nr->'.$escala->historico->getNrescalatrabm().'   PERD>'.$ref_dsr.'   FALTA->'.$ref_falta.'    UTEIS->'.$diasUteis.'    DSR->'.$diasDsr.'    NORM->'.$diasNormais.'    AFAST->'.$diasAfastados.'    FERIAS->'.$diasFerias);
                        }

                        /* BORBA 08/10/2014 Alguns vinculos apresentaram erros gerando dsr acima de 10 dias, enquanto a causa for
                        desconhecida ou o erro não for reproduzido será feito um teste limitador antes de gerar o evento*/
                        if(($diasDsr) > 7 ){
                            $msg=TkDateTime::DATETIME." - ".$nrEvento.'.<br />'."\n";
                            $msg.= "Referencia de ".$diasDsr." DSR para o vínculo: ".$this->_vinculo->getNrvinculom()." - ".$this->_vinculo->getNmvinculom().'.<br />'."\n";
                            $msg.="DSR: ".$diasDsr." - UTEIS: ".$diasUteis." - NORMAIS: ".$diasNormais." - FERIAS: ".$diasFerias." - AFAST: ".$diasAfastados.'.<br />'."\n";
                            $msg.="DtOcorrencia: ".$dtOcorrencia."  - DtIni: ".$primeiroDiaOcorrencia."   - DtFim: ".$ultimoDiaOcorrencia.'.<br />'."\n";
                            $msg.="Atributo DSR: ".$this->_dias_rsr."  - Atributo UTEIS: ".$this->_dias_uteis.'.<br />'."\n";
                            $msg.="Calendário: ".$this->_nrCalendario.'.<br />'."\n";
                            $msg.="---------------------------------------------------------------------------------------------------"."\n"."\n";
                            file_put_contents('logdsr.txt',$msg,FILE_APPEND);
                        }else {
                            $this->_geraEventoCalculoReflexo(
                                $itens_calculo, $nrEvento, $dtOcorrencia, $valorBase, $diasDsr, $diasUteis
                            );
                        }

                    }
                } else {
                    $this->_geraEventoCalculoReflexo(
                        $itens_calculo, $nrEvento, $this->_mes_competencia, $base, $this->_dias_rsr, $this->_dias_uteis
                    );

                }

            }
        }

    }

    private function _geraEventoCalculoReflexo(\FpaitecalcfolhaEntity $itens_calculo, $nrEvento,
                                               \TkDateTime $dataOcorrencia, $valorBase, $diasDsr, $diasUteis)
    {
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nrEvento, $this->_eventom, $this->_nrorg);
        $valor      = ($valorBase / $diasUteis) * $diasDsr;
        $itens_calculo->geraEvento($evento_aux, $dataOcorrencia, (float)$valor, $diasDsr, 1);
    }

    /**
     * Calculo do Vale Transporte.
     *
     * @return void
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG
     */
    private function _calculaValeTransporte(){
        /*@todo rever parametrização tipo de vínculo */ //BORBA 21/03/2013
        if($this->_vinculo->historico->getIdremuneracao()!= GpeVinculohEntity::IDREMUNERACAO_ESTAGIO){
            ValeTransporte::calcula(
                $this->_salario, $this->_mes_competencia, $this->_itens_calculo_principal, $this->_assoc_eventos,
                $this->_eventom, $this->_nrorg
            );
        }
    }


    /**
     * Calcula os totais de proventos, descontos e liquido.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels - 21/11/2011 - Implementacao do arredondamento do liquido.
     */
    private function _calculaTotais(){


        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_ANTES_TOTALIZACOES, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        $valor_preservar = $this->preservarValores();


        $totais = $this->_itens_calculo_principal->retornaTotais($this->_eventom);
        $total_proventos = $totais[FpaeventomEntity::IDTIPOEVENTO_PROVENTO];
        $total_desconto = $totais[FpaeventomEntity::IDTIPOEVENTO_DESCONTO];
        $liquido = $total_proventos - $total_desconto;

        // Validacao de liquido negativo.
        if ($liquido - $valor_preservar < 0) {
            // @todo - Tratar prioridade de estorno.
            $valor_complemento = abs($liquido - $valor_preservar);

            $evento_liquido_negativo = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_COMPLEMENTO_SAL_CR, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento(
                $evento_liquido_negativo, null, $valor_complemento, 0, 2
            );

            $totais = $this->_itens_calculo_principal->retornaTotais($this->_eventom);
            $total_proventos = $totais[FpaeventomEntity::IDTIPOEVENTO_PROVENTO];
            $total_desconto = $totais[FpaeventomEntity::IDTIPOEVENTO_DESCONTO];
            /** @autor jorgefonseca Inverte o sinal pois a funcao bcsub espera escala positiva para manter os numeros decimais */
            $liquido = bcsub($total_proventos, $total_desconto, 10);
        }


        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_LIQUIDO_NEGATIVO, $this->_nr_tipo_calculo,$this->_itens_calculo_principal
        );

        // Arredondamento do liquido.
        if ($this->_idTipoArredonda !== false) {
            //BORBA 31/03/2014 - Nao arredonda na rescisao.
            if (($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_RESCISAO)
                && ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            ) {
                $valorAux = Valor::arredonda(
                    $liquido, $this->_idTipoArredonda, $this->_nrDigitoArredonda, $this->_nrLimiteArredonda
                );
                if ($valorAux > $liquido) {
                    // Calcula valor de arredondamento.
                    $valorArredondamento = $valorAux - $liquido;
                    if ($valorArredondamento > 0) {
                        $evento_arredondamento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_ARREDONDAM_SAL_CR, $this->_eventom, $this->_nrorg
                        );

                        // A quantidade de ocorrencia sera igual a 2 para o fechamento jogar o evento para o mes seguinte.
                        $this->_itens_calculo_principal->geraEvento(
                            $evento_arredondamento, null, $valorArredondamento, 0, 2
                        );

                        unset($evento_arredondamento);

                        $totais = $this->_itens_calculo_principal->retornaTotais($this->_eventom);
                        $total_proventos = $totais[FpaeventomEntity::IDTIPOEVENTO_PROVENTO];
                        $total_desconto = $totais[FpaeventomEntity::IDTIPOEVENTO_DESCONTO];
                        $liquido = $total_proventos - $total_desconto;
                    }
                }
            }
        }

        $evento_provento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PROVENTOS, $this->_eventom, $this->_nrorg
        );
        $evento_desconto = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_DESCONTOS, $this->_eventom, $this->_nrorg
        );

        // Verifica Calculo Parcial.
        if ($this->_parcial === true) {
            $evento_liquido = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_LIQUIDO_PARCIAL, $this->_eventom, $this->_nrorg
            );
        } else {//BORBA 27/09/2013 Em caso de rescisão o liquido será gravado no evento 3050
            if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
                || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            ) {
                $evento_liquido = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_LIQUIDO_RESCISAO, $this->_eventom, $this->_nrorg
                );
            } else{
                $evento_liquido = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_LIQUIDO, $this->_eventom, $this->_nrorg
                );
            }
        }

        /* $this->_itens_calculo_principal->geraEvento(
         *     $evento_provento, $this->_mes_competencia, $total_proventos, 0, 1
         * );
         */
        $this->_itens_calculo_principal->geraEvento($evento_provento, null, (float)$total_proventos, 0, 1);
        /* $this->_itens_calculo_principal->geraEvento(
         *     $evento_desconto, $this->_mes_competencia, $total_desconto, 0, 1
         * );
         */
        $this->_itens_calculo_principal->geraEvento($evento_desconto, null, (float)$total_desconto, 0, 1);

        /* $this->_itens_calculo_principal->geraEvento($evento_liquido, $this->_mes_competencia, $liquido, 0, 1); */
        $this->_itens_calculo_principal->geraEvento($evento_liquido, null, (float)$liquido, 0, 1);

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FERIAS) {
            $this->_calculaTotaisFerias($liquido);
        }
    }


    /**
     * Calcula o Sub Totais de Ferias para demonstracao na folha mensal.
     *
     * @param float $liquido Valor do liquido.
     *
     * @return void
     *
     * @author alessandrobartels 22/07/2011
     */
    private function _calculaTotaisFerias($liquido){

        /* Calculo do subtotal 1a parte */
        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_SUBTOTAL_FERIAS, $this->_mes_competencia, $this->_eventom
        );
        $this->_atribuiValor($this->_itens_calculo_principal, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, $base);

        /* Calculo do subtotal 2a parte*/
        $base = $liquido - $base;
        $this->_atribuiValor($this->_itens_calculo_principal, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, $base);

    }


    /**
     * Prepara cabecalho para impressao de calculo em tela.
     *
     * @param GpevinculomEntity $vinculo       Instancia de GpevinculomEntity.
     * @param Demonstrativo     $demonstrativo Instancia de Demonstrativo.
     * @param integer           $contador      Contador.
     *
     * @return Elemento
     */
    private function _preparaCabecalho(GpevinculomEntity $vinculo, Demonstrativo $demonstrativo, $contador){
        $pessoa = $this->_pessoa->retornaPessoaAtual($vinculo->getNrpessoa());
        $nmPessoa = $pessoa->historico->getNmpessoa();

        /* Teste data admissao do vinculo. */
        $dtAdmissao = explode(' ', $vinculo->getDtadmissaovinc());
        $dtAdmissao = $dtAdmissao[0];

        $dataAux = new TkDateTime($dtAdmissao, TkDateTime::FORMAT_DATE);
        $dataAux->setDay(1);
        if ($dataAux->equals($this->_mes_competencia) === true) {
            $dataAux->set($dtAdmissao);
            $dtAdmissao = $dataAux->toString(TkDateTime::FORMAT_DATE);
        } else {
            // $dtAdmissao = null;
        }

        /* Teste data rescisao do vinculo. */
        $dtRescisao = $vinculo->getDtrescisaovinc();
        if (empty($dtRescisao) !== true) {
            $dataAux = new TkDateTime($dtRescisao, TkDateTime::FORMAT_DATE);
            $dataAux->setDay(1);
            if ($dataAux->equals($this->_mes_competencia) === true) {
                $dataAux->set($dtRescisao);
                $dtRescisao = $dataAux->toString(TkDateTime::FORMAT_DATE);
            } else {
                $dtRescisao = null;
            }
        } else {
            $dtRescisao = null;
        }

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FERIAS) {
            /* Teste periodo de gozo de ferias do vinculo. */
            $dtIniGozo = $this->_gozo_ferias->getDtInicioGozo()->toString(TkDateTime::FORMAT_DATE);
            if (empty($dtIniGozo) !== true) {
                $dataAux = new TkDateTime($dtIniGozo, TkDateTime::FORMAT_DATE);
                $dataAux->setDay(1);
                if ($dataAux->equals($this->_mes_competencia) === true) {
                    $periodoGozo = $dtIniGozo;
                    $periodoGozo .= '  -  '.$this->_gozo_ferias->getDtFimGozo()->toString(TkDateTime::FORMAT_DATE);
                } else {
                    $periodoGozo = null;
                }
            } else {
                $periodoGozo = null;
            }
        }

        // Verificar periodo de afastamento

        unset($dataAux);
        $dias_uteis_dsr = ' Dias úteis: '.$this->_dias_uteis.' -  DSR: '.$this->_dias_rsr;

        $demonstrativo->montaCabecalho(
            $vinculo->getCdmatricula(), $vinculo->getNrvinculom(), $nmPessoa, $this->_salario, $dtAdmissao, $dtRescisao,
            $periodoGozo,$dias_uteis_dsr
        );

        $elementoDemonstrativo = $demonstrativo->addElemento(null, $contador, $nmPessoa);

        return $elementoDemonstrativo;
    }


    /**
     * Calcula os eventos da incidencia e gera novo evento determinado no item grupo
     *
     * @return void
     *
     * @author alessandrobartels - 28/06/2012
     */
    private function _calculaGrupoIncidencias(){
        $itensGrupo = $this->_itemGrupo->getItems();

        // Loop nos itens de grupo
        foreach($itensGrupo as $itemGrupo){

            // Para cada item calcula incidencia
            $nrTipoIncidencia = $itemGrupo->getNrtipoincide();
            $valor = $this->_itens_calculo_principal->calculaIncidencias($nrTipoIncidencia, $this->_mes_competencia, $this->_eventom);

            // Realizar a operacao  para cada opcao(PERCENTUAL, MULTIPLICADOR, DIVISOR) com o valor calculado na incidencia;
            $valor = $itemGrupo->calculaValor($valor);

            // Transferido para a classe de Grupo de Item
            /*$percentual = $itemGrupo->getVrpercent();
            if ($percentual !== 100 && empty($percentual) === false) {
                $valor = ($valor * $percentual) / 100;
            }

            $multiplicador = $itemGrupo->getVrmultiplic();
            if ($multiplicador !== 1 && empty($multiplicador) === false) {
                $valor = $valor * $multiplicador;
            }

            $divisor = $itemGrupo->getVrdivide();
            if ($divisor !== 1 && empty($divisor) === false) {
                $valor = $valor / $divisor;
            }*/


            // Pegar a referencia conforme o campo IDREFGERAR;
            $referencia = $itemGrupo->determinaReferencia();

            // Transferido para a classe de Grupo de Item
            /* switch($itemGrupo->getIdrefgerar()){
                 case FpaGrpitemEntity::IDREFGERAR_PERCENTUAL:
                     $referencia = $percentual;
                     break;

                 case FpaGrpitemEntity::IDREFGERAR_MULTIPLICADOR:
                     $referencia = $multiplicador;
                     break;

                 case FpaGrpitemEntity::IDREFGERAR_DIVISOR:
                     $referencia = $divisor;
                     break;

                 case FpaGrpitemEntity::IDREFGERAR_NENHUM:
                     $referencia = $itemGrupo->getVrreffixo();
                     break;
             }*/

            // Zera o valor da referencia caso o campo chegue vazio.
            if (empty($referencia) === true){
                $referencia = 0;
            }

            // Se IDRETVALOR for N = valor do evento gerado sera 0; IDRETVALOR (Consolida Valor)
            if ($itemGrupo->getIdretvalor() === FpaGrpitemEntity::IDRETVALOR_NAO) {
                $valor = 0;
            }

            // Se campo IDRETREFERENCIA for S, consolidar o valor das referencias referencias;
            if ($itemGrupo->getIdretreferencia() === FpaGrpitemEntity::IDRETREFERENCIA_SIM) {
                $referencia = $this->_itens_calculo_principal->getTotalReferencias();
            }

            // Gerar novo evento com valor, referencia;
            $evento = $this->_eventom->retornaEvento($itemGrupo->getNreventom());
            $this->_itens_calculo_principal->geraEvento($evento, $this->_mes_competencia, $valor, $referencia, 1);
        }
    }


    private function _geraEventoRelacionado(){

        // Inicializa o array
        $this->_eventoRelacionado = array();

        // Prepara eventos associados na Ocupacao
        $this->_carregaEventoRelacionadoOcupacao();         // BORBA 06/03/2013

        // Prepara eventos associados na Estrutura/Sindicato
        $this->_carregaEventoRelacionadoEstrutura();    // BORBA 07/03/2013

        // Prepara eventos associados no Vinculo
        $this->_carregaEventoRelacionadoVinculo();

        // Percorre lista de eventos fixos
        foreach($this->_eventoRelacionado as $item){

            $valor = 0;
            $referencia= 0;

            $descricaoReferencia = $this->_valores_referencia->getDescricaoReferencia($item->getNrvalorreferenciam());

            // Verifica se a referencia vem da tabela ValorReferencia ou se eh passada fixa no item
            if ($item->getIdretreferencia() === FpaVinceventoEntity::IDRETREFERENCIA_SIM){
                if($descricaoReferencia){
                    $referencia = $this->_valores_referencia->getReferencia($descricaoReferencia);
                }
            } else {
                if ($item->getVrreffixo() != 0){
                    $referencia = $item->getVrreffixo();
                } else {
                    // Pegar a referencia conforme o campo IDREFGERAR;
                    $referencia = $item->determinaReferencia();
                }
            }

            if ($item->getVreventofixo() != 0){
                // Valor do evento passado fixo
                $valor = $item->getVreventofixo();

            } else {
                if($descricaoReferencia){
                    // Retorna o valor da tabela ValorReferencia
                    $valor = $this->_valores_referencia->getValorReferencia($descricaoReferencia);
                    // Realizar a operacao  para cada opcao (PERCENTUAL, MULTIPLICADOR, DIVISOR) com o valor;

                    $percentual = $item->getVrpercent();
                    if ($percentual !== 100 && empty($percentual) === false) {
                        $valor = ($valor * $percentual) / 100;
                    }

                    $multiplicador = $item->getVrmultiplic();
                    if ($multiplicador !== 1 && empty($multiplicador) === false) {
                        $valor = $valor * $multiplicador;
                    }

                    $divisor = $item->getVrdivide();
                    if ($divisor !== 1 && empty($divisor) === false) {
                        $valor = $valor / $divisor;
                    }

                    /*try {
                        tk_warning(get_class($item));
                        $valor = $item->calculaValor($valor);
                    } catch (\Exception $e) {
                        tk_warning('teste');
                    }*/

                }else{
                    if ($item->getVrpercent() != 0){
                        //BORBA 02/10/2013
                        $valor=$this->_salario * $item->getVrpercent()/100;
                    }
                }
            }

            if (empty($referencia) === true){
                $referencia = 0;
            }
            //10/07/2014
            //Limita o valor entre o piso e o teto
            if($valor>$item->getVrtetoevento()){
                $valor=$item->getVrtetoevento();
            }elseif($valor<$item->getVrpisoevento()){
                $valor=$item->getVrpisoevento();
            }

            // Gerar novo evento no itemCalculo com valor, referencia;
            $evento = $this->_eventom->retornaEvento($item->getNreventom());
            $this->_itens_calculo_principal->geraEvento($evento, $this->_mes_competencia, $valor, $referencia, 1);
        }

    }


    private function _carregaEventoRelacionadoVinculo(){

        $lista = $this->_vincEvento->retornaAssociacoesVinculoEvento(
            $this->_nrorg, $this->_vinculo->getNrvinculom(), $this->_mes_competencia
        );
        foreach($lista as $item){
            // BORBA 07/03/2013 - Validacao para carregar o evento conforme movimento PRINCIPAL / AUXILIAR - PERIODICIDADEMES - DTINIVIGENCIA - DTFIMVIGENCIA
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(),$item->getPeriodicidademes(),
                $item->getDtinivigencia(),$item->getDtfimvigencia()); //BORBA 06/03/2013
            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
            }
        }

    }


    private function _carregaEventoRelacionadoOcupacao(){

        $alteracaoOcupacao = $this->_alteracaoOcupacao->retornaUltimaAlteracaoOcupacaoVinculo(
            $this->_nrorg, $this->_mes_competencia, $this->_vinculo->getNrvinculom()

        );

        if (is_object($alteracaoOcupacao) === true){

            $nrOcupacao = $alteracaoOcupacao->getNrocupacaom();
            $lista = $this->_ocupacaoEvento->retornaAssociacoesOcupacaoEvento($this->_nrorg, $nrOcupacao);

            foreach($lista as $item){
                // BORBA 07/03/2013 - Validacao para carregar o evento conforme movimento PRINCIPAL / AUXILIAR - PERIODICIDADEMES - DTINIVIGENCIA - DTFIMVIGENCIA
                $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(),$item->getPeriodicidademes(),
                    $item->getDtinivigencia(),$item->getDtfimvigencia()); //BORBA 06/03/2013

                if ($carregaEvento === true) {
                    $this->_eventoRelacionado[$item->getNreventom()] = $item;
                }
            }
        }
    }

    private function _carregaEventoRelacionadoEstrutura(){

        /*@todo verificar se retornamovimentacaovinculo é suficiente*/

        // $movEstrutura = $this->_movimentosVinculo->retornaMovimentacoesVinculo(
            // $this->_nrorg, $this->_vinculo->getNrvinculom()
        // );
        // //tk_warning($this->_nrorg.'  |  '.$this->_vinculo->getNrvinculom().' ESTRUTURA');

        // if (is_object($movEstrutura) === true) {
            // $nrEstrutura = $movEstrutura->getNrestruturam();
            // $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
            // foreach($lista as $item){
                // // BORBA 07/03/2013 - Validacao para carregar o evento conforme movimento PRINCIPAL / AUXILIAR - PERIODICIDADEMES - DTINIVIGENCIA - DTFIMVIGENCIA
                // $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(),$item->getPeriodicidademes(),
                    // $item->getDtinivigencia(),$item->getDtfimvigencia()); //BORBA 06/03/2013

                // if ($carregaEvento === true) {
                    // $this->_eventoRelacionado[$item->getNreventom()] = $item;
                // }
            // }
        // }
		
        //Marcelo 03-02-2015 Evento relacionado respeitar a estrutura legal contida no histórico do vínculo
        $nrEstrutura = $this->_vinculo->historico->getNrestrutlegal();
        $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
        foreach($lista as $item){
            // BORBA 07/03/2013 - Validacao para carregar o evento conforme movimento PRINCIPAL / AUXILIAR - PERIODICIDADEMES - DTINIVIGENCIA - DTFIMVIGENCIA
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(),$item->getPeriodicidademes(),
                $item->getDtinivigencia(),$item->getDtfimvigencia()); //BORBA 06/03/2013
            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
            }
        }

        //Marcelo 03-02-2015 Evento relacionado respeitar a estrutura gerencial contida no histórico do vínculo
        $nrEstrutura = $this->_vinculo->historico->getNrestrutgeren();
        $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
        foreach($lista as $item){
            // BORBA 07/03/2013 - Validacao para carregar o evento conforme movimento PRINCIPAL / AUXILIAR - PERIODICIDADEMES - DTINIVIGENCIA - DTFIMVIGENCIA
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(),$item->getPeriodicidademes(),
                $item->getDtinivigencia(),$item->getDtfimvigencia()); //BORBA 06/03/2013
            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
            }
        }		
		
        /** @todo fazer merge das estruts do vinculoh com as movimentações */
        $nrEstrutura = $this->_vinculo->historico->getNrestrutsind();
        $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
        foreach($lista as $item){
            // BORBA 07/03/2013 - Validacao para carregar o evento conforme movimento PRINCIPAL / AUXILIAR - PERIODICIDADEMES - DTINIVIGENCIA - DTFIMVIGENCIA
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(),$item->getPeriodicidademes(),
                $item->getDtinivigencia(),$item->getDtfimvigencia()); //BORBA 06/03/2013

            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
            }
        }
    }


    /**
     * Preserva os valores dos eventos que devem ser preservados para complemento de líquido
     * Ex: o evento salário família é preservado.
     * Parametrização: deverá ser inserido um valor 999 no campo Prioridade de estorno no registro do evento
     * @return float|int Valor somado dos eventos que devem ser preservados no complemento de líquido
     * @author Leandro Afonso,  BRUNOBORBA
     */
    public function preservarValores(){
        $valor = 0;
        //lista de eventos carregada em FpaeventomEntity no inicializa lista
        foreach( $this->_eventom->preservar as $evento_preserv ){
            $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($evento_preserv, $this->_eventom, $this->_nrorg);
            $itens = $this->_itens_calculo_principal->retornaItens($evento_aux);
            foreach ($itens as $indice) {
                $valor += $this->_itens_calculo_principal->retornaValor($indice);
            }
        }
        return $valor;
    }

    /**
     * Valida se o evento fixo sera carregado conforme parametro IDTIPOMOVIMENTO (Fpavincevento, Fpaocupaevento)
     *
     * @param string $idTipoMovimento
     * @param string $periodicidadeMes
     * @param string $dtIniVigencia
     * @param string $dtFimVigencia
     *
     * @return bool
     *
     * @author alessandrobartels 06/05/12
     * @author brunoborba 09/10/2013
     */
    private function _validaCarregamentoEventoRelacionado($idTipoMovimento,$periodicidadeMes,$dtIniVigencia,$dtFimVigencia = null){

        // BORBA 09/10/2013 Verifica se a competencia está dentro da vigencia do item de evento relacionado, caso contrário ja retorna falso
        if($this->_mes_competencia->isEarlier($dtIniVigencia)){
            $carregaEvento = false;
            return $carregaEvento;
        }elseif($dtFimVigencia != null){
            if($this->_mes_competencia->isLater($dtFimVigencia)){
                $carregaEvento = false;
                return $carregaEvento;
            }
        }

        switch ($idTipoMovimento){
            case FpaVinceventoEntity::IDTIPOMOVIMENTO_PRINCIPAL:
                if (in_array($this->_nr_tipo_calculo, $this->_movimentoPrincipal) === true){
                    // Inclusão da validação da string periodicidademes verificando na posição referente ao mês - 1 se o valor é S ou N BORBA 06/03/2013
                    if ($periodicidadeMes[$this->_mes_competencia_int-1]=='S'){
                        $carregaEvento = true;
                    }else {
                        $carregaEvento = false;
                    }

                }
                break;

            case FpaVinceventoEntity::IDTIPOMOVIMENTO_AUXILIAR:
                if (in_array($this->_nr_tipo_calculo, $this->_movimentoAuxiliar) === true){
                    // Inclusão da validação da string periodicidademes verificando na posição referente ao mês - 1 se o valor é S ou N BORBA 06/03/2013
                    if ($periodicidadeMes[$this->_mes_competencia_int-1]=='S'){
                        $carregaEvento = true;
                    }else {
                        $carregaEvento = false;
                    }
                }
                break;

            case FpaVinceventoEntity::IDTIPOMOVIMENTO_TODOS:
                // Inclusão da validação da string periodicidademes verificando na posição referente ao mês - 1 se o valor é S ou N BORBA 06/03/2013
                if ($periodicidadeMes[$this->_mes_competencia_int-1]=='S'){
                    $carregaEvento = true;
                }else {
                    $carregaEvento = false;
                }
                break;

            default:
                $carregaEvento = false;
        }

//        testes
//        tk_warning('string de meses'.$periodicidadeMes);
//        tk_warning('mes competencia'.$this->_mes_competencia_int);
//        tk_warning('mes ajustado pra posição'.($this->_mes_competencia_int - 1));


        return $carregaEvento;
    }


}